----------------------------------------------------------------------------------------------------
--------------------------------TIME TO MAKE THE DOUGHNUTS------------------------------------------
----------------------------------------------------------------------------------------------------
local letsdothis = CreateFrame("Frame")
letsdothis:RegisterEvent("ADDON_LOADED")

function SVRoot.cleanDefaults(src, dst)
	for k,v in pairs(dst) do
		if type(v) == "table" then
			if v ~= src[k] then
				v = nil
			else
				v = SVRoot.cleanDefaults(src[k],v)
			end
		elseif k ~= src[k] then
			k = nil
		end
	end
	return dst
end
function SVRoot.copyDefaults(src, dst, clean)
	if not src then return { } end
	if not dst then dst = { } end
	for k, v in pairs(src) do
		if type(v) == "table" then
			dst[k] = SVRoot.copyDefaults(v,dst[k],false)
		elseif type(v) ~= type(dst[k]) then
			dst[k] = v
		end
	end
	if clean == true then
		dst = SVRoot.cleanDefaults(src, dst)
	end
	return dst
end

letsdothis:SetScript("OnEvent", function(frame, event, addon)
	if addon == "A_Battle_Begins" then
		if not SVUISet then
			SVUISet = {}
		end
		if not SVUIBar then
			SVUIBar = {}
		end
		if not SVUIStat then
			SVUIStat = {}
		end
		if not SVUIAuraBars then
			SVUIAuraBars = {}
		end
		if not SVUIText then
			SVUIText = {}
		end

		SuperSet = SVRoot.copyDefaults(svUIDefaultTS,SVUISet,true)
		SuperBar = SVRoot.copyDefaults(svUIDefaultAB,SVUIBar,true)
		SuperText = SVRoot.copyDefaults(svUIDefaultTX,SVUIText,true)
		SuperStat = SVRoot.copyDefaults(svUIDefaultST,SVUIStat,true)
		letsdothis:UnregisterEvent"ADDON_LOADED"
	end
end)