SlashCmdList.REL = ReloadUI
SLASH_REL1 = "/rl"

------------------------------------------------------------------------
--	SET VARIABLES
------------------------------------------------------------------------
SVRoot = {}
SVLocal,SVMod,SVConfig,SVAuras,SVMedia,SVFonts,SVUnit,SVColors,SVAnimate,SVLock = {},{},{},{},{},{},{},{},{},{}
SVRoot.dummy = function() return end
SVRoot.myname, _ = UnitName("player")
_, SVRoot.myclass = UnitClass("player") 
SVRoot.client = GetLocale() 
SVRoot.resolution = GetCurrentResolution()
SVRoot.getscreenresolution = select(SVRoot.resolution, GetScreenResolutions())
SVRoot.version = GetAddOnMetadata("A_Hero_Dies", "Version")
SVRoot.incombat = UnitAffectingCombat("player")

------------------------------------------------------------------------
--	DECLAIRE PRE-CONFIG TABLES
------------------------------------------------------------------------
svUIDefaultTS,svUIDefaultAB,svUIDefaultST,svUIDefaultFI,svUIDefaultTX = {},{},{},{},{}
SuperSet,SuperBar,SuperStat,SuperAura,SuperText,SuperBuffet = {},{},{},{},{},{}
Quokkas_Options = {}
----------------------------------------------------------------------------------------------------------------COLOR END
---MAP START-------------------------------------------------------------------------------------------------------------
SVConfig["MungMap"] = {
	["VILLAINS"] = { [[Interface\Addons\A_Battle_Begins\Supervillain_Media\MungMaps\SUPERVILLAIN-TEXMAP-GREY]], "Map16"},
	["VILLAINS2"] = { [[Interface\Addons\A_Battle_Begins\Supervillain_Media\MungMaps\SUPERVILLAIN-TEXMAP-LIGHT]], "Map16"},
	["PROBLEM"] = { [[Interface\Addons\A_Battle_Begins\Supervillain_Media\MungMaps\PROBLEM-TEXMAP]], "Map2"},
	["ACTIONS"] = { [[Interface\Addons\A_Battle_Begins\Supervillain_Media\MungMaps\MUNG-TEXMAP1]], "Map16"},
	["BUBBLES"] = { [[Interface\Addons\A_Battle_Begins\Supervillain_Media\MungMaps\MUNG-TEXMAP2]], "Map4L"},
}
SVConfig["Map16"] = {
	[1] = { 0, 64/256, 0, 64/256 },
	[2] = { 66/256, 126/256, 2/256, 62/256 },
	[3] = { 128/256, 192/256, 0, 64/256 },
	[4] = { 192/256, 256/256, 0, 64/256 },
	[5] = { 0, 64/256, 64/256, 128/256 },
	[6] = { 64/256, 128/256, 64/256, 128/256 },
	[7] = { 128/256, 192/256, 64/256, 128/256 },
	[8] = { 192/256, 256/256, 64/256, 128/256 },
	[9] = { 0, 64/256, 128/256, 192/256 },
	[10] = { 64/256, 128/256, 128/256, 192/256 },
	[11] = { 128/256, 192/256, 128/256, 192/256 },
	[12] = { 192/256, 256/256, 128/256, 192/256 },
	[13] = { 0, 64/256, 192/256, 256/256 },
	[14] = { 64/256, 128/256, 192/256, 256/256 },
	[15] = { 128/256, 191/256, 192/256, 256/256 },
	[16] = { 192/256, 256/256, 192/256, 256/256 },
	[17] = { 128/256, 256/256, 128/256, 256/256 },     --only for focus crosshairs
}
SVConfig["Map4L"] = {
	[1] = { 0, 128/256, 0, 128/256 },
	[2] = { 128/256, 256/256, 0, 128/256 },
	[3] = { 0, 128/256, 128/256, 256/256 },
	[4] = { 128/256, 256/256, 128/256, 256/256 },
	[5] = { 128/256, 256/256, 0, 64/256 },             --target/player/pet/party portrait bg
}
SVConfig["Map2"] = {
	[1] = { 0, 256/256, 0, 128/256 },
	[2] = { 0, 256/256, 128/256, 256/256 },
}

SVConfig.NPCList = {
	--Gundrak
	["Fanged Pit Viper"] = true,
	["Crafty Snake"] = true,
 
	--Shaman Totems
	["Earth Elemental Totem"] = true,
	["Fire Elemental Totem"] = true,
	["Fire Resistance Totem"] = true,
	["Flametongue Totem"] = true,
	["Frost Resistance Totem"] = true,
	["Healing Stream Totem"] = true,
	["Magma Totem"] = true,
	["Mana Spring Totem"] = true,
	["Nature Resistance Totem"] = true,
	["Searing Totem"] = true,
	["Stoneclaw Totem"] = true,
	["Stoneskin Totem"] = true,
	["Strength of Earth Totem"] = true,
	["Windfury Totem"] = true,
	["Totem of Wrath"] = true,
	["Wrath of Air Totem"] = true,
 
	--The gayest ability in the game
	["Army of the Dead Ghoul"] = true,
 
	--Hunter Trap
	["Venomous Snake"] = true,
	["Viper"] = true,
 
	--Test
	--["Unbound Seer"] = true,
}
----------------------------------------------------------------------------------------------------------------MAP END
----------END TABLES--------------------------------------------------------------------------------------------------------