﻿
if SVRoot.myclass ~= "SHAMAN" then
	SuperBar.menu.showtotems = false
end

SlashCmdList.SVABS = function()
	local st = {
		["hovernames"] = "Hover HotKeys",
		["shownames"] = SVUICONFIG.option_actionbar_hk,
		["hovermacro"] = "Hover Macro",
		["showmacro"] = "Show Macro",
		["reverse"] = "Reverse Layout",
		["showright"] = "Show Rightbar",
		["showtotems"] = "Show Totems",
		["showgcd"] = "Show Range",
		["petright"] = SVUICONFIG.option_actionbar_petrt,
		["autobar"] = "Enable the AutoBar",
		}
	
	local abset = "ActionBar Layout Options"
	local frame = SVMod.make_settings(st,SuperBar.menu,82,230,"SUPERVILLAIN ACTIONBARS",true,abset,nil,true)
	local layouttable = {"1 X 12","2 X 12","3 X 12","3 X 12 Split","4 X 12 Split","1 X 24","2 X 24"}	
	local nickname = {"The Minimalist","Basic Villainy","Evil Artillery","The Supervillain","Sinnisterr","Line 'Em Up","MOAR BUTTONS!"}
	local helplayw = {455,455,455,455,455,910,910}
	local helplayh = {36,74,112,74,112,36,74}

	local helptexture = frame:CreateTexture(nil,"OVERLAY")
	helptexture:SetTexture(1,1,1,1)
	helptexture:SetPoint("BOTTOM",SVActionAnchor,0,0)
	helptexture:SetSize(helplayw[SuperBar.barset]*SuperSet.scaleops.abscale,helplayh[SuperBar.barset]*SuperSet.scaleops.abscale)
	helptexture:SetGradient("VERTICAL",.2,.5,1,.12,.31,.6)
	
	local helptex2 = frame:CreateTexture(nil,"OVERLAY")
	helptex2:SetTexture(1,1,1,1)
	helptex2:SetPoint("BOTTOM",SVActionAnchor,-300.5,0)
	helptex2:SetSize(120*SuperSet.scaleops.abscale,74*SuperSet.scaleops.abscale)
	helptex2:SetGradient("VERTICAL",.2,.5,1,.12,.31,.6)
	if SuperBar.barset ~= 4 then helptex2:Hide() end
	
	local helptex3 = frame:CreateTexture(nil,"OVERLAY")
	helptex3:SetTexture(1,1,1,1)
	helptex3:SetPoint("BOTTOM",SVActionAnchor,300.5,0)
	helptex3:SetSize(120*SuperSet.scaleops.abscale,74*SuperSet.scaleops.abscale)
	helptex3:SetGradient("VERTICAL",.2,.5,1,.12,.31,.6)
	if SuperBar.barset ~= 4 then helptex3:Hide() end

	local helptex4 = frame:CreateTexture(nil,"OVERLAY")
	helptex4:SetTexture(1,1,1,1)
	helptex4:SetPoint("BOTTOM",SVActionAnchor,-300.5,0)
	helptex4:SetSize(120*SuperSet.scaleops.abscale,112*SuperSet.scaleops.abscale)
	helptex4:SetGradient("VERTICAL",.2,.5,1,.12,.31,.6)
	if SuperBar.barset ~= 5 then helptex4:Hide() end
	
	local helptex5 = frame:CreateTexture(nil,"OVERLAY")
	helptex5:SetTexture(1,1,1,1)
	helptex5:SetPoint("BOTTOM",SVActionAnchor,300.5,0)
	helptex5:SetSize(120*SuperSet.scaleops.abscale,112*SuperSet.scaleops.abscale)
	helptex5:SetGradient("VERTICAL",.2,.5,1,.12,.31,.6)
	if SuperBar.barset ~= 5 then helptex5:Hide() end
	
	local laystate = frame:CreateFontString(nil,"OVERLAY")
	laystate:SetFont(SVFonts.super,24,"OUTLINE")
	laystate:SetPoint("CENTER",0,130)
	laystate:SetText(layouttable[SuperBar.barset])
	laystate:SetJustifyH("LEFT")
	laystate:SetTextColor(1,1,0.2)
	laystate:SetShadowOffset(-4,-2.5)
	laystate:SetShadowColor(1,0.2,0.1)
	
	local namestate = frame:CreateFontString(nil,"OVERLAY")
	namestate:SetFont(SVFonts.font,18,"OUTLINE")
	namestate:SetPoint("CENTER",0,105)
	namestate:SetText(nickname[SuperBar.barset])
	namestate:SetJustifyH("CENTER")
	namestate:SetShadowOffset(1,-1)
	
	local abset = function (val)
		SuperBar.barset = val
	end
	
	local swt = function(change,abc)
		local tem = (SuperBar.barset) + change
		local abc = abc or tem
		if abc == 0 then abc = 7
		elseif abc == 8 then abc = 1
		end
		if abc == 4 then
			helptexture:SetSize(helplayw[abc],helplayh[abc])
			helptex2:Show()
			helptex3:Show()
			helptex4:Hide()
			helptex5:Hide()
		elseif abc == 5 then
			helptexture:SetSize(helplayw[abc],helplayh[abc])
			helptex2:Hide()
			helptex3:Hide()
			helptex4:Show()
			helptex5:Show()
		else
			helptexture:SetSize(helplayw[abc],helplayh[abc])
			helptex2:Hide()
			helptex3:Hide()
			helptex4:Hide()
			helptex5:Hide()
		end	
		laystate:SetText(layouttable[abc])
		namestate:SetText(nickname[abc])
		abset(abc)
	end

	local crbutton = function(parent,t,change,x,y)
		local f = CreateFrame("Frame",nil,parent)
		f:SetSize(30,30)
		f:EnableMouse(true)
		local text = f:CreateFontString(nil,"OVERLAY")
		text:SetAllPoints()
		text:SetFont(SVFonts.font,24)
		text:SetText(t)
		f:SetPoint("CENTER",x,y)
		f:SetScript("OnEnter",function() text:SetTextColor(1,.3,.3) end)
		f:SetScript("OnLeave",function() text:SetTextColor(1,1,1) end)
		f:SetScript("OnMouseDown",function() swt(change) end)
	end
		
	local bleft = crbutton(frame,"<",-1,-80,105)
	local bright = crbutton(frame,">",1,80,105)
	frame:Show()
	SlashCmdList.SVABS = function() frame:Show() end
end
SLASH_SVABS1 = "/svbars"