﻿local bspt = {44,82,120,82,120,44,82}
local barspawn = bspt[SuperBar.barset]
local sizeme = SuperSet.SizeMe
local side_table = {}
local count = 0
local barval = SuperBar.barset
local bar = CreateFrame("Frame", "SVUIMainMenuBar", UIParent, "SecureHandlerStateTemplate")
bar:SetAllPoints(SVActionAnchor)
MultiBarBottomLeft:SetParent(SVActionAnchor)
MultiBarBottomRight:SetParent(SVActionAnchor)
MultiBarLeft:SetParent(bar)
MultiBarRight:SetParent(bar)

local ptbar = CreateFrame("Frame", "SVUIPetAnchor", UIParent, "SecureHandlerStateTemplate")
ptbar:SetPoint("BOTTOM", SVActionAnchor, "BOTTOM", 0, barspawn)
PetActionBarFrame:SetParent(ptbar)
ptbar:SetWidth(300)
ptbar:SetHeight(50)
ptbar:SetMovable(true)
ptbar:SetUserPlaced(true)
local panchorbg = CreateFrame("Frame","SVUIPetAnchorBack",ptbar)
	panchorbg:SetFrameLevel(0)
	panchorbg:SetFrameStrata("BACKGROUND")
	panchorbg:SetAllPoints(ptbar)
	SVMod.MentaloBG(panchorbg)
	local pmentaloframe = CreateFrame("Frame","SVUIPetAnchorMentalo",ptbar)
	pmentaloframe:SetSize(128,128)
	pmentaloframe:SetPoint("BOTTOMRIGHT",panchorbg,"TOPRIGHT")
    pmentaloframe:SetAlpha(0)
    pmentaloframe:Hide()
	local pmentalo = pmentaloframe:CreateTexture(nil,"OVERLAY")
	pmentalo:SetAllPoints(pmentaloframe)
	pmentalo:SetTexture(SVMedia.mentalo_hand)
	local panchortxt = panchorbg:CreateFontString(nil,"OVERLAY")
	panchortxt:SetFont(SVFonts.super_c, 14, "OUTLINE")
	panchortxt:SetText("Pet Bar Anchor")
	panchortxt:SetPoint("TOP",panchorbg,0,-22)
	panchorbg:SetAlpha(0)
	ptbar:SetScript("OnEnter",function()
			if pmentaloframe:IsShown() then
				panchorbg:SetBackdropColor(0.5,0.8,1,0.5)
				UIFrameFadeIn(pmentaloframe, 0.3, 0, 1)
				SVMod.MentaloPEWPEW()
			end
		end)
	ptbar:SetScript("OnLeave",function()
			if pmentaloframe:IsShown() then
				panchorbg:SetBackdropColor(0.5,0.8,1,0.15)
				UIFrameFadeOut(pmentaloframe, 0.3, 1, 0)
				SVMod.MentaloIDLE()
			end
		end)
local pbmove = false
local function petmovebutton()
	-- don't allow moving while in combat
	if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
	
	if pbmove == false then
		pbmove = true
		SVUIPetAnchorMentalo:Show()
		UIFrameFadeIn(SVUIPetAnchorBack, 0.5, 0, 1)
		print(LEVEL_UP_FEATURE)
		SVUIPetAnchor:SetFrameStrata("DIALOG")
		SVUIPetAnchor:EnableMouse(true)
		SVUIPetAnchor:RegisterForDrag("LeftButton", "RightButton")
		SVUIPetAnchor:SetScript("OnDragStart", function(self) self:StartMoving() end)
		SVUIPetAnchor:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	elseif pbmove == true then
		pbmove = false
		SVUIPetAnchor:SetFrameStrata("BACKGROUND")
		SVUIPetAnchorMentalo:Hide()
		SVUIPetAnchor:EnableMouse(false)
		UIFrameFadeOut(SVUIPetAnchorBack, 0.5, 1, 0)
		print(LOCKED)
	end
end
local function resetPB()
	SVUIPetAnchor:ClearAllPoints()
	SVUIPetAnchor:SetPoint("BOTTOM", SVActionAnchor, "BOTTOM", 0, barspawn)
end

SLASH_PETMOVEBUTTON1 = "/mpb"
SlashCmdList["PETMOVEBUTTON"] = petmovebutton

SLASH_RESETPB1 = "/rpb"
SlashCmdList["RESETPB"] = resetPB
-----------------------------------------------------------------------------
-- Shapeshift Initializations ---------
-----------------------------------------------------------------------------
local SVUIShift = CreateFrame("Frame","SVUIShiftAnchor",UIParent)
SVUIShift:SetPoint("BOTTOM", SVActionAnchor, "BOTTOM", 220, barspawn)
SVUIShift:SetWidth(100)
SVUIShift:SetHeight(48)
SVUIShift:SetMovable(true)
SVUIShift:SetUserPlaced(true)
local sanchorbg = CreateFrame("Frame","SVUIShiftAnchorBack",SVUIShift)
	sanchorbg:SetFrameLevel(0)
	sanchorbg:SetFrameStrata("BACKGROUND")
	sanchorbg:SetAllPoints(SVUIShift)
	SVMod.MentaloBG(sanchorbg)
	local smentaloframe = CreateFrame("Frame","SVUIShiftAnchorMentalo",SVUIShift)
	smentaloframe:SetSize(128,128)
	smentaloframe:SetPoint("BOTTOMRIGHT",sanchorbg,"TOPRIGHT")
    smentaloframe:SetAlpha(0)
    smentaloframe:Hide()
	local smentalo = smentaloframe:CreateTexture(nil,"OVERLAY")
	smentalo:SetAllPoints(smentaloframe)
	smentalo:SetTexture(SVMedia.mentalo_hand)
	local sanchortxt = sanchorbg:CreateFontString(nil,"OVERLAY")
	sanchortxt:SetFont(SVFonts.super_c, 14, "OUTLINE")
	sanchortxt:SetText("Shift Bar Anchor")
	sanchortxt:SetPoint("TOP",sanchorbg,0,-22)
	sanchorbg:SetAlpha(0)
	SVUIShift:SetScript("OnEnter",function()
			if smentaloframe:IsShown() then
				sanchorbg:SetBackdropColor(0.5,0.8,1,0.5)
				UIFrameFadeIn(smentaloframe, 0.3, 0, 1)
				SVMod.MentaloPEWPEW()
			end
		end)
	SVUIShift:SetScript("OnLeave",function()
			if smentaloframe:IsShown() then
				sanchorbg:SetBackdropColor(0.5,0.8,1,0.15)
				UIFrameFadeOut(smentaloframe, 0.3, 1, 0)
				SVMod.MentaloIDLE()
			end
		end)
local ssmove = false
local function showmovebutton()
	-- don't allow moving while in combat
	if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
	if ssmove == false then
		ssmove = true
		SVUIShiftAnchorMentalo:Show()
		UIFrameFadeIn(SVUIShiftAnchorBack, 0.5, 0, 1)
		SVUIShiftAnchor:SetFrameStrata("DIALOG")
		SVUIShiftAnchor:EnableMouse(true)
		print(LEVEL_UP_FEATURE)
		SVUIShiftAnchor:RegisterForDrag("LeftButton", "RightButton")
		SVUIShiftAnchor:SetScript("OnDragStart", function(self) self:StartMoving() end)
		SVUIShiftAnchor:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	elseif ssmove == true then
		ssmove = false
		SVUIShiftAnchorMentalo:Hide()
		UIFrameFadeOut(SVUIShiftAnchorBack, 0.5, 1, 0)
		SVUIShiftAnchor:SetFrameStrata("BACKGROUND")
		SVUIShiftAnchor:EnableMouse(false)
		print(LOCKED)
	end
end

local function resetSS()
	SVUIShiftAnchor:ClearAllPoints()
	SVUIShiftAnchor:SetPoint("BOTTOM", SVActionAnchor, "BOTTOM", 220, barspawn)
end

SLASH_SHOWMOVEBUTTON1 = "/mss"
SlashCmdList["SHOWMOVEBUTTON"] = showmovebutton

SLASH_RESETSS1 = "/rss"
SlashCmdList["RESETSS"] = resetSS
-----------------------------------------------------------------------------
-- Begin Resetting Bars Now ---------
-----------------------------------------------------------------------------
local resetbt = function(b)
	b:SetSize(SVMod.Scale(32)*SuperSet.scaleops.abscale, SVMod.Scale(32)*SuperSet.scaleops.abscale)
	b:SetFrameLevel(15)
	local bg = SVMod.frame(b,2,"BACKGROUND")
	bg:SetPoint("TOP",0,4)
	bg:SetPoint("BOTTOM",0,-4)
	bg:SetPoint("LEFT",-4,0)
	bg:SetPoint("RIGHT",4,0)
	
	count = count + 1
	side_table[count] = b
end

do
	local havetodo = {
		"ActionButton",
		"MultiBarBottomLeftButton",
		"MultiBarBottomRightButton",
		"MultiBarLeftButton",
		"MultiBarRightButton",
		}
		
	for i=1, #havetodo do
		for p = 1, 12 do
			resetbt(_G[havetodo[i]..p])
		end
	end
end

local Page = {
	["DRUID"] = "[bonusbar:1,nostealth] 7; [bonusbar:1,stealth] 8; [bonusbar:2] 8; [bonusbar:3] 9; [bonusbar:4] 10;",
	["WARRIOR"] = "[bonusbar:1] 7; [bonusbar:2] 8; [bonusbar:3] 9;",
	["PRIEST"] = "[bonusbar:1] 7;",
	["ROGUE"] = "[bonusbar:1] 7; [form:3] 7;",
	["DEFAULT"] = "[bonusbar:5] 11; [bar:2] 2; [bar:3] 3; [bar:4] 4; [bar:5] 5; [bar:6] 6;",
}

local function GetBar()
	local condition = Page["DEFAULT"]
	local class = SVRoot.myclass
	local page = Page[class]
	if page then
		condition = condition.." "..page
	end
	condition = condition.." 1"
	return condition
end

bar:RegisterEvent("PLAYER_LOGIN")
bar:RegisterEvent("PLAYER_ENTERING_WORLD")
bar:RegisterEvent("KNOWN_CURRENCY_TYPES_UPDATE")
bar:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
bar:RegisterEvent("BAG_UPDATE")
bar:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
bar:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_LOGIN" then
		local button,buttons
		for i = 1, NUM_ACTIONBAR_BUTTONS do
			button = _G["ActionButton"..i]
			self:SetFrameRef("ActionButton"..i, button)
		end	

		self:Execute([[
			buttons = table.new()
			for i = 1, 12 do
				table.insert(buttons, self:GetFrameRef("ActionButton"..i))
			end
		]])

		self:SetAttribute("_onstate-page", [[ 
			for i, button in ipairs(buttons) do
				button:SetAttribute("actionpage", tonumber(newstate))
			end
		]])
			
		RegisterStateDriver(self, "page", GetBar())
	elseif event == "PLAYER_ENTERING_WORLD" then
		local button
		for i = 1, 12 do
			button = _G["ActionButton"..i]
			button:SetSize(SVMod.Scale(32)*SuperSet.scaleops.abscale, SVMod.Scale(32)*SuperSet.scaleops.abscale)
			button:SetParent(SVActionAnchor)
		end
	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
		-- attempt to fix blocked glyph change after switching spec.
		LoadAddOn("Blizzard_GlyphUI")
	else
		MainMenuBar_OnEvent(self, event, ...)
	end
end)

---------------------------------------------------------------------------
-- Hide all Blizzard stuff that we don't need
---------------------------------------------------------------------------

do
	MainMenuBar:SetScale(0.00001)
	MainMenuBar:EnableMouse(false)
	VehicleMenuBar:SetScale(0.00001)
	VehicleMenuBar:EnableMouse(false)
	PetActionBarFrame:EnableMouse(false)
	ShapeshiftBarFrame:EnableMouse(false)
	
	local elements = {
		MainMenuBar, MainMenuBarArtFrame, BonusActionBarFrame, VehicleMenuBar,
		PossessBarFrame, PetActionBarFrame, ShapeshiftBarFrame,
		ShapeshiftBarLeft, ShapeshiftBarMiddle, ShapeshiftBarRight,
	}
	for _, element in pairs(elements) do
		if element:GetObjectType() == "Frame" then
			element:UnregisterAllEvents()
		end
		
		-- Because of code changes by Blizzard developer thought 4.0.6 about action bars, we must have MainMenuBar always visible. :X
		-- MultiActionBar_Update() and IsNormalActionBarState() Blizzard functions make shit thought our bars. (example: Warrior after /rl)
		-- See 4.0.6 MultiActionBars.lua for more info at line ~25.
		if element ~= MainMenuBar then
			element:Hide()
		end
		element:SetAlpha(0)
	end
	elements = nil
	
	-- fix main bar keybind not working after a talent switch. :X
	hooksecurefunc('TalentFrame_LoadUI', function()
		PlayerTalentFrame:UnregisterEvent('ACTIVE_TALENT_GROUP_CHANGED')
	end)
end

do
	local uiManagedFrames = {
		"MultiBarLeft",
		"MultiBarRight",
		"MultiBarBottomLeft",
		"MultiBarBottomRight",
		"ShapeshiftBarFrame",
		"PossessBarFrame",
		"PETACTIONBAR_YPOS",
		"MultiCastActionBarFrame",
		"MULTICASTACTIONBAR_YPOS",
		"ChatFrame1",
		"ChatFrame2",
	}
	for _, frame in pairs(uiManagedFrames) do
		UIPARENT_MANAGED_FRAME_POSITIONS[frame] = nil
	end
	uiManagedFrames = nil
end

-----------------------------
-- STYLE -
local securehandler = bar
local replace = string.gsub

local pbsize
if SuperBar.menu.petright == false then
	pbsize = SVMod.Scale(20)
else
	pbsize = SVMod.Scale(32)
end

local style = SVMod.StyleThis

local function StylePet()
	for i=1, NUM_PET_ACTION_SLOTS do
		local name = "PetActionButton"..i
		local button  = _G[name]
		local icon  = _G[name.."Icon"]
		local hilight = _G[name]:GetHighlightTexture()
		local pushed = _G[name]:GetPushedTexture()
		local check = _G[name]:GetCheckedTexture()
		SVMod.StyleThisSmall( button, icon, name, true, hilight, pushed, check, pbsize)
	end
end
local function StyleSmall()
	for i=1, NUM_SHAPESHIFT_SLOTS do
		local name = "ShapeshiftButton"..i
		local button  = _G[name]
		local icon  = _G[name.."Icon"]
		local hilight = _G[name]:GetHighlightTexture()
		local pushed = _G[name]:GetPushedTexture()
		local check = _G[name]:GetCheckedTexture()
		SVMod.StyleThisSmall( button, icon, name, false, hilight, pushed, check, SVMod.Scale(26))
	end
end

local function updatehotkey(self)
	local hotkey = _G[self:GetName() .. 'HotKey']
	local text = hotkey:GetText()
	text = replace(text, '(s%-)', 'S')
	text = replace(text, '(a%-)', 'A')
	text = replace(text, '(c%-)', 'C')
	text = replace(text, '(Mouse Button )', 'M')
	text = replace(text, '(Middle Mouse)', 'M3')
	text = replace(text, '(Средняя кнопка мыши)', 'M3')
	text = replace(text, '(Кнопка мыши )', 'M')
	text = replace(text, '(Num Pad )', 'N')
	text = replace(text, '(Page Up)', 'PU')
	text = replace(text, '(Page Down)', 'PD')
	text = replace(text, '(Spacebar)', 'SpB')
	text = replace(text, '(Insert)', 'Ins')
	text = replace(text, '(Home)', 'Hm')
	text = replace(text, '(Delete)', 'Del')
	
	if hotkey:GetText() == _G['RANGE_INDICATOR'] then
		hotkey:SetText('')
	else
		hotkey:SetFormattedText("|cffFFFFFF%s",text)
	end
end

-- rescale cooldown spiral to fix texture.
local buttonNames = { "ActionButton",  "MultiBarBottomLeftButton", "MultiBarBottomRightButton", "MultiBarLeftButton", "MultiBarRightButton", "ShapeshiftButton", "PetActionButton"}
for _, name in ipairs( buttonNames ) do
	for index = 1, 12 do
		local buttonName = name .. tostring(index)
		local button = _G[buttonName]
		local cooldown = _G[buttonName .. "Cooldown"]
 
		if ( button == nil or cooldown == nil ) then
			break
		end
		
		cooldown:ClearAllPoints()
		cooldown:SetPoint("TOPLEFT", button)
		cooldown:SetPoint("BOTTOMRIGHT", button)
	end
end

local buttons = 0
local function SetupFlyoutButton()
	for i=1, buttons do
		--prevent error if you don't have max ammount of buttons
		if _G["SpellFlyoutButton"..i] then
			local p = _G["SpellFlyoutButton"..i]
			style(p)
			if not p.bbg then
				local bg = SVMod.frame(p,5,"MEDIUM")
				bg:SetPoint("TOPLEFT",-4,4)
				bg:SetPoint("BOTTOMRIGHT",4,-4)
				p.bbg = bg
			end
		end
	end
end
SpellFlyout:HookScript("OnShow", SetupFlyoutButton)

-- Reposition flyout buttons depending on what A_Hero_Dies bar the button is parented to
local function FlyoutButtonPos(self, buttons, direction)
	for i=1, buttons do
		local parent = SpellFlyout:GetParent()
		if not _G["SpellFlyoutButton"..i] then return end
		
		if InCombatLockdown() then return end
 
		if direction == "LEFT" then
			if i == 1 then
				_G["SpellFlyoutButton"..i]:ClearAllPoints()
				_G["SpellFlyoutButton"..i]:SetPoint("RIGHT", parent, "LEFT", -6, 0)
			else
				_G["SpellFlyoutButton"..i]:ClearAllPoints()
				_G["SpellFlyoutButton"..i]:SetPoint("RIGHT", _G["SpellFlyoutButton"..i-1], "LEFT", -6, 0)
			end
		else
			if i == 1 then
				_G["SpellFlyoutButton"..i]:ClearAllPoints()
				_G["SpellFlyoutButton"..i]:SetPoint("BOTTOM", parent, "TOP", 0, 6)
			else
				_G["SpellFlyoutButton"..i]:ClearAllPoints()
				_G["SpellFlyoutButton"..i]:SetPoint("BOTTOM", _G["SpellFlyoutButton"..i-1], "TOP", 0, 6)
			end
		end
	end
end
 
--Hide the Mouseover texture and attempt to find the ammount of buttons to be skinned
local function styleflyout(self)
	self.FlyoutBorder:SetAlpha(0)
	self.FlyoutBorderShadow:SetAlpha(0)
	
	SpellFlyoutHorizontalBackground:SetAlpha(0)
	SpellFlyoutVerticalBackground:SetAlpha(0)
	SpellFlyoutBackgroundEnd:SetAlpha(0)
	
	for i=1, GetNumFlyouts() do
		local x = GetFlyoutID(i)
		local _, _, numSlots, isKnown = GetFlyoutInfo(x)
		if isKnown then
			buttons = numSlots
			break
		end
	end
	
	--Change arrow direction depending on what bar the button is on
	local arrowDistance
	if ((SpellFlyout and SpellFlyout:IsShown() and SpellFlyout:GetParent() == self) or GetMouseFocus() == self) then
			arrowDistance = 5
	else
			arrowDistance = 2
	end
	
	if (self.flyR) then
		self.FlyoutArrow:ClearAllPoints()
		self.FlyoutArrow:SetPoint("LEFT", self, "LEFT", -arrowDistance, 0)
		SetClampedTextureRotation(self.FlyoutArrow, 270)
		FlyoutButtonPos(self,buttons,"LEFT")
	elseif (self.flyT) then
		self.FlyoutArrow:ClearAllPoints()
		self.FlyoutArrow:SetPoint("TOP", self, "TOP", 0, arrowDistance)
		SetClampedTextureRotation(self.FlyoutArrow, 0)
		FlyoutButtonPos(self,buttons,"UP")	
	elseif not self:GetParent():GetParent() == "SpellBookSpellIconsFrame" then
		FlyoutButtonPos(self,buttons,"UP")
	end
end

hooksecurefunc("ActionButton_Update",style)
hooksecurefunc("ActionButton_UpdateHotkeys",updatehotkey)
hooksecurefunc("ActionButton_UpdateFlyout",styleflyout)

local function ShiftBarUpdate()
	local numForms = GetNumShapeshiftForms()
	local texture, name, isActive, isCastable
	local button, icon, cooldown
	local start, duration, enable
	for i = 1, NUM_SHAPESHIFT_SLOTS do
		button = _G["ShapeshiftButton"..i]
		icon = _G["ShapeshiftButton"..i.."Icon"]
		if i <= numForms then
			texture, name, isActive, isCastable = GetShapeshiftFormInfo(i)
			icon:SetTexture(texture)
			
			cooldown = _G["ShapeshiftButton"..i.."Cooldown"]
			if texture then
				cooldown:SetAlpha(1)
			else
				cooldown:SetAlpha(0)
			end
			
			start, duration, enable = GetShapeshiftFormCooldown(i)
			CooldownFrame_SetTimer(cooldown, start, duration, enable)
			
			if isActive then
				ShapeshiftBarFrame.lastSelected = button:GetID()
				button:SetChecked(1)
			else
				button:SetChecked(0)
			end

			if isCastable then
				icon:SetVertexColor(1.0, 1.0, 1.0)
			else
				icon:SetVertexColor(0.4, 0.4, 0.4)
			end
		end
	end
end

local function PetBarUpdate()

	local petActionButton, petActionIcon, petAutoCastableTexture, petAutoCastShine
		for i=1, NUM_PET_ACTION_SLOTS, 1 do
		local buttonName = "PetActionButton" .. i
			petActionButton = _G[buttonName]
			petActionIcon = _G[buttonName.."Icon"]
			petAutoCastableTexture = _G[buttonName.."AutoCastable"]
			petAutoCastShine = _G[buttonName.."Shine"]
		local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i)

		if not isToken then
			petActionIcon:SetTexture(texture)
			petActionButton.tooltipName = name
		else
			petActionIcon:SetTexture(_G[texture])
			petActionButton.tooltipName = _G[name]
		end
	
		petAutoCastableTexture:Hide()
		petAutoCastShine:SetScale(1.2)
		petActionButton.isToken = isToken
		petActionButton.tooltipSubtext = subtext

		if isActive and name ~= "PET_ACTION_FOLLOW" then
			petActionButton:SetChecked(1)
			if IsPetAttackAction(i) then
				PetActionButton_StartFlash(petActionButton)
			end
		else
			petActionButton:SetChecked(0)
			if IsPetAttackAction(i) then
				PetActionButton_StopFlash(petActionButton)
			end
		end

		if autoCastEnabled then
			AutoCastShine_AutoCastStart(petAutoCastShine)
		else
			AutoCastShine_AutoCastStop(petAutoCastShine)
		end

		if texture then
			if GetPetActionSlotUsable(i) then
				SetDesaturation(petActionIcon, nil)
			else
				SetDesaturation(petActionIcon, 1)
			end
			if not petActionButton.bg then
				petActionButton.bg = SVMod.frame(petActionButton,0,"MEDIUM")
				petActionButton.bg:SetPoint("TOP",0,4)
				petActionButton.bg:SetPoint("BOTTOM",0,-4)
				petActionButton.bg:SetPoint("LEFT",-4,0)
				petActionButton.bg:SetPoint("RIGHT",4,0)
			end
			petActionIcon:Show()
		else
			petActionIcon:Hide()
		end

		-- between level 1 and 10 on cata, we don't have any control on Pet. (I lol'ed so hard)
		-- Setting desaturation on button to true until you learn the control on class trainer.
		-- you can at least control "follow" button.
		if not PetHasActionBar() and texture and name ~= "PET_ACTION_FOLLOW" then
				PetActionButton_StopFlash(petActionButton)
				SetDesaturation(petActionIcon, 1)
				petActionButton:SetChecked(0)
		end
		if SuperBar.showpet ~= true then
			petActionButton:Hide()
		else
			petActionButton:Show()
		end
	end
end

if SuperBar.menu.showright == true then
	local rp = SVMod.frame(UIParent,0,"BACKGROUND")
		rp:SetHeight(SVMod.Scale(465)*SuperSet.scaleops.abscale)
		rp:SetPoint("RIGHT",5,-9)
		rp:SetWidth(18)
		rp.bg:SetGradientAlpha("HORIZONTAL",.35,.35,.35,.7,.5,.5,.5,.25)
end

local reverse = SuperBar.menu.reverse
local chat

side_table[1]:ClearAllPoints()
side_table[1].flyT = true
if (barval) <= 5 then
	chat = 380
	if (reverse) and (barval == 2) then
		side_table[1]:SetPoint("BOTTOM",SVActionAnchor,"BOTTOM",SVMod.Scale(-208)*SuperSet.scaleops.abscale,SVMod.Scale(42)*SuperSet.scaleops.abscale)
	elseif (reverse) and (barval == 3) then
		side_table[1]:SetPoint("BOTTOM",SVActionAnchor,"BOTTOM",SVMod.Scale(-208)*SuperSet.scaleops.abscale,SVMod.Scale(80)*SuperSet.scaleops.abscale)
	elseif (reverse) and (barval == 4) then
		side_table[1]:SetPoint("BOTTOM",SVActionAnchor,"BOTTOM",SVMod.Scale(-208)*SuperSet.scaleops.abscale,SVMod.Scale(42)*SuperSet.scaleops.abscale)
	elseif (reverse) and (barval == 5) then
		side_table[1]:SetPoint("BOTTOM",SVActionAnchor,"BOTTOM",SVMod.Scale(-208)*SuperSet.scaleops.abscale,SVMod.Scale(80)*SuperSet.scaleops.abscale)
	else
		side_table[1]:SetPoint("BOTTOM",SVActionAnchor,"BOTTOM",SVMod.Scale(-208)*SuperSet.scaleops.abscale,SVMod.Scale(4)*SuperSet.scaleops.abscale)
	end
else
	chat = 380
	if (reverse) and (barval == 7) then
		side_table[1]:SetPoint("BOTTOM",SVActionAnchor,"BOTTOM",SVMod.Scale(-436)*SuperSet.scaleops.abscale,SVMod.Scale(42)*SuperSet.scaleops.abscale)
	else
		side_table[1]:SetPoint("BOTTOM",SVActionAnchor,"BOTTOM",SVMod.Scale(-436)*SuperSet.scaleops.abscale,SVMod.Scale(4)*SuperSet.scaleops.abscale)
	end
end

local stoped
local TOP_LEFT_A_BUTTON
local setbtpos = function(from,secondroll,thirdroll)
	for i=2, from do
		side_table[i]:ClearAllPoints()
		side_table[i]:SetPoint("LEFT",side_table[i-1],"RIGHT",6,0)
		side_table[i].flyT = true
	end
	if secondroll then
		side_table[secondroll]:ClearAllPoints()
		if reverse then
			side_table[secondroll]:SetPoint("TOP",side_table[1],"BOTTOM",0,-6)
			TOP_LEFT_A_BUTTON = side_table[1]
		else
			side_table[secondroll]:SetPoint("BOTTOM",side_table[1],"TOP",0,6)
			TOP_LEFT_A_BUTTON = secondroll
		end
	end
	if thirdroll then
		if reverse then
			if thirdroll == 19 then
				side_table[25]:ClearAllPoints()
				side_table[25]:SetPoint("RIGHT",side_table[1],"LEFT",SVMod.Scale(-100)*SuperSet.scaleops.abscale,0)
				side_table[28]:ClearAllPoints()
				side_table[28]:SetPoint("TOP",side_table[25],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				side_table[31]:ClearAllPoints()
				side_table[31]:SetPoint("LEFT",side_table[12],"RIGHT",SVMod.Scale(25)*SuperSet.scaleops.abscale,0)
				side_table[34]:ClearAllPoints()
				side_table[34]:SetPoint("TOP",side_table[31],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
			elseif thirdroll == 29 then
				side_table[25]:ClearAllPoints()
				side_table[25]:SetPoint("TOP",side_table[secondroll],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				side_table[37]:ClearAllPoints()
				side_table[37]:SetPoint("RIGHT",side_table[1],"LEFT",SVMod.Scale(-64)*SuperSet.scaleops.abscale,0)
				side_table[39]:ClearAllPoints()
				side_table[39]:SetPoint("TOP",side_table[37],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				side_table[41]:ClearAllPoints()
				side_table[41]:SetPoint("TOP",side_table[39],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				side_table[43]:ClearAllPoints()
				side_table[43]:SetPoint("LEFT",side_table[12],"RIGHT",SVMod.Scale(25)*SuperSet.scaleops.abscale,0)
				side_table[45]:ClearAllPoints()
				side_table[45]:SetPoint("TOP",side_table[43],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				side_table[47]:ClearAllPoints()
				side_table[47]:SetPoint("TOP",side_table[45],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
			else
				side_table[thirdroll]:ClearAllPoints()
				side_table[thirdroll]:SetPoint("TOP",side_table[secondroll],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
			end
			TOP_LEFT_A_BUTTON = side_table[1]
		else
			if thirdroll == 19 then
				side_table[25]:ClearAllPoints()
				side_table[25]:SetPoint("RIGHT",side_table[13],"LEFT",SVMod.Scale(-100)*SuperSet.scaleops.abscale,0)
				side_table[28]:ClearAllPoints()
				side_table[28]:SetPoint("TOP",side_table[25],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				side_table[31]:ClearAllPoints()
				side_table[31]:SetPoint("LEFT",side_table[24],"RIGHT",SVMod.Scale(25)*SuperSet.scaleops.abscale,0)
				side_table[34]:ClearAllPoints()
				side_table[34]:SetPoint("TOP",side_table[31],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				TOP_LEFT_A_BUTTON = side_table[13]
			elseif thirdroll == 29 then
				side_table[25]:ClearAllPoints()
				side_table[25]:SetPoint("BOTTOM",side_table[secondroll],"TOP",0,SVMod.Scale(6)*SuperSet.scaleops.abscale)
				side_table[37]:ClearAllPoints()
				side_table[37]:SetPoint("RIGHT",side_table[25],"LEFT",SVMod.Scale(-64)*SuperSet.scaleops.abscale,0)
				side_table[39]:ClearAllPoints()
				side_table[39]:SetPoint("TOP",side_table[37],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				side_table[41]:ClearAllPoints()
				side_table[41]:SetPoint("TOP",side_table[39],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				side_table[43]:ClearAllPoints()
				side_table[43]:SetPoint("LEFT",side_table[36],"RIGHT",SVMod.Scale(25)*SuperSet.scaleops.abscale,0)
				side_table[45]:ClearAllPoints()
				side_table[45]:SetPoint("TOP",side_table[43],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				side_table[47]:ClearAllPoints()
				side_table[47]:SetPoint("TOP",side_table[45],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
				TOP_LEFT_A_BUTTON = side_table[25]
			else
				side_table[thirdroll]:ClearAllPoints()
				side_table[thirdroll]:SetPoint("BOTTOM",side_table[secondroll],"TOP",0,SVMod.Scale(6)*SuperSet.scaleops.abscale)
				TOP_LEFT_A_BUTTON = side_table[13]
			end
		end
	end
	stoped = from
end

do 
	have1 = {12,24,36,36,48,24,48}
	have2 = {nil,13,13,13,13,nil,25}
	have3 = {nil,nil,25,19,29,nil,nil}
	setbtpos(have1[barval],have2[barval],have3[barval])
end

local checkthepet = SVRoot.Null

if stoped~= 60 then
	local rightg,k,z = {},1,1
	rightg[1] = {}
	for i=stoped+1,60 do
		side_table[i].flyR = true
		side_table[i]:ClearAllPoints()
		side_table[i]:Hide()
		if i~= stoped+1 and z~= 1 then
			side_table[i]:SetPoint("TOP",side_table[i-1],"BOTTOM",0,SVMod.Scale(-6)*SuperSet.scaleops.abscale)
		elseif z == 1 then
			side_table[i]:SetPoint("RIGHT",UIParent,SVMod.Scale(-6)*SuperSet.scaleops.abscale,SVMod.Scale(200)*SuperSet.scaleops.abscale)
		end
		rightg[k][z] = side_table[i]
		z = z+1
		if z == 13 then
			k = k + 1
			z = 1
			rightg[k] = {}
		end
	end
	
	local hideroll = function(coord)
		for i=1,12 do
			if rightg[coord][i]:IsShown() then
				rightg[coord][i].isshown = true
			else
				rightg[coord][i].isshown = false
			end
			rightg[coord][i]:Hide()
			rightg[coord][i]:SetAlpha(0)
			rightg[coord][i]:EnableMouse(false)
			rightg[coord][i]:SetScript("OnShow",function(self) if not InCombatLockdown() then self:Hide() end end)
		end
	end
	
	local showroll = function(coord)
		for i=1,12 do
			rightg[coord][i]:SetScript("OnShow",SVRoot.Null)
			if rightg[coord][i].isshown then
				rightg[coord][i]:Show()
			end
			rightg[coord][i]:SetAlpha(1)
			rightg[coord][i]:EnableMouse(true)
		end
	end
	
	local onp = false
	local bright = SVMod.frame(UIParent,2)
	bright:SetAlpha(0)
	bright:SetPoint("RIGHT",SVMod.Scale(2),SVMod.Scale(-254)*SuperSet.scaleops.abscale)
	bright:SetWidth(44)
	bright:SetHeight(28)
	bright:EnableMouse(true)
	
	bright:SetScript("OnEnter", function(self) 
		 if not onp then
			UIFrameFadeIn(self,.2,0,1) end
		 end)
	bright:SetScript("OnLeave", function(self)
			onp = false
			UIFrameFadeOut(self,.2,1,0)
		end)	
	
	local bcount = bright:CreateFontString(nil, "OVERLAY")
		bcount:SetPoint("RIGHT",bright,"LEFT",-2,0)
		bcount:SetFont(SVFonts.super,22,"OUTLINE")
		bcount:SetTextColor(0,1,0)
		bcount:SetShadowOffset(1,-1)
	
	local deadline = k - 1
	
	local fff = function()
		for i=1,deadline do
			hideroll(i)
		end
		if deadline < SuperBar.savedright then
			showroll(1)
			SuperBar.savedright = 1
			bcount:SetText(1)
		elseif SuperBar.savedright ~= 0 then
			showroll(SuperBar.savedright)
			bcount:SetText(SuperBar.savedright)
		else
			bcount:SetText("X")
		end
		checkthepet()
	end
	tinsert(SVRoot.PostApply,fff)
	
	local switch = function(change)
		local abc = SuperBar.savedright
		if abc ~= 0 then
			hideroll(abc)
		end
		abc = abc + change
		if abc > deadline then
			abc = 0
		elseif abc < 0 then
			abc = deadline
		end
		if abc == 0 then
			bcount:SetText("X")
		else
			bcount:SetText(abc)
			showroll(abc)
		end
		SuperBar.savedright = abc
		checkthepet()
	end
	
	local setrr = function(tex,unk,x,y,x1,y1,change)
		local rr = CreateFrame ("Frame",nil,bright)
			rr:SetPoint(unk,bright,x,y)
			rr:SetWidth(SVMod.Scale(18)*SuperSet.scaleops.abscale)
			rr:SetHeight(SVMod.Scale(18)*SuperSet.scaleops.abscale)
			rr:EnableMouse(true)
			
		local rrtex = rr:CreateTexture(nil, "OVERLAY")
			rrtex:SetAllPoints(rr)
			rrtex:SetTexture(tex,18,"OUTLINE")
				
		rr:SetScript("OnEnter", function()
			rrtex:SetVertexColor(1,1,0.2)
			UIFrameFadeIn(bright,0,1,1)
			UIFrameFadeOut(bright,0,1,1)
			onp = true
		end)

		rr:SetScript("OnLeave", function()
			rrtex:SetVertexColor(0,1,0)
			UIFrameFadeOut(bright,.2,1,0)
		end)
		
		rr:SetScript("OnMouseDown", function()
			if not InCombatLockdown() then
				switch(change)
			else
				print(SVRoot.combat)
			end
		end)
	end
	setrr(SVMedia.right,"TOPRIGHT",-4,-4,-4,-4,1)
	setrr(SVMedia.left,"TOPLEFT",4,-4,4,-4,-1)
else
	SuperBar.savedright = 0
end
local petshown, petshownr, petaway, petbuttonz
if SuperBar.menu.petright == false then
	petshown = {"BOTTOM",SVUIPetAnchor,"BOTTOM",SVMod.Scale(-116)*SuperSet.scaleops.abscale,SVMod.Scale(4)}
	petshownr = {"BOTTOM",SVUIPetAnchor,"BOTTOM",SVMod.Scale(-116)*SuperSet.scaleops.abscale,SVMod.Scale(4)}
	petaway = {"BOTTOM",SVUIPetAnchor,"BOTTOM",SVMod.Scale(-116)*SuperSet.scaleops.abscale,SVMod.Scale(4)}
	petbuttonz = {"LEFT", "RIGHT", SVMod.Scale(6)*SuperSet.scaleops.abscale, 0}
else
	petshown = {"TOPRIGHT",UIParent,"RIGHT",SVMod.Scale(-44)*SuperSet.scaleops.abscale,SVMod.Scale(216)*SuperSet.scaleops.abscale}
	petshownr = {"TOPRIGHT",UIParent,"RIGHT",SVMod.Scale(-6)*SuperSet.scaleops.abscale,SVMod.Scale(216)*SuperSet.scaleops.abscale}
	petaway = {"TOPRIGHT",UIParent,"RIGHT",SVMod.Scale(200)*SuperSet.scaleops.abscale,SVMod.Scale(216)*SuperSet.scaleops.abscale}
	petbuttonz = {"TOP", "BOTTOM", 0, SVMod.Scale(-6)*SuperSet.scaleops.abscale}
end

-- PetStyle and place
ptbar:RegisterEvent("PLAYER_LOGIN")
ptbar:RegisterEvent("PLAYER_CONTROL_LOST")
ptbar:RegisterEvent("PLAYER_CONTROL_GAINED")
ptbar:RegisterEvent("PLAYER_ENTERING_WORLD")
ptbar:RegisterEvent("PLAYER_FARSIGHT_FOCUS_CHANGED")
ptbar:RegisterEvent("PET_BAR_UPDATE")
ptbar:RegisterEvent("PET_BAR_UPDATE_USABLE")
ptbar:RegisterEvent("PET_BAR_UPDATE_COOLDOWN")
ptbar:RegisterEvent("PET_BAR_HIDE")
ptbar:RegisterEvent("UNIT_PET")
ptbar:RegisterEvent("UNIT_FLAGS")
ptbar:RegisterEvent("UNIT_AURA")

checkthepet = function()
	if SuperBar.menu.petright == false then
		PetActionButton1:SetPoint(unpack(petshown))
		PetBarUpdate()
	else
		if SuperBar.showpet ~= true then
			PetActionButton1:SetPoint(unpack(petaway))
		elseif SuperBar.savedright == 0 then
			PetActionButton1:SetPoint(unpack(petshownr))
		else
			PetActionButton1:SetPoint(unpack(petshown))
		end
	end
end

ptbar:SetScript("OnEvent", function(self, event, ...)
	local arg1 = ...
	if event == "PLAYER_LOGIN" then	
		local button
		for i = 1, 10 do
			button = _G["PetActionButton"..i]
			button:ClearAllPoints()
			button:SetParent(SVUIPetAnchor)
			button:SetSize(pbsize*SuperSet.scaleops.abscale,pbsize*SuperSet.scaleops.abscale)
			
			if i ~= 1 then
				button:SetPoint( petbuttonz[1],_G["PetActionButton"..(i - 1)],petbuttonz[2],petbuttonz[3],petbuttonz[4])
			end
			button:Show()
			self:SetAttribute("addchild", button)
		end
		RegisterStateDriver(self, "visibility", "[pet,novehicleui,nobonusbar:5] show; hide")
		PetActionButton_OnDragStart = SVRoot.Null
	elseif event == "PET_BAR_UPDATE" or (event == "UNIT_PET" and arg1 == "player") or event == "PLAYER_CONTROL_LOST" or event == "PLAYER_CONTROL_GAINED" or event == "PLAYER_FARSIGHT_FOCUS_CHANGED" or event == "UNIT_FLAGS" or (arg1 == "pet" and event == "UNIT_AURA") then
		PetBarUpdate()
	elseif event == "PET_BAR_UPDATE_COOLDOWN" then
		PetActionBar_UpdateCooldowns()
	else
		StylePet()
	end
end)

local pettriger = SVMod.frame(UIParent,2)
	pettriger:SetAlpha(0)
	pettriger:SetPoint("RIGHT",2,SVMod.Scale(230)*SuperSet.scaleops.abscale)
	pettriger:SetWidth(44)
	pettriger:SetHeight(24)
	pettriger:EnableMouse(true)
	pettriger:SetBackdropBorderColor(0,1,0)
local petn = pettriger:CreateFontString(nil,"OVERLAY")
	petn:SetPoint("CENTER")
	petn:SetFont(SVFonts.font,16)
	petn:SetText("pet")
	petn:SetTextColor(0.2,1,0.2)
local col = function (r,g,b,t)
	if t then
		pettriger:SetBackdropBorderColor(1,0.2,0.1)
		petn:SetTextColor(1,0.2,0.2)
	else
		pettriger:SetBackdropBorderColor(r,g,b,.5)
		petn:SetTextColor(r,g,b)
	end
	pettriger.top:SetTexture(r,g,b)
	pettriger.bottom:SetTexture(r,g,b)
	pettriger.left:SetTexture(r,g,b)
	pettriger.right:SetTexture(r,g,b)
end
	
if SuperBar.showpet == true then
	col(0.2,1,0.2)
end
	
pettriger:SetScript("OnEnter",function(self) UIFrameFadeIn(self,.2,0,1) end)
pettriger:SetScript("OnLeave",function(self) UIFrameFadeOut(self,.2,1,0) end)
pettriger:SetScript("OnMouseDown",function(self)
	if not InCombatLockdown() then
		if SuperBar.showpet == true then
			SuperBar.showpet = false
			col(1,0.5,0.5,true)
		else
			SuperBar.showpet = true
			col(0.2,1,0.2)
		end
			checkthepet()
	else
		print(SVRoot.combat)
	end
end)

-- ShiftBar position and setup--
local ssbar = CreateFrame("Frame", "SVUIShapeShift", SVUIShift, "SecureHandlerStateTemplate")
ssbar:ClearAllPoints()
ssbar:SetAllPoints(SVUIShift)

local States = {
	["DRUID"] = "show",
	["WARRIOR"] = "show",
	["PALADIN"] = "show",
	["DEATHKNIGHT"] = "show",
	["ROGUE"] = "show,",
	["PRIEST"] = "show,",
	["HUNTER"] = "show,",
}
ssbar:RegisterEvent("PLAYER_LOGIN")
ssbar:RegisterEvent("PLAYER_ENTERING_WORLD")
ssbar:RegisterEvent("UPDATE_SHAPESHIFT_FORMS")
ssbar:RegisterEvent("UPDATE_SHAPESHIFT_USABLE")
ssbar:RegisterEvent("UPDATE_SHAPESHIFT_COOLDOWN")
ssbar:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
ssbar:RegisterEvent("ACTIONBAR_PAGE_CHANGED")
ssbar:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_LOGIN" then
		local button
		for i = 1, NUM_SHAPESHIFT_SLOTS do
			button = _G["ShapeshiftButton"..i]
			button:ClearAllPoints()
			button:SetParent(self)
			if i == 1 then
				button:SetPoint("BOTTOMLEFT", SVUIShift, "BOTTOMLEFT",0, 0)
			else
				local previous = _G["ShapeshiftButton"..i-1]
				button:SetPoint("LEFT", previous, "RIGHT", SVMod.Scale(8), 0)
			end
			local _, name = GetShapeshiftFormInfo(i)
			if name then
				button:Show()
			end
		end
		RegisterStateDriver(self, "visibility", States[SVRoot.myclass] or "hide")
	elseif event == "UPDATE_SHAPESHIFT_FORMS" then
		if InCombatLockdown() then return end
		local button
		for i = 1, NUM_SHAPESHIFT_SLOTS do
			button = _G["ShapeshiftButton"..i]
			local _, name = GetShapeshiftFormInfo(i)
			if name then
				button:Show()
			else
				button:Hide()
			end
		end
		ShiftBarUpdate()
	elseif event == "PLAYER_ENTERING_WORLD" then
		StyleSmall()
	else
		ShiftBarUpdate()
	end
end)

--Vehicle Shit--
local veb = CreateFrame("BUTTON", "rABS_VehicleExitButton", UIParent, "SecureActionButtonTemplate");
	veb:SetFrameLevel(2)
	veb:SetFrameStrata("BACKGROUND")
	veb:SetWidth(SVMod.Scale(64)*SuperSet.scaleops.minimapscale)
	veb:SetHeight(SVMod.Scale(32)*SuperSet.scaleops.minimapscale)
	veb:SetPoint("BOTTOMLEFT",TOP_LEFT_A_BUTTON,"TOPLEFT",-1,6)
	veb:RegisterForClicks("AnyDown")
	veb:SetScript("OnClick", function(self) VehicleExit() end)
	veb:RegisterEvent("UNIT_ENTERING_VEHICLE")
	veb:RegisterEvent("UNIT_ENTERED_VEHICLE")
	veb:RegisterEvent("UNIT_EXITING_VEHICLE")
	veb:RegisterEvent("UNIT_EXITED_VEHICLE")
local offset = 0
	
local bg1 = SVMod.frame(UIParent)
	bg1:SetPoint("CENTER",veb,0,0)
	bg1:SetWidth(SVMod.Scale(64)*SuperSet.scaleops.minimapscale)
	bg1:SetHeight(SVMod.Scale(32)*SuperSet.scaleops.minimapscale)
	bg1:SetFrameLevel(0)
	bg1:Hide()
local vebname = bg1:CreateTexture(nil,"OVERLAY")
	vebname:SetAllPoints(bg1)
	SVMod.MapDraw(vebname,"PROBLEM",2)
	vebname:SetVertexColor(1,1,1)
	
local make_anim_in = function(self)
	self.show_in = self:CreateAnimationGroup("IN")
	self.show_in.b = self.show_in:CreateAnimation("Translation")
	self.show_in.b:SetOffset(0,-50)
	self.show_in.b:SetDuration(1)
	self.show_in.b:SetOrder(1)
	self.show_in.b:SetSmoothing("OUT")
end

local show_out = function(self)
	self.show_out = self:CreateAnimationGroup("OUT")
	self.show_out.a = self.show_out:CreateAnimation("Translation")
	self.show_out.a:SetOffset(0,-50)
	self.show_out.a:SetDuration(1)
	self.show_out.a:SetOrder(1)
	self.show_out.a:SetSmoothing("IN")
end

	show_out(bg1)
	make_anim_in(bg1)
	
	bg1.show_in:SetScript("OnFinished",function() bg1:SetPoint("CENTER",veb,0,0) end)
	bg1.show_out:SetScript("OnFinished",function() bg1:Hide() end)

	veb:SetAlpha(0)
	veb:SetScript("OnEnter",function(self) bg1:SetBackdropColor(.04,.04,.04) vebname:SetVertexColor(.1,.7,.9) end)
	veb:SetScript("OnLeave",function(self) bg1:SetBackdropColor(unpack(SVMedia.backdropcolor)) vebname:SetVertexColor(1,1,1) end)
	veb:SetScript("OnEvent", function(self,event,...)		
	local arg1 = ...;
		if(((event=="UNIT_ENTERING_VEHICLE") or (event=="UNIT_ENTERED_VEHICLE")) and arg1 == "player") then
			if not bg1.show_in:IsPlaying() then
				bg1:Show()
				bg1:SetPoint("CENTER",veb,0,offset)
				bg1.show_out:Stop()
				bg1.show_in:Play()
				UIFrameFadeIn(bg1, 1, 0, 1)
			end
		elseif(((event=="UNIT_EXITING_VEHICLE") or (event=="UNIT_EXITED_VEHICLE")) and arg1 == "player") then
			if not bg1.show_out:IsPlaying() then
				bg1.show_in:Stop()
				bg1.show_out:Play()
				UIFrameFadeOut(bg1, 1, 1, 0)
			end
		end
	end)

local correct_minmax = CreateFrame("Frame")
	correct_minmax:RegisterEvent("PLAYER_ENTERING_WORLD")
	correct_minmax:SetScript("OnEvent",function(self) 
	self:UnregisterAllEvents() 
	offset = 50/GetCVar("UIScale") 
end)
