﻿local panelW = 300
local panelH = floor(panelW*0.082)
local menuW = 324
local menuH = floor(panelW*0.082)
local slider = function (self,k,x,y)
	self.slide = self:CreateAnimationGroup("Move_In")
	self.slide.in_a = self.slide:CreateAnimation("Translation")
	self.slide.in_a:SetDuration(0)
	self.slide.in_a:SetOrder(1)
	self.slide.in_b = self.slide:CreateAnimation("Translation")
	self.slide.in_b:SetDuration(.3)
	self.slide.in_b:SetOrder(2)
	self.slide.in_b:SetSmoothing("OUT")
	self.slide_out = self:CreateAnimationGroup("Move_Out")
	self.slide_out.b = self.slide_out:CreateAnimation("Translation")
	self.slide_out.b:SetDuration(.3)
	self.slide_out.b:SetOrder(1)
	self.slide_out.b:SetSmoothing("IN")
	self.slide_out.b:SetStartDelay(5)
	self.slide.in_a:SetOffset(x,y)
	self.slide.in_b:SetOffset(-x,-y)
	self.slide_out.b:SetOffset(x,y)	
	if k then self.slide_out:SetScript("OnFinished",function() self:Hide() end) end
end
SVLock.menubar=true
local cColor = SVColors["classy"]
local myclass = SVRoot.myclass
local colorz = cColor[myclass]
local r, g, b = colorz[1], colorz[2], colorz[3]
local textShrink = function(string, i, dots)
	local bytes = string:len()
	if (bytes <= i) then
		return string
	else
		local len, pos = 0, 1
		while(pos <= bytes) do
			len = len + 1
			local c = string:byte(pos)
			if (c > 0 and c <= 127) then
				pos = pos + 1
			elseif (c >= 192 and c <= 223) then
				pos = pos + 2
			elseif (c >= 224 and c <= 239) then
				pos = pos + 3
			elseif (c >= 240 and c <= 247) then
				pos = pos + 4
			end
			if (len == i) then break end
		end

		if (len == i and pos <= bytes) then
			return string:sub(1, pos - 1)..(dots and '...' or '')
		else
			return string
		end
	end
end

-------quick locals
local function CalcTheHeight(num)
	local MMSP = 4
	local MMBS = 22
	local MMNUM = num
	local MMadd = MMBS+MMSP
	local HIGH = MMadd*MMNUM
	return HIGH
end
-------------------
local function ToggleBarMaker(f,h,t)
	f:SetPoint("RIGHT",UIParent,"RIGHT",-100,80)
	f:SetWidth(156*SuperSet.scaleops.minimapscale)
	f:SetHeight(h)
	f:SetFrameStrata("DIALOG")
	f:SetFrameLevel(24)
	local fglow = CreateFrame ("Frame",nil,f)
	fglow:SetPoint("TOPLEFT",f,"TOPLEFT",-4,2)
	fglow:SetPoint("BOTTOMRIGHT",f,"BOTTOMRIGHT",4,-2)
	fglow:SetBackdrop( {
		bgFile = SVMedia.menuglow,
		tile = true,
		edgeFile = SVMedia.glow,
		edgeSize = 3, insets = { left = 2, right = 2, top = 2, bottom = 2 }})
	fglow:SetBackdropColor(r,g,b,0.5)
	fglow:SetBackdropBorderColor(r,g,b)
	fglow:SetFrameStrata("BACKGROUND")
	fglow:SetFrameLevel(0)
	local ftxt = f:CreateFontString(nil,"OVERLAY")
	ftxt:SetFont(SVFonts.super, 16, "OUTLINE")
	ftxt:SetTextColor(1,1,0)
	ftxt:SetShadowOffset(-4,-2.5)
	ftxt:SetShadowColor(1,0.1,0)
	ftxt:SetText(t)
	ftxt:SetPoint("BOTTOMLEFT",f,"TOPLEFT",2,10)
	ftxt:SetPoint("BOTTOMRIGHT",f,"TOPRIGHT",-2,10)
	return f
end

--------MENU ----------------------------------
-- right lock bar
local lockbar = CreateFrame ("Frame",nil,UIParent)
	local LBHIGH = CalcTheHeight(3)
	ToggleBarMaker(lockbar,LBHIGH,"Anchor Toggles")
	SVAnimate.Slide(lockbar,true,300,0)
	TheLockBar = lockbar
	TheLockBar:Hide()

local togbarthree = CreateFrame ("Frame",nil,UIParent)
	local MB_HIGH = CalcTheHeight(6)
	ToggleBarMaker(togbarthree,MB_HIGH,"Menu Toggles")
	SVAnimate.Slide(togbarthree,true,300,0)
	MenuToggleBarThree = togbarthree
	MenuToggleBarThree:Hide()
	
local togbarfour = CreateFrame ("Frame",nil,UIParent)
	local miscnum
	if SuperSet.load.coolbar == true then
		miscnum = 6
	else
		miscnum = 5
	end
	local MBF_HIGH = CalcTheHeight(miscnum)
	ToggleBarMaker(togbarfour,MBF_HIGH,"Misc Toggles")
	SVAnimate.Slide(togbarfour,true,300,0)
	MenuToggleBarFour = togbarfour
	MenuToggleBarFour:Hide()
			
TheLockBar.slide:SetScript("OnFinished",function() go = true end)
TheLockBar.slide_out:SetScript("OnPlay",function() go = false end)
MenuToggleBarThree.slide:SetScript("OnFinished",function() go = true end)
MenuToggleBarThree.slide_out:SetScript("OnPlay",function() go = false end)
MenuToggleBarFour.slide:SetScript("OnFinished",function() go = true end)
MenuToggleBarFour.slide_out:SetScript("OnPlay",function() go = false end)
--------MENU BUTTONS----------------------------------
-- right lock bar button
local rinfo2 = CreateFrame("Button", "MenuToggleOne", MapBottomSlider, "SecureActionButtonTemplate")
	rinfo2:SetPoint("LEFT",MapBottomSlider)
	rinfo2:SetWidth(SVMod.Scale(40)*SuperSet.scaleops.abscale)
	rinfo2:SetHeight(SVMod.Scale(40)*SuperSet.scaleops.abscale)
	rinfo2:SetFrameStrata("MEDIUM")
	rinfo2:SetFrameLevel(4)

-- minion toggle button
local linfo2 = CreateFrame("Button", "MenuToggleTwo", MapBottomSlider, "SecureActionButtonTemplate")
	linfo2:SetPoint("LEFT",rinfo2,"RIGHT")
	linfo2:SetWidth(SVMod.Scale(40)*SuperSet.scaleops.abscale)
	linfo2:SetHeight(SVMod.Scale(40)*SuperSet.scaleops.abscale)
	linfo2:SetFrameStrata("BACKGROUND")
	linfo2:SetFrameLevel(2)

-- toggle button 3
local linfo3 = CreateFrame("Button", "MenuToggleThree", MapBottomSlider, "SecureActionButtonTemplate")
	linfo3:SetPoint("LEFT",linfo2,"RIGHT")
	linfo3:SetWidth(SVMod.Scale(40)*SuperSet.scaleops.abscale)
	linfo3:SetHeight(SVMod.Scale(40)*SuperSet.scaleops.abscale)
	linfo3:SetFrameStrata("BACKGROUND")
		
-- toggle button 4
local linfo4 = CreateFrame("Button", "MenuToggleFour", MapBottomSlider, "SecureActionButtonTemplate")
	linfo4:SetPoint("LEFT",linfo3,"RIGHT")
	linfo4:SetWidth(SVMod.Scale(40)*SuperSet.scaleops.abscale)
	linfo4:SetHeight(SVMod.Scale(40)*SuperSet.scaleops.abscale)
	linfo4:SetFrameStrata("BACKGROUND")
	linfo4:SetFrameLevel(2)
	
if SuperSet["panelops"].minimap ~= false then
	--ZONE TEXT
	local minimapzone = CreateFrame("Frame", "MinimapZone", Minimap)
	minimapzone:SetPoint("BOTTOMLEFT", MapBorder, "BOTTOMLEFT", 4,4)
	minimapzone:SetPoint("BOTTOMRIGHT", MapBorder, "BOTTOMRIGHT", -4,4)
	minimapzone:SetHeight(SVMod.Scale(32)*SuperSet.scaleops.minimapscale)
	minimapzone:SetFrameStrata("MEDIUM")

	--MEANWHILE
	local meanwhile = CreateFrame("Frame", "Meanwhile", MapBorder)
	SVMod.DeluxePanel(meanwhile, SVMod.Scale(112)*SuperSet.scaleops.minimapscale, SVMod.Scale(22)*SuperSet.scaleops.minimapscale, "TOPLEFT", MapBorder, "TOPLEFT", 2, -2)
	meanwhile:SetBackdropColor(1,1,0,0.4)
	meanwhile.bg:SetVertexColor(1,1,0,0.4)
	meanwhile:SetFrameStrata("MEDIUM")

	--CONFLICT
	local conflict = CreateFrame("Frame", "Conflict", MapBorder)
	SVMod.DeluxePanel(conflict, SVMod.Scale(112)*SuperSet.scaleops.minimapscale, SVMod.Scale(22)*SuperSet.scaleops.minimapscale, "TOPLEFT", MapBorder, "TOPLEFT", 2, -2)
	conflict:SetBackdropColor(1,1,0,0.4)
	conflict.bg:SetVertexColor(1,1,0,0.4)
	conflict:SetFrameStrata("MEDIUM")

	--A BATTLE
	local abattle = CreateFrame("Frame", "Abattle", MapBorder)
	SVMod.DeluxePanel(abattle, SVMod.Scale(112)*SuperSet.scaleops.minimapscale, SVMod.Scale(22)*SuperSet.scaleops.minimapscale, "TOPLEFT", MapBorder, "TOPLEFT", 2, -2)
	abattle:SetBackdropColor(1,1,0,0.4)
	abattle.bg:SetVertexColor(1,1,0,0.4)
	abattle:SetFrameStrata("MEDIUM")

	local StatZ = CreateFrame("Frame")
	StatZ:EnableMouse(true)

	local Text1  = MinimapZone:CreateFontString("Text1", "OVERLAY")
	Text1:SetFont(SVFonts.super_c, 14, "THINOUTLINE")
	Text1:SetHeight(SVMod.Scale(27)*SuperSet.scaleops.minimapscale)
	Text1:SetTextColor(r, g, b)
	Text1:SetShadowColor(0, 0, 0, 0.7)
	Text1:SetShadowOffset(2, -2)
	Text1:SetPoint("RIGHT", MinimapZone,0,-3)
	Text1:SetParent(MinimapZone)
	local Text2  = Meanwhile:CreateFontString(nil, "OVERLAY")
	Text2:SetFont(SVFonts.meanwhile, 14, "THINOUTLINE")
	Text2:SetHeight(SVMod.Scale(27)*SuperSet.scaleops.minimapscale)
	Text2:SetTextColor(r, g, b)
	Text2:SetShadowColor(0, 0, 0, 0.7)
	Text2:SetShadowOffset(1.25, -1.25)
	Text2:SetPoint("LEFT", Meanwhile,6,1)
	Text2:SetParent(Meanwhile)
	local Text3  = Conflict:CreateFontString(nil, "OVERLAY")
	Text3:SetFont(SVFonts.meanwhile, 14, "THINOUTLINE")
	Text3:SetHeight(SVMod.Scale(27)*SuperSet.scaleops.minimapscale)
	Text3:SetTextColor(r, g, b)
	Text3:SetShadowColor(0, 0, 0, 0.7)
	Text3:SetShadowOffset(1.25, -1.25)
	Text3:SetPoint("CENTER", Conflict)
	Text3:SetParent(Conflict)
	local Text4  = Abattle:CreateFontString(nil, "OVERLAY")
	Text4:SetFont(SVFonts.meanwhile, 14, "THINOUTLINE")
	Text4:SetHeight(SVMod.Scale(27)*SuperSet.scaleops.minimapscale)
	Text4:SetTextColor(r, g, b)
	Text4:SetShadowColor(0, 0, 0, 0.7)
	Text4:SetShadowOffset(1.25, -1.25)
	Text4:SetPoint("CENTER", Abattle)
	Text4:SetParent(Abattle)
	local int = 1

	local function Update(self)
		int = int - 10
		local pvp = GetZonePVPInfo()
		local zoneText = GetMinimapZoneText()
		if pvp == "friendly" then
			Text1:SetTextColor(0.1, 1.0, 0.1)
		elseif pvp == "sanctuary" then
			Text1:SetTextColor(0.41, 0.8, 0.94)
		elseif pvp == "arena" or pvp == "hostile" or pvp == "combat" then
			Text1:SetTextColor(1.0, 0.1, 0.1)
		elseif pvp == "contested" then
			Text1:SetTextColor(1.0, 0.7, 0.0)
		else
			Text1:SetTextColor(1.0, 1.0, 1.0)
		end
		if int < 0 then
			zoneText = textShrink(zoneText, 18, true)
			Text1:SetText(SVUICONFIG.option_other_inzone..zoneText)
			Text2:SetText(SVUICONFIG.option_other_meanwhile)
			Text3:SetText(SVUICONFIG.option_other_adungeon)
			Text4:SetText(SVUICONFIG.option_other_war)
			int = 1
		end     
	end

	StatZ:RegisterEvent("PLAYER_ENTERING_WORLD")
	StatZ:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	StatZ:RegisterEvent("ZONE_CHANGED")
	StatZ:RegisterEvent("ZONE_CHANGED_INDOORS")
	StatZ:SetScript("OnEvent",Update) 


	--MEANWHILE....
	local mwframe = CreateFrame("Frame", "MeanwhileFrame", UIParent)
	local mwState = 0
	local function OnEvent(self, event)
		if (event == "PLAYER_ENTERING_WORLD") and (mwState ~= 1) then
			inInstance, instanceType = IsInInstance()
			if inInstance and (instanceType == "pvp") then
				Abattle:Show()
				Meanwhile:Hide()
				Conflict:Hide()
			elseif inInstance and (instanceType ~= "pvp") then
				Abattle:Hide()
				Meanwhile:Hide()
				Conflict:Show()
			else
				Abattle:Hide()
				Meanwhile:Show()
				Conflict:Hide()
			end
			collectgarbage("collect")
			mwState = 1;
		elseif (event == "PLAYER_REGEN_DISABLED" and not(inInstance and (instanceType == "pvp"))) and (mwState ~= 2) then
			Abattle:Show()
			Meanwhile:Hide()
			Conflict:Hide()
			mwState = 2;
		elseif (event == "PLAYER_REGEN_ENABLED" and not(inInstance and (instanceType == "pvp"))) and (mwState ~= 3) then
			Abattle:Hide()
			Meanwhile:Show()
			Conflict:Hide()
			mwState = 3;
		end
	end
	mwframe:RegisterEvent('PLAYER_REGEN_DISABLED')
	mwframe:RegisterEvent('PLAYER_REGEN_ENABLED')
	mwframe:RegisterEvent("PLAYER_ENTERING_WORLD")
	mwframe:SetScript("OnEvent", OnEvent)
end