
local panelW = SVMod.Scale(SuperSet.chatops.chat_width)*SuperSet.scaleops.chatscale
local panelH = SVMod.Scale(28)*SuperSet.scaleops.chatscale
local cWoff
if (SuperBar.barset == 6) then
	cWoff = panelH+40
elseif (SuperBar.barset == 7) then
	cWoff = panelH+78
else
	cWoff = panelH+4
end
--------TOP/BOTTOM BARS----------------------------------
if SuperSet["panelops"].top then
	local top = SVMod.flipframe(UIParent,0,"BACKGROUND")
	top:SetHeight(25)
	top:SetPoint("TOPRIGHT",5,5)
	top:SetPoint("TOPLEFT",-5,5)
	TopBeam = top
end
if SuperSet["panelops"].bottom then
	local bottom = SVMod.frame(UIParent,0,"BACKGROUND")
	bottom:SetHeight(25)
	bottom:SetPoint("BOTTOMLEFT",-5,-5)
	bottom:SetPoint("BOTTOMRIGHT",5,-5)
	BottomBeam = bottom
end

--------CHAT ALIGNMENT BARS----------------------------------
-- left infobar
local linfo = CreateFrame ("Frame",nil,UIParent)
	linfo:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",8,4)
	linfo:SetWidth(panelW+10)
	linfo:SetHeight(panelH)
	LeftInfoBar = linfo

-- right infobar
local rinfo = CreateFrame ("Frame",nil,UIParent)
	rinfo:SetPoint("BOTTOMRIGHT",UIParent,"BOTTOMRIGHT",-8,4)
	rinfo:SetWidth(panelW+10)
	rinfo:SetHeight(panelH)
	RightInfoBar = rinfo

local a_high = SVMod.Scale(SuperSet.chatops.chat_height)*SuperSet.scaleops.chatscale
local a_wide = SVMod.Scale(SuperSet.chatops.chat_width)*SuperSet.scaleops.chatscale
local a_low = a_high*0.6
--------LEFT/RIGHT CHAT BOXES----------------------------
-- left chat
local chatone = CreateFrame("Frame","SuperLeftChat",UIParent)
	SVMod.chatframe(chatone,0,1,true,false)
	chatone:SetWidth(a_wide+16)
	chatone:SetHeight(a_low+16)
	chatone:SetPoint("BOTTOMLEFT",LeftInfoBar,"BOTTOMLEFT",3,16)

-- left chat popout
local l_infobar = CreateFrame("Frame","SuperLeftChatBar",LeftInfoBar)
	SVMod.DeluxePanel(l_infobar,(panelH*2),(panelH),"LEFT",LeftInfoBar,"LEFT",SVMod.Scale(4),0)
local linfotext = l_infobar:CreateFontString(nil,"OVERLAY")
	linfotext:SetFont(SVFonts.font, 13, "THINOUTLINE")
	linfotext:SetTextColor(1,1,1)
	linfotext:SetShadowColor(0,0,0,0.5)
	linfotext:SetShadowOffset(2, -2)
	linfotext:SetPoint("TOPLEFT",l_infobar,2,-2)
	linfotext:SetPoint("BOTTOMRIGHT",l_infobar,-2,2)
	linfotext:SetJustifyH("CENTER")
	linfotext:SetText("CHAT")
local chat_toggle = CreateFrame("Frame","FirstframeSwitch",SuperLeftChatBar)
	chat_toggle:SetFrameStrata("MEDIUM")
	chat_toggle:SetPoint("TOPLEFT",SuperLeftChatBar,2,-2)
	chat_toggle:SetPoint("BOTTOMRIGHT",SuperLeftChatBar,-2,2)
	chat_toggle:EnableMouse(true)
	chat_toggle:SetScript("OnEnter",function() 
		if chat_toggle:IsShown() then
			SVMod.re_Color(chatone,1,.7,.1,.4)
			SuperLeftChatBar:SetBackdropColor(1,0.5,0.1)
		end
	end)
	chat_toggle:SetScript("OnLeave",function()
		if chat_toggle:IsShown() then
			SVMod.re_Color(chatone,0,0,0)
			SuperLeftChatBar:SetBackdropColor(0.4,0.4,0.4)
		end
	end)	

if (Quokkas_Options.lootchat == true) then	
	-- right chat popout
	local r_infobar2 = CreateFrame("Frame","SuperDockButton2",RightInfoBar)
		SVMod.DeluxePanel(r_infobar2,(panelH*2),(panelH),"RIGHT",RightInfoBar,"RIGHT",SVMod.Scale(-4),0)

	local r_infobar3 = CreateFrame("Frame","SuperDockButton3",RightInfoBar)
		SVMod.DeluxePanel(r_infobar3,(panelH*2),(panelH),"RIGHT",SuperDockButton2,"LEFT",SVMod.Scale(-4),0)
		
	local r_infobar1 = CreateFrame("Frame","SuperDockButton1",RightInfoBar)
		SVMod.DeluxePanel(r_infobar1,(panelH*2),(panelH),"RIGHT",SuperDockButton3,"LEFT",SVMod.Scale(-4),0)
		
	for i=1, 2 do
		local d_w
		if i==1 then
			d_w = (a_low+16)
		else
			d_w = (a_low-25)
		end
		local dock = CreateFrame("Frame","SuperDock"..i,UIParent)
		SVMod.chatframe(dock,0,1,true,false)
		dock:SetWidth(a_wide+16)
		dock:SetHeight(d_w)
		dock:SetPoint("BOTTOMRIGHT",RightInfoBar,"BOTTOMRIGHT",-3,16)
		local dock_toggle = CreateFrame("Frame","SuperDockToggle"..i,SuperDockButton1)
		dock_toggle:SetFrameStrata("MEDIUM")
		dock_toggle:SetPoint("TOPLEFT",SuperDockButton1,2,-2)
		dock_toggle:SetPoint("BOTTOMRIGHT",SuperDockButton1,-2,2)
		dock_toggle:EnableMouse(true)
		local dock_text = dock_toggle:CreateFontString("SuperDockText"..i,"OVERLAY")
		dock_text:SetFont(SVFonts.font, 12, "THINOUTLINE")
		dock_text:SetTextColor(1,1,1)
		dock_text:SetShadowColor(0,0,0,0.5)
		dock_text:SetShadowOffset(2, -2)
		dock_text:SetPoint("TOPLEFT",dock_toggle,2,-2)
		dock_text:SetPoint("BOTTOMRIGHT",dock_toggle,-2,2)
		dock_text:SetJustifyH("CENTER")
		dock_text:SetText("")
		dock_toggle:SetScript("OnEnter",function()
			if dock_toggle:IsShown() then
				SVMod.re_Color(dock,1,.7,.1,.4)
				SuperDockButton1:SetBackdropColor(1,0.5,0.1)
			end
		end)
		dock_toggle:SetScript("OnLeave",function()
			if dock_toggle:IsShown() then
				SVMod.re_Color(dock,0,0,0)
				SuperDockButton1:SetBackdropColor(0.4,0.4,0.4)
			end
		end)
		local nextspot = _G["SuperDockButton"..(i+1)]
		local dock_toggle2 = CreateFrame("Frame","SuperDockSwitch"..i,nextspot)
		dock_toggle2:SetFrameStrata("MEDIUM")
		dock_toggle2:SetPoint("TOPLEFT",nextspot,2,-2)
		dock_toggle2:SetPoint("BOTTOMRIGHT",nextspot,-2,2)
		dock_toggle2:EnableMouse(true)
		local dock_text2 = dock_toggle2:CreateFontString("SuperDockSwitchText"..i,"OVERLAY")
		dock_text2:SetFont(SVFonts.font, 13, "THINOUTLINE")
		dock_text2:SetTextColor(1,1,1)
		dock_text2:SetShadowColor(0,0,0,0.5)
		dock_text2:SetShadowOffset(2, -2)
		dock_text2:SetPoint("TOPLEFT",dock_toggle2,2,-2)
		dock_text2:SetPoint("BOTTOMRIGHT",dock_toggle2,-2,2)
		dock_text2:SetJustifyH("CENTER")
		dock_text2:SetText("")
		dock_toggle2:SetScript("OnEnter",function() 
			if dock_toggle2:IsShown() then
				nextspot:SetBackdropColor(1,0.5,0.1)
			end
		end)
		dock_toggle2:SetScript("OnLeave",function()
			if dock_toggle2:IsShown() then
				nextspot:SetBackdropColor(0.4,0.4,0.4)
			end
		end)
	end

	SuperDockText1:SetText("GROW")
	SuperDockText2:SetText("GROW")
	SuperDockSwitchText1:SetText(">>")
	SuperDockSwitchText2:SetText("<<")
end
	
-----MapBorder ----------------------------------------------
local map_border = CreateFrame("Frame","MapBorder",Minimap)
	map_border:SetHeight(156*SuperSet.scaleops.minimapscale)
	map_border:SetWidth(202*SuperSet.scaleops.minimapscale)
	map_border:SetFrameStrata("BACKGROUND")
	map_border:SetFrameLevel(1)
	map_border:SetPoint("CENTER", Minimap, "CENTER", 0, 0)	
	map_border:SetBackdrop({
		bgFile = SVMedia.bar,
		edgeFile = SVMedia.glow,
		edgeSize = 3, insets = { left = 2, right = 2, top = 2, bottom = 2 }})
	map_border:SetBackdropColor(1,1,1,0.8)
	map_border:SetBackdropBorderColor(0, 0, 0)
	map_border.bg = CreateFrame("Frame",nil,map_border)
	map_border.bg:SetPoint("TOPLEFT")
	map_border.bg:SetPoint("BOTTOMRIGHT")
	map_border.bg:SetFrameLevel(1)
	map_border.bg2 = map_border.bg:CreateTexture(nil,"BACKGROUND")
	map_border.bg2:SetPoint("TOPLEFT",4,-4)
	map_border.bg2:SetPoint("BOTTOMRIGHT",-4,4)
	map_border.bg2:SetTexture(SVMedia.bar)
	map_border.bg2:SetVertexColor(1,1,1,0.8)
	map_border.bg2:SetGradientAlpha("VERTICAL",.2,.2,.2,.15,.25,.25,.25,.9)
	map_border.left = map_border.bg:CreateTexture(nil,"OVERLAY")
	map_border.left:SetTexture(SVMedia.bar)
	map_border.left:SetVertexColor(0.15,0.15,0.15,0.8)
	map_border.left:SetPoint("TOPLEFT")
	map_border.left:SetPoint("BOTTOMLEFT")
	map_border.left:SetWidth(4)
	map_border.right = map_border.bg:CreateTexture(nil,"OVERLAY")
	map_border.right:SetTexture(SVMedia.bar)
	map_border.right:SetVertexColor(0.15,0.15,0.15,0.8)
	map_border.right:SetPoint("TOPRIGHT")
	map_border.right:SetPoint("BOTTOMRIGHT")
	map_border.right:SetWidth(4)
	map_border.top = map_border.bg:CreateTexture(nil,"OVERLAY")
	map_border.top:SetTexture(SVMedia.bar)
	map_border.top:SetVertexColor(0.15,0.15,0.15,0.8)
	map_border.top:SetPoint("TOPLEFT")
	map_border.top:SetPoint("TOPRIGHT")
	map_border.top:SetHeight(4)
	map_border.bottom = map_border.bg:CreateTexture(nil,"OVERLAY")
	map_border.bottom:SetTexture(SVMedia.bar)
	map_border.bottom:SetVertexColor(0.15,0.15,0.15,0.8)
	map_border.bottom:SetPoint("BOTTOMLEFT")
	map_border.bottom:SetPoint("BOTTOMRIGHT")
	map_border.bottom:SetHeight(4)
	if SuperSet["panelops"].minimap == false then
		MapBorder:SetAlpha(0)
	end