﻿--[[ 
  /$$$$$$                                          /$$    /$$ /$$ /$$ /$$           /$$          
 /$$__  $$                                        | $$   | $$|__/| $$| $$          |__/          
| $$  \__/ /$$   /$$  /$$$$$$   /$$$$$$   /$$$$$$ | $$   | $$ /$$| $$| $$  /$$$$$$  /$$ /$$$$$$$ 
|  $$$$$$ | $$  | $$ /$$__  $$ /$$__  $$ /$$__  $$|  $$ / $$/| $$| $$| $$ |____  $$| $$| $$__  $$
 \____  $$| $$  | $$| $$  \ $$| $$$$$$$$| $$  \__/ \  $$ $$/ | $$| $$| $$  /$$$$$$$| $$| $$  \ $$
 /$$  \ $$| $$  | $$| $$  | $$| $$_____/| $$        \  $$$/  | $$| $$| $$ /$$__  $$| $$| $$  | $$
|  $$$$$$/|  $$$$$$/| $$$$$$$/|  $$$$$$$| $$         \  $/   | $$| $$| $$|  $$$$$$$| $$| $$  | $$
 \______/  \______/ | $$____/  \_______/|__/          \_/    |__/|__/|__/ \_______/|__/|__/  |__/
                    | $$                                                                         
                    | $$                                                                         
                    |__/                                                                         
 /$$      /$$           /$$ /$$                               /$$
| $$$    /$$$          | $$|__/                              |__/
| $$$$  /$$$$  /$$$$$$ | $$ /$$ /$$$$$$$   /$$$$$$   /$$$$$$  /$$
| $$ $$/$$ $$ /$$__  $$| $$| $$| $$__  $$ |____  $$ /$$__  $$| $$
| $$  $$$| $$| $$  \ $$| $$| $$| $$  \ $$  /$$$$$$$| $$  \__/| $$
| $$\  $ | $$| $$  | $$| $$| $$| $$  | $$ /$$__  $$| $$      | $$
| $$ \/  | $$|  $$$$$$/| $$| $$| $$  | $$|  $$$$$$$| $$      | $$
|__/     |__/ \______/ |__/|__/|__/  |__/ \_______/|__/      |__/
                                                                 

Molinari created by: p3lim, modified for SVUI by: Munglunch (with full permission from p3lim) 

LICENCE INFO:
Copyright (c) 2006-2008 Trond A Ekseth
Copyright (c) 2009-2010 Adrian L Lange

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
]]--
if SuperSet["load"].bags ~= true then return end
local addonName, ns = ...
local button = CreateFrame('Button', addonName, UIParent, 'SecureActionButtonTemplate')
button:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
button:RegisterEvent('PLAYER_LOGIN')

-----------------------------------------------Make the damn toggle button----
--LOCAL SHIZ------------------------------------------------------------------
local playerClass = SVRoot.myclass
local cColor = SVColors["classy"]
local r, g, b = unpack(cColor[playerClass])
local ir,ig,ib = (1-(r*0.8)),(1-(g*0.8)),(1-(b*0.8))
local blank = SVMedia.blank
local glowTex = SVMedia.glow
------------------------------------------------------------------------------
function DisassembleToggle()
	if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
	if SVLock.disassemble == true then
		SVLock.disassemble = false
		DisassembleButtonFrame.text:SetTextColor(r, g, b)
		DisassembleButtonFrame.text:SetText("Disassemble : OFF")
		DisassembleButtonFrame.bg:SetGradient("VERTICAL",ir, ig, ib,ir*0.3, ig*0.3, ib*0.3)
	else
		SVLock.disassemble = true
		DisassembleButtonFrame.text:SetTextColor(ir, ig, ib)
		DisassembleButtonFrame.text:SetText("Disassemble : ON")
		DisassembleButtonFrame.bg:SetGradient("VERTICAL",r, g, b,r*0.3, g*0.3, b*0.3)
	end
end
local function BreakShitB_OnHide()
	SVLock.disassemble = false
	DisassembleButtonFrame.text:SetTextColor(r, g, b)
	DisassembleButtonFrame.text:SetText("Disassemble : OFF")
	DisassembleButtonFrame.bg:SetGradient("VERTICAL",ir, ig, ib,ir*0.3, ig*0.3, ib*0.3)
end
--MOLINARI BUTTON-------------------------------------------------------------
local function CreateBreakShitButton()
	local lbBf = CreateFrame("Frame", "DisassembleButtonFrame", StuffingFrameBags)
	lbBf:SetFrameStrata("LOW")
	SVMod.AddonSkin(lbBf,nil,nil,2,ir,ig,ib)
	lbBf:SetWidth(140)
	lbBf:SetHeight(18)
	lbBf:SetPoint("TOPLEFT", StuffingFrameBags, "BOTTOMLEFT", 2, -4)
	lbBf:SetFrameLevel(3)
	local lbB = CreateFrame("Frame", "DisassembleButton", lbBf)
	lbB:SetPoint("TOPLEFT")
	lbB:SetPoint("BOTTOMRIGHT")
	lbBf:SetFrameStrata("MEDIUM")
	lbB:SetFrameLevel(4)
	lbB:EnableMouse(true)
	lbBf.text = lbBf:CreateFontString(nil,"OVERLAY")
	lbBf.text:SetAllPoints(lbBf)
	lbBf.text:SetFont(SVFonts.super, 14, "THINOUTLINE")
	lbBf.text:SetShadowOffset(2, -2)
	lbBf.text:SetTextColor(r, g, b)
	lbBf.text:SetText("Disassemble : OFF")
	SVLock.disassemble = false
	DisassembleButton:SetScript("OnMouseUp", function() DisassembleToggle() end)
	DisassembleButtonFrame:SetScript("OnHide", BreakShitB_OnHide)
end

local function ScanTooltip(self, spells)
	for index = 1, self:NumLines() do
		local info = spells[_G['GameTooltipTextLeft' .. index]:GetText()]
		if(info) then
			return unpack(info)
		end
	end
end

function button:PLAYER_LOGIN()
	local spells, disenchanter = {}
	if(IsSpellKnown(51005)) then
		spells[ITEM_MILLABLE] = {GetSpellInfo(51005), 1/2, 1, 1/2}
		CreateBreakShitButton()
	end

	if(IsSpellKnown(31252)) then
		spells[ITEM_PROSPECTABLE] = {GetSpellInfo(31252), 1, 1/3, 1/3}
		CreateBreakShitButton()
	end

	-- I wish Blizzard could treat disenchanting the same way
	if(IsSpellKnown(13262)) then
		disenchanter = {GetSpellInfo(13262), 1, 1, 1}
		CreateBreakShitButton()
	end

	GameTooltip:HookScript('OnTooltipSetItem', function(self)
		local item, link = self:GetItem()
		if(item and not InCombatLockdown() and (SVLock.disassemble == true)) then
			local spell, r, g, b = ScanTooltip(self, spells)

			if(not spell and disenchanter and ns.Disenchantable(link)) then
				spell, r, g, b = unpack(disenchanter)
			end

			local bag, slot = GetMouseFocus():GetParent(), GetMouseFocus()
			if(spell and GetContainerItemLink(bag:GetID(), slot:GetID()) == link) then
				button:SetAttribute('macrotext', string.format('/cast %s\n/use %s %s', spell, bag:GetID(), slot:GetID()))
				button:GetNormalTexture():SetVertexColor(r, g, b, 0.7)
				button:SetAllPoints(slot)
				button:Show()
			end
		end
	end)

	self:SetFrameStrata('TOOLTIP')
	self:SetAttribute('type', 'macro')
	self:SetNormalTexture(SVMedia.bar)
	self:GetNormalTexture():SetTexCoord(0.11, 0.66, .11, 0.66)
	self:SetScript('OnLeave', self.MODIFIER_STATE_CHANGED)

	self:RegisterEvent('MODIFIER_STATE_CHANGED')
	self:Hide()
end

function button:MODIFIER_STATE_CHANGED(key)
	if(not self:IsShown() and not key and (SVLock.disassemble == false)) then return end

	if(InCombatLockdown()) then
		self:SetAlpha(0)
		self:RegisterEvent('PLAYER_REGEN_ENABLED')
	else
		self:ClearAllPoints()
		self:SetAlpha(1)
		self:Hide()
	end
end

function button:PLAYER_REGEN_ENABLED()
	self:UnregisterEvent('PLAYER_REGEN_ENABLED')
	self:MODIFIER_STATE_CHANGED()
end
