MinionTable = {}
MinionTable = {
	[1] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Overlays\MINION-ONE]],
	[2] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Overlays\MINION-TWO]],
	[3] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Overlays\MINION-THREE]],
	[4] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Overlays\MINION-FOUR]],
}
local set_slide = SVAnimate.Slide
local default_minion = MinionTable[1]
function opt_color(self,r_col,g_col,b_col,r_txt,g_txt,b_txt)
	self.top:SetTexture(r_col,g_col,b_col)
	self.bottom:SetTexture(r_col,g_col,b_col)
	self.right:SetTexture(r_col,g_col,b_col)
	self.left:SetTexture(r_col,g_col,b_col)
	self.txt:SetTextColor(r_txt,g_txt,b_txt)
end	
--LOCKBAR BUTTON--
function SVMod.lock_toggled()
	if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
	if not TheLockBar:IsShown() then
		TheLockBar.slide_out:Stop()
		TheLockBar:Show()
		TheLockBar.slide:Play()
		toggleall()
	else
		TheLockBar.slide:Stop()
		TheLockBar.slide_out:Play()
	end
end
-- MAIN FRAME
	local MinionFrame = CreateFrame("Frame","MinionFrame",UIParent)
	MinionFrame:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 0, 0)
	MinionFrame:SetWidth(500)
	MinionFrame:SetHeight(500)
	MinionFrame:SetFrameStrata("DIALOG")
	MinionFrame:SetFrameLevel(24)
	MinionFramePic = MinionFrame:CreateTexture("MinionFramePic","ARTWORK")
	MinionFramePic:SetTexture(default_minion)
	MinionFramePic:SetPoint("TOPLEFT",MinionFrame,150,-150)
	MinionFramePic:SetPoint("BOTTOMRIGHT",MinionFrame)
	MinionFrame:Hide()
	
	local MinionFrameBG = CreateFrame("Frame","MinionFrameBG",UIParent)
	MinionFrameBG:SetAllPoints(WorldFrame)
	MinionFrameBG:SetBackdrop({bgFile = SVMedia.bar})
	MinionFrameBG:SetBackdropColor(0,0,0,0.9)
	MinionFrameBG:SetFrameStrata("DIALOG")
	MinionFrameBG:SetFrameLevel(22)
	MinionFrameBG:Hide()
	
	-- ANIMATION
	set_slide(MinionFrame,true,500,-500)

	--
	local opt1 = SVMod.flipframe(MinionFrame)
	opt1:SetWidth(150)
	opt1:SetHeight(30)
	opt1:SetPoint("BOTTOMRIGHT",MinionFrame,"LEFT",200,200)
	opt1:SetFrameStrata("DIALOG")
	opt1:SetFrameLevel(24)
	SVMod.AddonSkin(opt1)
	opt1:EnableMouse(true)
	opt1.txt = opt1:CreateFontString(nil,"OVERLAY")
	opt1.txt:SetFont(SVFonts.super,16,"OUTLINE")
	opt1.txt:SetShadowOffset(1,-1)
	opt1.txt:SetJustifyH("CENTER")
	opt1.txt:SetText("General Options")
	opt1.txt:SetPoint("CENTER",opt1)
	GOptions = opt1
	GOptions:SetScript("OnMouseDown", function() SVMod.RunSlash("/setupsvui"); toggleall() end)
	GOptions:SetScript("OnEnter",function() opt_color(GOptions,1,.7,.1,1,1,0) end)
	GOptions:SetScript("OnLeave",function() opt_color(GOptions,0,0,0,1,1,1) end)
	set_slide(GOptions,true,500,500)
	--
	local opt2 = SVMod.flipframe(MinionFrame)
	opt2:SetWidth(150)
	opt2:SetHeight(30)
	opt2:SetPoint("BOTTOMRIGHT",MinionFrame,"LEFT",150,160)
	opt2:SetFrameStrata("DIALOG")
	opt2:SetFrameLevel(24)
	SVMod.AddonSkin(opt2)
	opt2:EnableMouse(true)
	opt2.txt = opt2:CreateFontString(nil,"OVERLAY")
	opt2.txt:SetFont(SVFonts.super,16,"OUTLINE")
	opt2.txt:SetShadowOffset(1,-1)
	opt2.txt:SetJustifyH("CENTER")
	opt2.txt:SetText("Bar Options")
	opt2.txt:SetPoint("CENTER",opt2)
	BOptions = opt2
	BOptions:SetScript("OnMouseDown", function() SVMod.RunSlash("/svbars"); toggleall() end)
	BOptions:SetScript("OnEnter",function() opt_color(BOptions,1,.7,.1,1,1,0) end)
	BOptions:SetScript("OnLeave",function() opt_color(BOptions,0,0,0,1,1,1) end)
	set_slide(BOptions,true,600,300)
	--
	local opt3 = SVMod.flipframe(MinionFrame)
	opt3:SetWidth(150)
	opt3:SetHeight(30)
	opt3:SetPoint("BOTTOMRIGHT",MinionFrame,"LEFT",100,120)
	opt3:SetFrameStrata("DIALOG")
	opt3:SetFrameLevel(24)
	SVMod.AddonSkin(opt3)
	opt3:EnableMouse(true)
	opt3.txt = opt3:CreateFontString(nil,"OVERLAY")
	opt3.txt:SetFont(SVFonts.super,16,"OUTLINE")
	opt3.txt:SetShadowOffset(1,-1)
	opt3.txt:SetJustifyH("CENTER")
	opt3.txt:SetText("Layout Options")
	opt3.txt:SetPoint("CENTER",opt3)
	COptions = opt3
	COptions:SetScript("OnMouseDown", function() SVMod.RunSlash("/svlayout"); toggleall() end)
	COptions:SetScript("OnEnter",function() opt_color(COptions,1,.7,.1,1,1,0) end)
	COptions:SetScript("OnLeave",function() opt_color(COptions,0,0,0,1,1,1) end)
	set_slide(COptions,true,300,100)
	--
	local opt4 = SVMod.flipframe(MinionFrame)
	opt4:SetWidth(150)
	opt4:SetHeight(30)
	opt4:SetPoint("BOTTOMRIGHT",MinionFrame,"LEFT",50,80)
	opt4:SetFrameStrata("DIALOG")
	opt4:SetFrameLevel(24)
	SVMod.AddonSkin(opt4)
	opt4:EnableMouse(true)
	opt4.txt = opt4:CreateFontString(nil,"OVERLAY")
	opt4.txt:SetFont(SVFonts.super,16,"OUTLINE")
	opt4.txt:SetShadowOffset(1,-1)
	opt4.txt:SetJustifyH("CENTER")
	opt4.txt:SetText("Color Options")
	opt4.txt:SetPoint("CENTER",opt4)
	UOptions = opt4
	UOptions:SetScript("OnMouseDown", function() SVMod.RunSlash("/svcolors"); toggleall() end)
	UOptions:SetScript("OnEnter",function() opt_color(UOptions,1,.7,.1,1,1,0) end)
	UOptions:SetScript("OnLeave",function() opt_color(UOptions,0,0,0,1,1,1) end)
	set_slide(UOptions,true,-600,-300)
	--
	local opt5 = SVMod.flipframe(MinionFrame)
	opt5:SetWidth(150)
	opt5:SetHeight(30)
	opt5:SetPoint("BOTTOMRIGHT",MinionFrame,"LEFT",100,40)
	opt5:SetFrameStrata("DIALOG")
	opt5:SetFrameLevel(24)
	SVMod.AddonSkin(opt5)
	opt5:EnableMouse(true)
	opt5.txt = opt5:CreateFontString(nil,"OVERLAY")
	opt5.txt:SetFont(SVFonts.super,16,"OUTLINE")
	opt5.txt:SetShadowOffset(1,-1)
	opt5.txt:SetJustifyH("CENTER")
	opt5.txt:SetText("Extra Options")
	opt5.txt:SetPoint("CENTER",opt5)
	FOptions = opt5
	FOptions:SetScript("OnMouseDown", function() SVMod.lock_toggled(); toggleall() end)
	FOptions:SetScript("OnEnter",function() opt_color(FOptions,1,.7,.1,1,1,0) end)
	FOptions:SetScript("OnLeave",function() opt_color(FOptions,0,0,0,1,1,1) end)
	set_slide(FOptions,true,600,300)
	--
	local opt6 = SVMod.flipframe(MinionFrame)
	opt6:SetWidth(150)
	opt6:SetHeight(30)
	opt6:SetPoint("BOTTOMRIGHT",MinionFrame,"LEFT",150,0)
	opt6:SetFrameStrata("DIALOG")
	opt6:SetFrameLevel(24)
	SVMod.AddonSkin(opt6)
	opt6:EnableMouse(true)
	opt6.txt = opt6:CreateFontString(nil,"OVERLAY")
	opt6.txt:SetFont(SVFonts.super,16,"OUTLINE")
	opt6.txt:SetShadowOffset(1,-1)
	opt6.txt:SetJustifyH("CENTER")
	opt6.txt:SetText("Aura-Bar Menu")
	opt6.txt:SetPoint("CENTER",opt6)
	AOptions = opt6
	AOptions:SetScript("OnMouseDown", function() SVMod.RunSlash("/svaurabars"); toggleall() end)
	AOptions:SetScript("OnEnter",function() opt_color(AOptions,1,.7,.1,1,1,0) end)
	AOptions:SetScript("OnLeave",function() opt_color(AOptions,0,0,0,1,1,1) end)
	set_slide(AOptions,true,600,-300)
	--
	-- SCALE OPTIONS
	local opt7 = SVMod.flipframe(MinionFrame)
	opt7:SetWidth(150)
	opt7:SetHeight(30)
	opt7:SetPoint("BOTTOMRIGHT",MinionFrame,"LEFT",200,-40)
	opt7:SetFrameStrata("DIALOG")
	opt7:SetFrameLevel(24)
	SVMod.AddonSkin(opt7)
	opt7:EnableMouse(true)
	opt7.txt = opt7:CreateFontString(nil,"OVERLAY")
	opt7.txt:SetFont(SVFonts.super,16,"OUTLINE")
	opt7.txt:SetShadowOffset(1,-1)
	opt7.txt:SetJustifyH("CENTER")
	opt7.txt:SetText("Aura-Bar Config")
	opt7.txt:SetPoint("CENTER",opt7)
	SOptions = opt7
	SOptions:SetScript("OnMouseDown", function() SVMod.RunSlash("/svauras"); toggleall() end)
	SOptions:SetScript("OnEnter",function() opt_color(SOptions,1,.7,.1,1,1,0) end)
	SOptions:SetScript("OnLeave",function() opt_color(SOptions,0,0,0,1,1,1) end)
	set_slide(SOptions,true,600,-300)
	
	
	function toggleall()
		MinionFrame.slide:Stop()
		MinionFrame.slide_out:Play()
		--
		MinionFrameBG:Hide()
		--
		GOptions.slide:Stop()
		GOptions.slide_out:Play()
		--
		BOptions.slide:Stop()
		BOptions.slide_out:Play()
		--
		COptions.slide:Stop()
		COptions.slide_out:Play()
		--
		UOptions.slide:Stop()
		UOptions.slide_out:Play()
		--
		FOptions.slide:Stop()
		FOptions.slide_out:Play()
		--
		AOptions.slide:Stop()
		AOptions.slide_out:Play()
		--
	end
	
	function miniontoggle()
		if (not MinionFrame:IsShown()) and (not InCombatLockdown()) then
			local rmn = random(1,4)
			local skin = MinionTable[rmn]
			MinionFramePic:SetTexture(skin)
			MinionFrame.slide_out:Stop()
			MinionFrame:Show()
			MinionFrame.slide:Play()
			--
			MinionFrameBG:Show()
			--
			GOptions.slide_out:Stop()
			GOptions:Show()
			GOptions.slide:Play()
			--
			BOptions.slide_out:Stop()
			BOptions:Show()
			BOptions.slide:Play()
			--
			COptions.slide_out:Stop()
			COptions:Show()
			COptions.slide:Play()
			--
			UOptions.slide_out:Stop()
			UOptions:Show()
			UOptions.slide:Play()
			--
			FOptions.slide_out:Stop()
			FOptions:Show()
			FOptions.slide:Play()
			--
			AOptions.slide_out:Stop()
			AOptions:Show()
			AOptions.slide:Play()
			--
			MenuToggleTwo:SetFrameStrata("DIALOG")
			MenuToggleTwo:SetFrameLevel(24)
		else
			toggleall()
			MenuToggleTwo:SetFrameStrata("BACKGROUND")
			MenuToggleTwo:SetFrameLevel(2)
		end
	end

	SlashCmdList.CALLMINION = function() miniontoggle() end
	SLASH_CALLMINION1 = "/callminion"
	
local MinionCaller = CreateFrame("Frame",nil,MenuToggleTwo)
	MinionCaller:SetFrameStrata("MEDIUM")
	MinionCaller:SetPoint("TOPLEFT",MenuToggleTwo,4,-4)
	MinionCaller:SetPoint("BOTTOMRIGHT",MenuToggleTwo,-4,4)
	MinionCaller:SetBackdrop( {
		bgFile = SVMedia.m_icon,
		tile = false,})
	MinionCaller:SetBackdropColor(0.3,0.3,0.3,0.4)
	MinionCaller:SetBackdropBorderColor(0,0,0,0)
	MinionCaller:EnableMouse(true)
		
	MinionCaller:SetScript("OnEnter",function() MinionCaller:SetBackdropColor(1,.7,.1,0.9) end)
	MinionCaller:SetScript("OnLeave",function() MinionCaller:SetBackdropColor(0.3,0.3,0.3,0.4) end)
	MinionCaller:SetScript("OnMouseDown",function() 
		miniontoggle()
	end)