local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local dColor = SVColors["classy"][SVRoot.myclass]
local nc1,nc2,nc3 = dColor[1], dColor[2], dColor[3]
local cr,cg,cb = cColor[1], cColor[2], cColor[3]
local ir,ig,ib
if (SuperSet.colortheme == 3) then
	ir,ig,ib = 1,0.4,0.4
else
	ir,ig,ib = (1-(cr*0.8)),(1-(cg*0.8)),(1-(cb*0.8))
end
if (SuperSet.colortheme == 3) then
	SVMedia.statbartex = SVMedia.smoothbar
else
	SVMedia.statbartex = SVMedia.colorbar
end

SVMod.StatBox = function(name,skin)
	local datapanel = CreateFrame ("Frame",name,UIParent)
	datapanel:SetWidth(132)
	datapanel:SetHeight(34)
	datapanel:SetFrameLevel(2)
	datapanel.button = CreateFrame("Frame",nil,datapanel)
	datapanel.button:SetHeight(34)
	datapanel.button:SetWidth(34)
	datapanel.button:SetPoint("LEFT",datapanel)
	datapanel.icon = datapanel.button:CreateTexture(nil,"OVERLAY")
	datapanel.icon:SetPoint("TOPLEFT",datapanel.button,4,-4)
	datapanel.icon:SetPoint("BOTTOMRIGHT",datapanel.button,-4,4)
	datapanel.icon:SetTexture(skin)
	datapanel.icon:SetTexCoord(0.1, 0.9, 0.1, 0.9)
	datapanel.overlay = CreateFrame ("Frame",nil,datapanel)
	datapanel.overlay:SetAllPoints(datapanel.button)
	datapanel.overlay:SetFrameLevel(5)
	SVMod.SuperSkin(datapanel.overlay,2,nil,nil,nil,0)
	datapanel.bg = CreateFrame ("Frame",nil,datapanel)
	datapanel.bg:SetWidth(102)
	datapanel.bg:SetHeight(34)
	datapanel.bg:SetFrameLevel(2)
	datapanel.bg:SetPoint("LEFT",datapanel.button,"RIGHT",-4,0)
	SVMod.SuperSkin(datapanel.bg,2)
	datapanel.bar = CreateFrame ("StatusBar",nil,datapanel)
	datapanel.bar:SetPoint("TOPLEFT",datapanel.bg,5,-5)
	datapanel.bar:SetPoint("BOTTOMRIGHT",datapanel.bg,-5,5)
	datapanel.bar:SetFrameLevel(5)
	local loltex = datapanel.bar:CreateTexture (nil,"OVERLAY")
	loltex:SetTexture(SVMedia.statbartex)
	loltex:SetGradient("HORIZONTAL",cr*0.5,cg*0.5,cb*0.5,cr,cg,cb)
	datapanel.bar:SetStatusBarTexture(loltex)
	return datapanel
end
--[[
ICONS
DEFAULT		Interface\Icons\Achievement_Reputation_KirinTor
DUR			Interface\Icons\Trade_BlackSmithing		--or--	Ability_Repair
BAG			Interface\Icons\INV_Misc_Bag_07
POWER		Interface\Icons\Achievement_BG_most_damage_killingblow_dieleast
DPS			Interface\Icons\Achievement_BG_killingblow_berserker
FRIENDS		Interface\Icons\Achievement_Reputation_01
GUILD		Interface\Icons\INV_Shirt_GuildTabard_01
LFG			Interface\Icons\ACHIEVEMENT_BOSS_KILJAEDAN
CLOCK		Interface\Icons\Spell_Holy_BorrowedTime
PING		Interface\Icons\Achievement_BG_grab_cap_flagunderXseconds
??			Achievement_BG_tophealer_AB
??			Ability_Mage_TormentOfTheWeak
]]--