﻿local Recount = _G.Recount
if not Recount then return end

local function SkinFrame(frame)
    frame.bgMain = CreateFrame("Frame",nil,frame)
    frame.bgMain:SetPoint("BOTTOMLEFT",frame,"BOTTOMLEFT")
    frame.bgMain:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT")
    frame.bgMain:SetPoint("TOP",frame,"TOP",0,-28)
    frame.bgMain:SetFrameStrata("LOW")
    frame.bgMain:SetFrameLevel(31)
    frame.bgMain:SetAlpha(0.9)
    frame.bgTitle = CreateFrame("Frame",nil,frame)
    frame.bgTitle:SetPoint("TOPRIGHT",frame,"TOPRIGHT",0,-15)
    frame.bgTitle:SetPoint("TOPLEFT",frame,"TOPLEFT",0,-15)
    frame.bgTitle:SetPoint("BOTTOM",frame,"TOP",0,-26)
    frame.bgTitle:SetFrameStrata("LOW")
    frame.bgTitle:SetFrameLevel(32)
    frame.CloseButton:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-2,-11)
    frame.Title:SetPoint("TOPLEFT",frame,"TOPLEFT",4,-14)
	frame:SetBackdrop(nil)
	local rcbg = CreateFrame("Frame",nil,frame.bgMain)
	rcbg:SetPoint("TOPLEFT",frame.bgTitle,-8,8)
	rcbg:SetPoint("BOTTOMRIGHT",frame.bgMain,8,-8)
	rcbg:SetFrameStrata("BACKGROUND")
	SAIAurora.SuperSkin(rcbg)
end

Recount.UpdateBarTextures = function(self)
	for k, v in pairs(Recount.MainWindow.Rows) do
		v.StatusBar:SetStatusBarTexture(SAIAurora.bar)
		v.StatusBar:GetStatusBarTexture():SetHorizTile(false)
		v.StatusBar:GetStatusBarTexture():SetVertTile(false)
	end
end
Recount.SetBarTextures = Recount.UpdateBarTextures
Recount.CreateFrame_ = Recount.CreateFrame
Recount.CreateFrame = function(self, Name, Title, Height, Width, ShowFunc, HideFunc)
    local frame = self:CreateFrame_(Name, Title, Height, Width, ShowFunc, HideFunc)
    SkinFrame(frame)
    return frame
end
-- Skin existing frames
if Recount.MainWindow then SkinFrame(Recount.MainWindow) end
if Recount.ConfigWindow then SkinFrame(Recount.ConfigWindow) end
if Recount.GraphWindow then SkinFrame(Recount.GraphWindow) end
if Recount.DetailWindow then SkinFrame(Recount.DetailWindow) end
if _G["Recount_Realtime_!RAID_DAMAGE"] then SkinFrame(_G["Recount_Realtime_!RAID_DAMAGE"].Window) end
if _G["Recount_Realtime_!RAID_HEALING"] then SkinFrame(_G["Recount_Realtime_!RAID_HEALING"].Window) end
if _G["Recount_Realtime_!RAID_HEALINGTAKEN"] then SkinFrame(_G["Recount_Realtime_!RAID_HEALINGTAKEN"].Window) end
if _G["Recount_Realtime_!RAID_DAMAGETAKEN"] then SkinFrame(_G["Recount_Realtime_!RAID_DAMAGETAKEN"].Window) end
if _G["Recount_Realtime_Bandwidth Available_AVAILABLE_BANDWIDTH"] then SkinFrame(_G["Recount_Realtime_Bandwidth Available_AVAILABLE_BANDWIDTH"].Window) end
if _G["Recount_Realtime_FPS_FPS"] then SkinFrame(_G["Recount_Realtime_FPS_FPS"].Window) end
if _G["Recount_Realtime_Latency_LAG"] then SkinFrame(_G["Recount_Realtime_Latency_LAG"].Window) end
if _G["Recount_Realtime_Downstream Traffic_DOWN_TRAFFIC"] then SkinFrame(_G["Recount_Realtime_Downstream Traffic_DOWN_TRAFFIC"].Window) end
if _G["Recount_Realtime_Upstream Traffic_UP_TRAFFIC"] then SkinFrame(_G["Recount_Realtime_Upstream Traffic_UP_TRAFFIC"].Window) end
