SAIAurora = {}
SAIASkin = {}
SAIAurora = {
	["backdrop1"] = [[Interface\Addons\Supervillain_AI_Aurora\Skin_Textures\BACKDROP-ONE]],
	["backdrop2"] = [[Interface\Addons\Supervillain_AI_Aurora\Skin_Textures\BACKDROP-TWO]],
	["comic"] = [[Interface\Addons\Supervillain_AI_Aurora\Skin_Textures\COMIC-SKIN]],
	["smallicon"] = [[Interface\Addons\Supervillain_AI_Aurora\Skin_Textures\SV-SMALL]],
	["largeicon"] = [[Interface\Addons\Supervillain_AI_Aurora\Skin_Textures\SV-LARGE]],
	["glow"] = "Interface\\AddOns\\Supervillain_AI_Aurora\\Skin_Textures\\Super_Glow",
	["blank"] = "Interface\\AddOns\\Supervillain_AI_Aurora\\Skin_Textures\\Super_Blank",
	["bar"] = "Interface\\AddOns\\Supervillain_AI_Aurora\\Skin_Textures\\Super_Bar",
	["backdropcolor"] = {0.12,0.12,0.12,1},
}

SAIAurora.dummy = function() end

local classcolors = {
	["HUNTER"] = { r = 0.58, g = 0.86, b = 0.49 },
	["WARLOCK"] = { r = 0.6, g = 0.47, b = 0.85 },
	["PALADIN"] = { r = 1, g = 0.22, b = 0.52 },
	["PRIEST"] = { r = 0.8, g = 0.87, b = .9 },
	["MAGE"] = { r = 0, g = 0.76, b = 1 },
	["ROGUE"] = { r = 1, g = 0.91, b = 0.2 },
	["DRUID"] = { r = 1, g = 0.49, b = 0.04 },
	["SHAMAN"] = { r = 0, g = 0.6, b = 0.6 };
	["WARRIOR"] = { r = 0.78, g = 0.61, b = 0.43 },
	["DEATHKNIGHT"] = { r = 0.77, g = 0.12 , b = 0.23 },
}
local shading = {
	["HUNTER"] = { r = 0.68, g = 0.86, b = 0.59 },
	["WARLOCK"] = { r = 0.7, g = 0.57, b = 0.85 },
	["PALADIN"] = { r = 1, g = 0.32, b = 0.62 },
	["PRIEST"] = { r = 0.90, g = 0.67, b = 1 },
	["MAGE"] = { r = 0.2, g = 0.76, b = 1 },
	["ROGUE"] = { r = 1, g = 0.91, b = 0.4 },
	["DRUID"] = { r = 1, g = 0.49, b = 0.04 },
	["SHAMAN"] = { r = 0, g = 0.6, b = 0.6 };
	["WARRIOR"] = { r = 0.78, g = 0.61, b = 0.43 },
	["DEATHKNIGHT"] = { r = 0.77, g = 0.12 , b = 0.23 },
}
local _,class = UnitClass("player")
SAIAurora.myclass = class
local c
if CUSTOM_CLASS_COLORS then 
	c = CUSTOM_CLASS_COLORS[SAIAurora.myclass]
else
	c = classcolors[SAIAurora.myclass]
end
local oc = shading[SAIAurora.myclass]
local svar,svag,svab = (1-(c.r*0.5)),(1-(c.g*0.5)),(1-(c.b*0.5))
------------------------------------------------------------------------------------------------------
local uiscale = min(2, max(.64, 768/string.match(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)")))
local mult = 768/string.match(GetCVar("gxResolution"), "%d+x(%d+)")/uiscale
local function scale(x)
    return mult*math.floor(x/mult+.5)
end

function SAIAurora.Scale(x) return scale(x) end
SAIAurora.mult = mult
------------------------------------------------------------------------------------------------------
local SmallBack = function(blizzframe,alf)
	blizzframe.tex = CreateFrame("Frame",nil,blizzframe)
	blizzframe.tex:SetPoint("TOPLEFT",blizzframe,-4,6)
	blizzframe.tex:SetPoint("BOTTOMRIGHT",blizzframe,6,-4)
	blizzframe.tex:SetFrameLevel(blizzframe:GetFrameLevel()-6)
	blizzframe.tex:SetBackdrop( {
		bgFile = SAIAurora.backdrop2,
		tile = true,
		tileSize = 256,
		edgeFile = SAIAurora.glow,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
	blizzframe.tex:SetBackdropColor(0.2,0.2,0.2,alf)
	blizzframe.tex:SetBackdropBorderColor(c.r,c.g,c.b,alf)
	return blizzframe
end

local BigBack = function(blizzframe,alf)
	blizzframe.tex = CreateFrame("Frame",nil,blizzframe)
	blizzframe.tex:SetPoint("TOPLEFT",blizzframe,-4,6)
	blizzframe.tex:SetPoint("BOTTOMRIGHT",blizzframe,6,-4)
	blizzframe.tex:SetFrameLevel(blizzframe:GetFrameLevel()-6)
	blizzframe.tex:SetBackdrop( {
		bgFile = SAIAurora.backdrop2,
		tile = false,
		edgeFile = SAIAurora.glow,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
	blizzframe.tex:SetBackdropColor(0.2,0.2,0.2,alf)
	blizzframe.tex:SetBackdropBorderColor(c.r,c.g,c.b,alf)
	return blizzframe
end

local MenuSkin = function(blizzframe,alpha,border,small)
	if not blizzframe then return end
	if blizzframe.tex then return end
	local border = border or 1
	local alpha = alpha or 1
	blizzframe:SetBackdrop({bgFile = "",edgeFile = ""})
	blizzframe:SetBackdropColor(0,0,0,0)
	blizzframe:SetBackdropBorderColor(0,0,0,0)
	blizzframe:SetFrameLevel(8)
	if small == true then
		SmallBack(blizzframe,alpha)
	else
		BigBack(blizzframe,alpha)
	end
	blizzframe.glaze = CreateFrame("Frame",nil,blizzframe)
	blizzframe.glaze:SetAllPoints(blizzframe.tex)
	blizzframe.glaze:SetFrameLevel(blizzframe:GetFrameLevel()-4)
	if (alpha > 0) then
		local skinit = blizzframe.glaze:CreateTexture(nil,"OVERLAY")
		skinit:SetAllPoints(blizzframe.glaze)
		skinit:SetTexture(SAIAurora.blank)
		skinit:SetGradientAlpha("VERTICAL",c.r,c.g,c.b,0.1,oc.r,oc.g,oc.b,0.1)
	end
	if (border > 0) then
		blizzframe.left = blizzframe:CreateTexture(nil,"OVERLAY")
		blizzframe.left:SetTexture(1,1,1)
		blizzframe.left:SetGradient("VERTICAL",0.5,0.5,0.5,1,1,1)
		blizzframe.left:SetPoint("TOPLEFT",blizzframe.tex,3,-3)
		blizzframe.left:SetPoint("BOTTOMLEFT",blizzframe.tex,3,3)
		blizzframe.left:SetWidth(border)
		blizzframe.right = blizzframe:CreateTexture(nil,"OVERLAY")
		blizzframe.right:SetTexture(1,1,1)
		blizzframe.right:SetGradient("VERTICAL",0.5,0.5,0.5,1,1,1)
		blizzframe.right:SetPoint("TOPRIGHT",blizzframe.tex,-3,-3)
		blizzframe.right:SetPoint("BOTTOMRIGHT",blizzframe.tex,-3,3)
		blizzframe.right:SetWidth(border)
		blizzframe.top = blizzframe:CreateTexture(nil,"OVERLAY")
		blizzframe.top:SetTexture(1,1,1)
		blizzframe.top:SetPoint("TOPLEFT",blizzframe.tex,3,-3)
		blizzframe.top:SetPoint("TOPRIGHT",blizzframe.tex,-3,-3)
		blizzframe.top:SetHeight(border)
		blizzframe.bottom = blizzframe:CreateTexture(nil,"OVERLAY")
		blizzframe.bottom:SetTexture(0.5,0.5,0.5)
		blizzframe.bottom:SetPoint("BOTTOMLEFT",blizzframe.tex,3,3)
		blizzframe.bottom:SetPoint("BOTTOMRIGHT",blizzframe.tex,-3,3)
		blizzframe.bottom:SetHeight(border)
	end
	return blizzframe
end
SAIAurora.MenuSkin = MenuSkin
---------------------------------------------------------------------------------------------------
local ComicSkin = function(blizzframe,x,y,xx,yy)
	local x,y = (x or -8),(y or 8)
	local xx,yy = (xx or 8),(yy or -8)
	if blizzframe.tex then return end
	blizzframe:SetBackdrop({bgFile = "",edgeFile = ""})
	blizzframe:SetBackdropColor(0,0,0,0)
	blizzframe:SetBackdropBorderColor(0,0,0,0)
	blizzframe:SetFrameLevel(8)
	blizzframe.tex = CreateFrame("Frame",nil,blizzframe)
	blizzframe.tex:SetPoint("TOPLEFT",blizzframe,x,y)
	blizzframe.tex:SetPoint("BOTTOMRIGHT",blizzframe,xx,yy)
	blizzframe.tex:SetFrameLevel(blizzframe:GetFrameLevel()-2)
	local skinit = blizzframe.tex:CreateTexture(nil,"OVERLAY")
	skinit:SetAllPoints(blizzframe.tex)
	skinit:SetTexture(SAIAurora.comic)
	skinit:SetGradient("VERTICAL",svar,svag,svab,c.r,c.g,c.b)
	blizzframe.left = blizzframe.tex:CreateTexture(nil,"OVERLAY")
	blizzframe.left:SetTexture(1,1,1)
	blizzframe.left:SetGradient("VERTICAL",0.5,0.5,0.5,1,1,1)
	blizzframe.left:SetPoint("TOPLEFT",blizzframe.tex,-3,3)
	blizzframe.left:SetPoint("BOTTOMLEFT",blizzframe.tex,-3,-3)
	blizzframe.left:SetWidth(2)
	blizzframe.right = blizzframe.tex:CreateTexture(nil,"OVERLAY")
	blizzframe.right:SetTexture(1,1,1)
	blizzframe.right:SetGradient("VERTICAL",0.5,0.5,0.5,1,1,1)
	blizzframe.right:SetPoint("TOPRIGHT",blizzframe.tex,3,3)
	blizzframe.right:SetPoint("BOTTOMRIGHT",blizzframe.tex,3,-3)
	blizzframe.right:SetWidth(2)
	blizzframe.top = blizzframe.tex:CreateTexture(nil,"OVERLAY")
	blizzframe.top:SetTexture(1,1,1)
	blizzframe.top:SetPoint("TOPLEFT",blizzframe.tex,-3,3)
	blizzframe.top:SetPoint("TOPRIGHT",blizzframe.tex,3,3)
	blizzframe.top:SetHeight(2)
	blizzframe.bottom = blizzframe.tex:CreateTexture(nil,"OVERLAY")
	blizzframe.bottom:SetTexture(0.5,0.5,0.5)
	blizzframe.bottom:SetPoint("BOTTOMLEFT",blizzframe.tex,-3,-3)
	blizzframe.bottom:SetPoint("BOTTOMRIGHT",blizzframe.tex,3,-3)
	blizzframe.bottom:SetHeight(2)

	return blizzframe
end
SAIAurora.ComicSkin = ComicSkin
---------------------------------------------------------------------------------------------------
local SlotSkin = function(f)
	if f.bg then return end
	local BottomTex = {0.4,0.4,0.4}
	local TopTex = {0.6,0.6,0.6}
	local SideGradient = {0.4,0.4,0.4,0.6,0.6,0.6}
	f:SetBackdrop({bgFile = "",edgeFile = ""})
	f.bg = CreateFrame("Frame",nil,f)
	f.bg:SetPoint("TOPLEFT",f)
	f.bg:SetPoint("BOTTOMRIGHT",f)
	f.bg:SetBackdrop( {
		bgFile = SAIAurora.blank,
		edgeFile = SAIAurora.glow,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
	f.bg:SetBackdropColor(0, 0, 0)
	f.bg:SetBackdropBorderColor(0, 0, 0)
	f.bg:SetFrameLevel((f:GetFrameLevel())-2)
	f.left = f:CreateTexture(nil,"OVERLAY")
	f.left:SetTexture(1,1,1)
	f.left:SetGradient("VERTICAL",unpack(SideGradient))
	f.left:SetPoint("TOPLEFT",f.bg)
	f.left:SetPoint("BOTTOMLEFT",f.bg)
	f.left:SetWidth(1)
	f.right = f:CreateTexture(nil,"OVERLAY")
	f.right:SetTexture(1,1,1)
	f.right:SetGradient("VERTICAL",unpack(SideGradient))
	f.right:SetPoint("TOPRIGHT",f.bg)
	f.right:SetPoint("BOTTOMRIGHT",f.bg)
	f.right:SetWidth(1)
	f.top = f:CreateTexture(nil,"OVERLAY")
	f.top:SetTexture(1,1,1)
	f.top:SetVertexColor(unpack(TopTex))
	f.top:SetPoint("TOPLEFT",f.bg)
	f.top:SetPoint("TOPRIGHT",f.bg)
	f.top:SetHeight(1)
	f.bottom = f:CreateTexture(nil,"OVERLAY")
	f.bottom:SetTexture(1,1,1)
	f.bottom:SetVertexColor(unpack(BottomTex))
	f.bottom:SetPoint("BOTTOMLEFT",f.bg)
	f.bottom:SetPoint("BOTTOMRIGHT",f.bg)
	f.bottom:SetHeight(1)
	return f
end
SAIAurora.SlotSkin = SlotSkin
------------------------------------------------------------------------------------------------------------------------------------
SAIAurora.CreatePulse = function(frame, speed, mult, alpha) -- pulse function originally by nightcracker
	frame.speed = speed or .05
	frame.mult = mult or 1
	frame.alpha = alpha or 1
	frame.tslu = 0 -- time since last update
	frame:SetScript("OnUpdate", function(self, elapsed)
		self.tslu = self.tslu + elapsed
		if self.tslu > self.speed then
			self.tslu = 0
			self:SetAlpha(self.alpha)
		end
		self.alpha = self.alpha - elapsed*self.mult
		if self.alpha < 0 and self.mult > 0 then
			self.mult = self.mult*-1
			self.alpha = 0
		elseif self.alpha > 1 and self.mult < 0 then
			self.mult = self.mult*-1
		end
	end)
end
---------------------------------------------------------------------------------------------------
SAIAurora.CreateTab = function(f)
	local sd = CreateFrame("Frame", nil, f)
	sd:SetBackdrop({
		bgFile = SAIAurora.blank,
		edgeFile = SAIAurora.glow,
		edgeSize = 5,
		insets = { left = 5, right = 5, top = 5, bottom = 5 },
	})
	sd:SetPoint("TOPLEFT", 4, 4)
	sd:SetPoint("BOTTOMRIGHT", -4, 2)
	sd:SetBackdropColor(0, 0, 0, .5)
	sd:SetBackdropBorderColor(0, 0, 0)
	sd:SetFrameStrata("LOW")
end
-------------------------------------------------------------------------------------------------
local ButtonSkin = function(f)
	if f.bg then return end
	f:SetBackdrop( {
		bgFile = SAIAurora.blank,
		edgeFile = SAIAurora.glow,
		edgeSize = 3, insets = { left = 2, right = 2, top = 2, bottom = 2 }})
	f:SetBackdropColor(0.05, 0.05, 0.05, 0.8)
	f:SetBackdropBorderColor(0, 0, 0)
	f.bg = f:CreateTexture(nil,"BORDER")
	f.bg:SetPoint("TOPLEFT", 2, -2)
	f.bg:SetPoint("BOTTOMRIGHT", -2, 2)
	f.bg:SetTexture(c.r,c.g,c.b)
	f.bg:SetGradientAlpha("VERTICAL",0.1,0.1,0.1,1,1,1,1,0.5)
	return f
end
SAIAurora.ButtonSkin = ButtonSkin
---------------------------------------------------------------------------------------------------
SAIAurora.Reskin = function(f)
	local glow = CreateFrame("Frame", nil, f)
	glow:SetBackdrop({
		edgeFile = SAIAurora.glow,
		edgeSize = 5,
	})
	glow:SetPoint("TOPLEFT", f, -6, 6)
	glow:SetPoint("BOTTOMRIGHT", f, 6, -6)
	glow:SetBackdropBorderColor(c.r, c.g, c.b)
	glow:SetAlpha(0)

	f:SetNormalTexture("")
	f:SetHighlightTexture("")
	f:SetPushedTexture("")
	f:SetDisabledTexture("")

	SAIAurora.ButtonSkin(f)

	f:HookScript("OnEnter", function(self) self:SetBackdropBorderColor(c.r, c.g, c.b) self:SetBackdropColor(c.r, c.g, c.b, .1) SAIAurora.CreatePulse(glow) end)
 	f:HookScript("OnLeave", function(self) self:SetBackdropBorderColor(0, 0, 0) self:SetBackdropColor(0, 0, 0, .25) glow:SetScript("OnUpdate", nil) glow:SetAlpha(0) end)
end
---------------------------------------------------------------------------------------------------
SAIAurora.BG_o_Matic = function(parent,x,y,xx,yy)
	local x,y = (x or 0),(y or 0)
	local xx,yy = (xx or 0),(yy or 0)
	local bgf = CreateFrame("Frame", nil, parent)
	bgf:ClearAllPoints()
	bgf:SetPoint("TOPLEFT",x,y)
	bgf:SetPoint("BOTTOMRIGHT",xx,yy)
	parent:SetFrameLevel(8)
	bgf:SetFrameLevel(parent:GetFrameLevel()-6)
	SAIAurora.MenuSkin(bgf)
	return f
end
---------------------------------------------------------------------------------------------------

local DeluxeSkin = function (f,level,color,strata)
	if f.bg then return end
	f:SetBackdrop( {
		bgFile = SAIAurora.blank,
		edgeFile = SAIAurora.glow,
		edgeSize = 3, insets = { left = 2, right = 2, top = 2, bottom = 2 }})
	local color = color or {0,0,0}
	f:SetFrameStrata(strata or "BACKGROUND")
	f:SetFrameLevel(level or 1)
	f:SetBackdropColor(0, 0, 0, 0)
	f:SetBackdropBorderColor(0, 0, 0, 0)
	f.bg = f:CreateTexture(nil,"BORDER")
	f.bg:SetTexture(0.08,0.08,0.08,0.8)
	f.bg:SetPoint("TOPLEFT",1,-1)
	f.bg:SetPoint("BOTTOMRIGHT",-1,1)
	f.left = f:CreateTexture(nil,"OVERLAY")
	f.left:SetTexture(0,0,0)
	f.left:SetPoint("TOPLEFT")
	f.left:SetPoint("BOTTOMLEFT")
	f.left:SetWidth(2)
	f.right = f:CreateTexture(nil,"OVERLAY")
	f.right:SetTexture(0,0,0)
	f.right:SetPoint("TOPRIGHT")
	f.right:SetPoint("BOTTOMRIGHT")
	f.right:SetWidth(2)
	f.top = f:CreateTexture(nil,"OVERLAY")
	f.top:SetTexture(0,0,0)
	f.top:SetPoint("TOPLEFT")
	f.top:SetPoint("TOPRIGHT")
	f.top:SetHeight(2)
	f.bottom = f:CreateTexture(nil,"OVERLAY")
	f.bottom:SetTexture(0,0,0)
	f.bottom:SetPoint("BOTTOMLEFT")
	f.bottom:SetPoint("BOTTOMRIGHT")
	f.bottom:SetHeight(2)
	return f
end
SAIAurora.DeluxeSkin = DeluxeSkin
---------------------------------------------------------------------------------------------------
local AddonSkin = function (f,v,v2,off,r,g,b)
	if f.bg then return end
	local v = v or 1
	local v2 = v2 or 0.3
	local off = off or 4
	local r = r or c.r
	local g = g or c.g
	local b = b or c.b
	f:SetBackdrop( {
		bgFile = SAIAurora.blank,
		edgeFile = SAIAurora.glow,
		edgeSize = 3, insets = { left = 2, right = 2, top = 2, bottom = 2 }})
	f:SetBackdropColor(0,0,0,0)
	f:SetBackdropBorderColor(0, 0, 0, 0)
	f.bg = f:CreateTexture(nil,"BACKGROUND")
	f.bg:SetTexture(1,1,1)
	f.bg:SetGradient("VERTICAL",r*v, g*v, b*v,r*v2, g*v2, b*v2)
	f.bg:SetPoint("TOPLEFT",-off,off)
	f.bg:SetPoint("BOTTOMRIGHT",off,-off)
	f.left = f:CreateTexture(nil,"OVERLAY")
	f.left:SetTexture(0,0,0)
	f.left:SetPoint("TOPLEFT",-off,off)
	f.left:SetPoint("BOTTOMLEFT",off,-off)
	f.left:SetWidth(2)
	f.right = f:CreateTexture(nil,"OVERLAY")
	f.right:SetTexture(0,0,0)
	f.right:SetPoint("TOPRIGHT",off,off)
	f.right:SetPoint("BOTTOMRIGHT",-off,-off)
	f.right:SetWidth(2)
	f.top = f:CreateTexture(nil,"OVERLAY")
	f.top:SetTexture(0,0,0)
	f.top:SetPoint("TOPLEFT",-off,off)
	f.top:SetPoint("TOPRIGHT",off,off)
	f.top:SetHeight(2)
	f.bottom = f:CreateTexture(nil,"OVERLAY")
	f.bottom:SetTexture(0,0,0)
	f.bottom:SetPoint("BOTTOMLEFT",-off,-off)
	f.bottom:SetPoint("BOTTOMRIGHT",off,-off)
	f.bottom:SetHeight(2)
	return f
end
SAIAurora.AddonSkin = AddonSkin
---------------------------------------------------------------------------------------------------
local super_skin = function (f,thick,r,g,b)
	if f.left then return end
	local thick = thick or 4
	local off = thick + 2
	local r = r or c.r
	local g = g or c.g
	local b = b or c.b
	local r2,g2,b2 = (r*0.3),(g*0.3),(b*0.3)
	f:SetBackdrop( {
		bgFile = SAIAurora.blank,
		edgeFile = SAIAurora.glow,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }})
	f:SetBackdropColor(0,0,0,0.6)
	f:SetBackdropBorderColor(0, 0, 0, 1)
	f.left = f:CreateTexture(nil,"OVERLAY")
	f.left:SetTexture(1,1,1)
	f.left:SetGradient("VERTICAL", r, g, b, r2, g2, b2)
	f.left:SetPoint("TOPLEFT",off,-off)
	f.left:SetPoint("BOTTOMLEFT",off,off)
	f.left:SetWidth(thick)
	f.right = f:CreateTexture(nil,"OVERLAY")
	f.right:SetTexture(1,1,1)
	f.right:SetGradient("VERTICAL", r, g, b, r2, g2, b2)
	f.right:SetPoint("TOPRIGHT",-off,-off)
	f.right:SetPoint("BOTTOMRIGHT",-off,off)
	f.right:SetWidth(thick)
	f.top = f:CreateTexture(nil,"OVERLAY")
	f.top:SetTexture(1,1,1)
	f.top:SetVertexColor(r2, g2, b2)
	f.top:SetPoint("TOPLEFT",off,-off)
	f.top:SetPoint("TOPRIGHT",-off,-off)
	f.top:SetHeight(thick)
	f.bottom = f:CreateTexture(nil,"OVERLAY")
	f.bottom:SetTexture(1,1,1)
	f.bottom:SetVertexColor(r, g, b)
	f.bottom:SetPoint("BOTTOMLEFT",off,off)
	f.bottom:SetPoint("BOTTOMRIGHT",-off,off)
	f.bottom:SetHeight(thick)
	return f
end
SAIAurora.SuperSkin = super_skin