--------------------------------Default Configurations---------------------------------------------
local d_texturepath = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Default\]]
local bar_texturepath = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Bars\]]
local o_texturepath = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Overlays\]]
local fontpath = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\fonts\]]
local soundpath = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\sounds\]]
INTERFACE_ACTION_BLOCKED = "" -- HATE THIS

SVRoot.combat = "You are in combat."
SVMedia = {
	["bordercolor"] = {0,0,0,1}, 
	["backdropcolor"] = {0.12,0.12,0.12,1},
	["bordershadow"] = {0,0,0,0.6}, 
	["blank"] = d_texturepath..[=[blankTex]=],
	["glow"] = d_texturepath..[=[glowTex]=],
	["normTex"] = d_texturepath..[=[normTex]=], 
	["colorbar"] = bar_texturepath..[=[ColorBar]=],
	["bar"] = bar_texturepath..[=[BasicBar]=],
	["smoothbar"] = bar_texturepath..[=[SmoothBar]=],
	["neonbar"] = bar_texturepath..[=[NeonBar]=],
	["tonel"] = o_texturepath..[=[ComicOverlayOne]=],
	["toner"] = o_texturepath..[=[ComicOverlayTwo]=],
	["menuglow"] = o_texturepath..[=[MenuGlow]=],
	["right"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\RIGHT-ARROW]],
	["left"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\LEFT-ARROW]],
	["up"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\UP-ARROW]],
	["down"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\DOWN-ARROW]],
	["punch"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\RED-GLOVE]],
	["glove"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\SUPER-GLOVE]],
	["take"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\GREEN-GLOVE]],
	["m_icon"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\M-ICON]],
	["lock"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\LOCK]],
	["gear"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\GEARS]],
	["svlogo"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\SV-SMALL]],
	["svbadge"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\SV-LARGE]],
	["raidicons"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\RAID-ICONS]],
	["unitfg"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\UnitFrameTextures\UNIT-FG]],
	["unitbg"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\UnitFrameTextures\UNIT-BG]],
	["unitaf"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\UnitFrameTextures\UNIT-AFFLICTED]],
	["smallbg"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\UnitFrameTextures\UNIT-SMALL-BG]],
	["smplbg"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\UnitFrameTextures\UNIT-SIMPLE-BG]],
	["tapped"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\UnitFrameTextures\TAPPED]],
	["ppvpd"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\PVPIcons\PLAYER-DEFAULT]],
	["ppvph"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\PVPIcons\PLAYER-HORDE]],
	["ppvpa"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\PVPIcons\PLAYER-ALLIANCE]],
	["tpvpd"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\PVPIcons\TARGET-DEFAULT]],
	["tpvph"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\PVPIcons\TARGET-HORDE]],
	["tpvpa"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\PVPIcons\TARGET-ALLIANCE]],
	["spvph"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\PVPIcons\HORDE]],
	["spvpa"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\PVPIcons\ALLIANCE]],
	["cpicon"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Icons\POP]],
	["sunicon"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Icons\SUN]],
	["moonicon"] = [[Interface\AddOns\A_Battle_Begins\Supervillain_Media\textures\Icons\MOON]],
	["whisper"] = soundpath..[=[whisper.mp3]=],
	["warning"] = soundpath..[=[warning.mp3]=],
	-- MENTALO THE FRAME MOVER!!
	["mentalo"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\MENTALO\mentalo_off]],
	["mentalo_on"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\MENTALO\mentalo_on]],
	["mentalo_hand"] = [[Interface\Addons\A_Battle_Begins\Supervillain_Media\textures\Icons\MENTALO\mentalo_hand]],
}
SVFonts = {
	["font"] = fontpath..[=[SVFont.ttf]=],
	["font_s"] = fontpath..[=[SVFont_Input.ttf]=],
	["pixel"] = fontpath..[=[SVFont_Pixel.ttf]=],
	["cooldown"] = fontpath..[=[SVFont_Cooldown.ttf]=],
	["super"] = fontpath..[=[SVFont_Title.ttf]=],
	["super_c"] = fontpath..[=[SVFont_Subtitle.ttf]=],
	["super_r"] = fontpath..[=[SVFont_Raid.ttf]=],
	["meanwhile"] = fontpath..[=[SVFont_Meanwhile.ttf]=],
	["damage"] = fontpath..[=[SVFont_MoreCombats.ttf]=],
	["numbers"] = fontpath..[=[SVFont_Numbers.ttf]=],
	["big_numbers"] = fontpath..[=[SVFont_Numbers_Big.ttf]=],
}
SVRoot.L = SVRoot.client

----DUMMY MENTALO FUNCTIONS, WE WILL DECLAIRE THE ACTUAL FUNCTIONS LATER--------
SVMod.MentaloIDLE = SVRoot.dummy
SVMod.MentaloPEWPEW = SVRoot.dummy