--Munglunch's CUSTOM class colors------------------------------------------------------------------------------COLOR START
if (SuperSet.colortheme == 2) then
	SVColors.oUF_colors = setmetatable({
		tapped = {0.55, 0.57, 0.61},
		disconnected = {0.84, 0.75, 0.65},
		power = setmetatable({
			["MANA"] = {0.31, 0.45, 0.63},
			["RAGE"] = {0.69, 0.31, 0.31},
			["FOCUS"] = {0.71, 0.43, 0.27},
			["ENERGY"] = {0.65, 0.63, 0.35},
			["RUNES"] = {0.55, 0.57, 0.61},
			["RUNIC_POWER"] = {0, 0.82, 1},
			["AMMOSLOT"] = {0.8, 0.6, 0},
			["FUEL"] = {0, 0.55, 0.5},
			["POWER_TYPE_STEAM"] = {0.55, 0.57, 0.61},
			["POWER_TYPE_PYRITE"] = {0.60, 0.09, 0.17},
		}, {__index = oUF.colors.power}),
		runes = setmetatable({
			[1] = {.69,.31,.31},
			[2] = {.33,.59,.33},
			[3] = {.31,.45,.63},
			[4] = {.84,.75,.65},
		}, {__index = oUF.colors.runes}),
		reaction = setmetatable({
			[1] = { 222/255, 95/255, 95/255 }, -- Hated
			[2] = { 222/255, 95/255, 95/255 }, -- Hostile
			[3] = { 222/255, 95/255, 95/255 }, -- Unfriendly
			[4] = { 218/255, 197/255, 92/255 }, -- Neutral
			[5] = { 75/255, 175/255, 76/255 }, -- Friendly
			[6] = { 75/255, 175/255, 76/255 }, -- Honored
			[7] = { 75/255, 175/255, 76/255 }, -- Revered
			[8] = { 75/255, 175/255, 76/255 }, -- Exalted
		}, {__index = oUF.colors.reaction}),
		class = setmetatable({
			["DEATHKNIGHT"] = { 196/255, 30/255, 60/255 },
			["DRUID"] = { 255/255, 125/255, 10/255 },
			["HUNTER"] = { 171/255, 214/255, 116/255 },
			["MAGE"] = { 104/255, 205/255, 255/255 },
			["PALADIN"] = { 245/255, 140/255, 186/255 },
			["PRIEST"] = { 212/255, 212/255, 212/255 },
			["ROGUE"] = { 255/255, 243/255, 82/255 },
			["SHAMAN"] = { 41/255, 79/255, 155/255 },
			["WARLOCK"] = { 148/255, 130/255, 201/255 },
			["WARRIOR"] = { 199/255, 156/255, 110/255 },
		}, {__index = oUF.colors.class}),
	}, {__index = oUF.colors})
	--CUSTOM Health gradient for colorSmooth---------------------
	SVColors["LIFE"] = {0.69, 0.31, 0.31, 0.65, 0.63, 0.35, 0.33, 0.59, 0.33}
	--CUSTOM Power gradient for colorSmooth----------------------
	SVColors["POW"] = {0.69, 0.17, 0.63, 0.55, 0.31, 0.63, 0.31, 0.45, 0.63}
	SVColors["classy"] = {  ---Used when default raidcolor has been changed
		["DEATHKNIGHT"] = { 196/255, 30/255, 60/255 },
		["DRUID"] = { 255/255, 125/255, 10/255 },
		["HUNTER"] = { 171/255, 214/255, 116/255 },
		["MAGE"] = { 104/255, 205/255, 255/255 },
		["PALADIN"] = { 245/255, 140/255, 186/255 },
		["PRIEST"] = { 212/255, 212/255, 212/255 },
		["ROGUE"] = { 255/255, 243/255, 82/255 },
		["SHAMAN"] = { 41/255, 79/255, 155/255 },
		["WARLOCK"] = { 148/255, 130/255, 201/255 },
		["WARRIOR"] = { 199/255, 156/255, 110/255 },
	}
	--Table Loaded single colors---------------------------------
	SVColors["purple"] = {0.69, 0.31, 0.69}
	SVColors["teal"] = {0.31, 0.51, 0.69}
	SVColors["shard"] = {0.79, 0.41, 0.79}
	SVColors["lunar"] = {0.41, 0.41, 0.79}
	SVColors["solar"] = {0.79, 0.79, 0.41}
elseif (SuperSet.colortheme == 3) then
	SVColors.oUF_colors = setmetatable({
		tapped = {0.60, 0.55, 0.56},
		disconnected = {0.20, 0.20, 0.20},
		power = setmetatable({
			["MANA"] = {0.15, 0.15, 0.15},
			["RAGE"] = {0.15, 0.15, 0.15},
			["FOCUS"] = {0.15, 0.15, 0.15},
			["ENERGY"] = {0.15, 0.15, 0.15},
			["RUNES"] = {0.15, 0.15, 0.15},
			["RUNIC_POWER"] = {0.15, 0.15, 0.15},
			["AMMOSLOT"] = {0.15, 0.15, 0.15},
			["FUEL"] = {0.15, 0.15, 0.15},
			["POWER_TYPE_STEAM"] = {0.15, 0.15, 0.15},
			["POWER_TYPE_PYRITE"] = {0.15, 0.15, 0.15},
		}, {__index = oUF.colors.power}),
		happiness = setmetatable({
			[1] = {.7,.3,.3},
			[2] = {.6,.4,.4},
			[3] = {.5,.5,.5},
		}, {__index = oUF.colors.happiness}),
		runes = setmetatable({
			[1] = {.50,.15,.15},
			[2] = {.15,.50,.15},
			[3] = {.15,.30,.50},
			[4] = {.50,.35,.25},
		}, {__index = oUF.colors.runes}),
		reaction = setmetatable({
			[1] = { 175/255, 15/255, 15/255 }, -- Hated
			[2] = { 175/255, 15/255, 15/255 }, -- Hostile
			[3] = { 175/255, 15/255, 15/255 }, -- Unfriendly
			[4] = { 105/255, 105/255, 35/255 }, -- Neutral
			[5] = { 75/255, 75/255, 75/255 }, -- Friendly
			[6] = { 75/255, 75/255, 75/255 }, -- Honored
			[7] = { 75/255, 75/255, 75/255 }, -- Revered
			[8] = { 75/255, 75/255, 75/255 }, -- Exalted	
		}, {__index = oUF.colors.reaction}),
		class = setmetatable({
			["DEATHKNIGHT"] = { 75/255, 75/255, 75/255 },
			["DRUID"]       = { 75/255, 75/255, 75/255 },
			["HUNTER"]      = { 75/255, 75/255, 75/255 },
			["MAGE"]        = { 75/255, 75/255, 75/255 },
			["PALADIN"]     = { 75/255, 75/255, 75/255 },
			["PRIEST"]      = { 75/255, 75/255, 75/255 },
			["ROGUE"]       = { 75/255, 75/255, 75/255 },
			["SHAMAN"]      = { 75/255, 75/255, 75/255 },
			["WARLOCK"]     = { 75/255, 75/255, 75/255 },
			["WARRIOR"]     = { 75/255, 75/255, 75/255 },
		}, {__index = oUF.colors.class}),
	}, {__index = oUF.colors})
	--CUSTOM Health gradient for colorSmooth---------------------
	SVColors["LIFE"] = {0.8, 0.01, 0.01, 0.6, 0.5, 0.25, 0.5, 0.5, 0.5}
	--CUSTOM Power gradient for colorSmooth----------------------
	SVColors["POW"] = {0.5, 0.55, 0.65, 0.4, 0.4, 0.45, 0.2, 0.2, 0.2}
	SVColors["classy"] = {  ---Used when default raidcolor has been changed
		["DEATHKNIGHT"] = { 196/255, 30/255, 60/255 },
		["DRUID"] = { 255/255, 125/255, 10/255 },
		["HUNTER"] = { 171/255, 214/255, 116/255 },
		["MAGE"] = { 104/255, 205/255, 255/255 },
		["PALADIN"] = { 245/255, 140/255, 186/255 },
		["PRIEST"] = { 212/255, 212/255, 212/255 },
		["ROGUE"] = { 255/255, 243/255, 82/255 },
		["SHAMAN"] = { 41/255, 79/255, 155/255 },
		["WARLOCK"] = { 148/255, 130/255, 201/255 },
		["WARRIOR"] = { 199/255, 156/255, 110/255 },
	}
	--Table Loaded single colors---------------------------------
	SVColors["purple"] = {0.50, 0.15, 0.50}
	SVColors["teal"] = {0.15, 0.30, 0.50}
	SVColors["shard"] = {0.8, 0.70, 0.75}
	SVColors["lunar"] = {0.70, 0.75, 0.80}
	SVColors["solar"] = {0.80, 0.80, 0.70}
else
	print(oUF)
	SVColors.oUF_colors = setmetatable({
		tapped = {0.55, 0.57, 0.61},
		disconnected = {0.84, 0.75, 0.65},
		power = setmetatable({
			["MANA"] = {0.1, 0.35, 1},
			["RAGE"] = {0.8, 0.2, 0.1},
			["FUEL"] = {0, 0.55, 0.5},
			["FOCUS"] = {0.8, 0.8, 0.1},
			["ENERGY"] = {0.8, 0.8, 0.1},
			["AMMOSLOT"] = {0.8, 0.6, 0},
			["RUNIC_POWER"] = {0.1, 0.8, 0.8},
			["POWER_TYPE_STEAM"] = {0.55, 0.57, 0.61},
			["POWER_TYPE_PYRITE"] = {0.60, 0.09, 0.17},
			["RUNES"] = {0.55, 0.57, 0.61},
		}, {__index = oUF.colors.power}),
		runes = setmetatable({
				[1] = {.79,.21,.21},
				[2] = {.23,.79,.23},
				[3] = {.21,.55,.73},
				[4] = {.84,.65,.45},
		}, {__index = oUF.colors.runes}),
		reaction = setmetatable({
			[1] = { 222/255, 45/255,  45/255 }, -- Hated
			[2] = { 222/255, 45/255,  45/255 }, -- Hostile
			[3] = { 222/255, 45/255,  45/255 }, -- Unfriendly
			[4] = { 228/255, 217/255, 42/255 }, -- Neutral
			[5] = { 35/255,  215/255, 36/255 }, -- Friendly
			[6] = { 35/255,  215/255, 36/255 }, -- Honored
			[7] = { 35/255,  215/255, 36/255 }, -- Revered
			[8] = { 35/255,  215/255, 36/255 }, -- Exalted	
		}, {__index = oUF.colors.reaction}),
		class = setmetatable({
			["DEATHKNIGHT"] = { 236/255,  50/255,  80/255 },
			["DRUID"]       = { 235/255, 105/255,  5/255 },
			["HUNTER"]      = {  10/255, 215/255,  10/255 },
			["MAGE"]        = {  20/255, 191/255, 255/255 },
			["PALADIN"]     = { 245/255,  40/255, 146/255 },
			["PRIEST"]      = { 248/255, 248/255, 255/255 },
			["ROGUE"]       = { 255/255, 243/255,  32/255 },
			["SHAMAN"]      = {  81/255,  81/255, 255/255 },
			["WARLOCK"]     = { 178/255,  23/255, 226/255 },
			["WARRIOR"]     = { 92/255,  59/255,  31/255 }, 
		}, {__index = oUF.colors.class}),
	}, {__index = oUF.colors})
	--CUSTOM Health gradient for colorSmooth---------------------
	SVColors["LIFE"] = {0.99, 0.01, 0.01, 0.95, 0.95, 0.10, 0.25, 0.98, 0.25}
	--CUSTOM Power gradient for colorSmooth----------------------
	SVColors["POW"] = {0.4, 0.1, 1, 0.2, 0.5, 0.9, 0.05, 0.75, 1}
	SVColors["classy"] = {  ---Used when default raidcolor has been changed
		["DEATHKNIGHT"] = { 196/255, 30/255, 60/255 },
		["DRUID"] = { 255/255, 125/255, 10/255 },
		["HUNTER"] = { 171/255, 214/255, 116/255 },
		["MAGE"] = { 104/255, 205/255, 255/255 },
		["PALADIN"] = { 245/255, 140/255, 186/255 },
		["PRIEST"] = { 212/255, 212/255, 212/255 },
		["ROGUE"] = { 255/255, 243/255, 82/255 },
		["SHAMAN"] = { 41/255, 79/255, 155/255 },
		["WARLOCK"] = { 148/255, 130/255, 201/255 },
		["WARRIOR"] = { 199/255, 156/255, 110/255 },
	}
	--Table Loaded single colors---------------------------------
	SVColors["purple"] = {1, 0.1, 1}
	SVColors["teal"] = {0.1, 0.5, 1}
	SVColors["shard"] = {1, 0.15, 0.90}
	SVColors["lunar"] = {0.20, 0.25, 1}
	SVColors["solar"] = {1, 1, 0.05}
end
--Munglunch's CUSTOM Percentage gradient for Health/Power Values---------------------------------------------------
SVColors["PERC"] = {0.91, 0.31, 0.01, 0.85, 0.93, 0.15, 0.15, 0.95, 0.15}
--Munglunch's CUSTOM AuraWatch colors------------------------------------------------------------------------------
local c = SVColors.classy[SVRoot.myclass]
local svar,svag,svab = (1-(c[1]*0.8)),(1-(c[2]*0.8)),(1-(c[3]*0.8))
SVColors["invert"] = {svar,svag,svab}