local action_anchorw = ((SVMod.Scale(32)*SuperSet.scaleops.abscale)+6)*14
local action_anchorh = ((SVMod.Scale(32)*SuperSet.scaleops.abscale)+6)*4
local action_anchor_move = false 

local action_anchor = CreateFrame("Frame","SVActionAnchor",UIParent)
	action_anchor:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, SVMod.Scale(8))
	action_anchor:SetWidth(action_anchorw)
	action_anchor:SetHeight(action_anchorh)
	action_anchor:SetMovable(true)
	action_anchor:SetClampedToScreen(true)
	action_anchor:SetFrameLevel(15)
	action_anchor:SetFrameLevel(0)
	action_anchor:SetFrameStrata("BACKGROUND")
	action_anchor:SetUserPlaced(true)
	local anchorbg = CreateFrame("Frame","SVActionAnchorBack",action_anchor)
	anchorbg:SetFrameLevel(0)
	anchorbg:SetFrameStrata("BACKGROUND")
	anchorbg:SetAllPoints(action_anchor)
	SVMod.MentaloBG(anchorbg)
	local mentaloframe = CreateFrame("Frame","SVActionAnchorMentalo",action_anchor)
	mentaloframe:SetSize(128,128)
	mentaloframe:SetPoint("BOTTOM",anchorbg,"TOP")
    mentaloframe:SetAlpha(0)
    mentaloframe:Hide()
	local mentalo = mentaloframe:CreateTexture(nil,"OVERLAY")
	mentalo:SetAllPoints(mentaloframe)
	mentalo:SetTexture(SVMedia.mentalo_hand)
	local anchortxt = anchorbg:CreateFontString(nil,"OVERLAY")
	anchortxt:SetFont(SVFonts.super_c, 14, "OUTLINE")
	anchortxt:SetText("Actionbar Anchor")
	anchortxt:SetPoint("TOP",anchorbg,0,-22)
	anchorbg:SetAlpha(0)
	action_anchor:SetScript("OnEnter",function()
			if mentaloframe:IsShown() then
				anchorbg:SetBackdropColor(0.5,0.8,1,0.5)
				UIFrameFadeIn(mentaloframe, 0.3, 0, 1)
				SVMod.MentaloPEWPEW()
			end
		end)
	action_anchor:SetScript("OnLeave",function()
			if mentaloframe:IsShown() then
				anchorbg:SetBackdropColor(0.5,0.8,1,0.15)
				UIFrameFadeOut(mentaloframe, 0.3, 1, 0)
				SVMod.MentaloIDLE()
			end
		end)	

local function MOVESVABAN()
	if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
	if action_anchor_move == false then
		action_anchor_move = true
		local bg = _G["SVActionAnchorBack"]
		local mn = _G["SVActionAnchorMentalo"]
		local fr = _G["SVActionAnchor"]
		UIFrameFadeIn(bg, 0.5, 0, 1)
		mn:Show()
		print(LEVEL_UP_FEATURE)
		fr:SetFrameStrata("DIALOG")
		fr:EnableMouse(true);
		fr:RegisterForDrag("LeftButton"); 
		fr:SetScript("OnDragStart", fr.StartMoving); 
		fr:SetScript("OnDragStop", fr.StopMovingOrSizing);
	elseif action_anchor_move == true then
		local bg = _G["SVActionAnchorBack"]
		local mn = _G["SVActionAnchorMentalo"]
		local fr = _G["SVActionAnchor"]
		fr:SetFrameStrata("BACKGROUND")
		fr:SetFrameLevel(15)
		fr:EnableMouse(false);
		mn:Hide();
		action_anchor_move = false
		UIFrameFadeOut(bg, 0.5, 1, 0)
		print(LOCKED)
	end
end

SLASH_MOVESVABAN1 = "/svmovebars"
SlashCmdList["MOVESVABAN"] = MOVESVABAN

local function RESETSVABAN()
	SVActionAnchor:ClearAllPoints()
	SVActionAnchor:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, SVMod.Scale(4))
end

SLASH_RESETSVABAN1 = "/rabars"
SlashCmdList["RESETSVABAN"] = RESETSVABAN