local anchor_move = false 
-- TIP
local ttinfo = CreateFrame("Frame","TipJar",UIParent)
	ttinfo:SetMovable(true)
	ttinfo:SetClampedToScreen(true) 
	ttinfo:ClearAllPoints()
	ttinfo:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMRIGHT",SVMod.Scale(-300),SVMod.Scale(250))
	ttinfo:SetWidth(100)
	ttinfo:SetHeight(50)
	ttinfo:SetUserPlaced(true)
-- TIP MOVER FRAME
local tanchorbg = CreateFrame("Frame","TipJarBack",ttinfo)
	tanchorbg:SetFrameLevel(0)
	tanchorbg:SetFrameStrata("BACKGROUND")
	tanchorbg:SetAllPoints(ttinfo)
	SVMod.MentaloBG(tanchorbg)
	local tmentaloframe = CreateFrame("Frame","TipJarMentalo",ttinfo)
	tmentaloframe:SetSize(128,128)
	tmentaloframe:SetPoint("BOTTOMRIGHT",tanchorbg,"TOPRIGHT")
    tmentaloframe:SetAlpha(0)
    tmentaloframe:Hide()
	local tmentalo = tmentaloframe:CreateTexture(nil,"OVERLAY")
	tmentalo:SetAllPoints(tmentaloframe)
	tmentalo:SetTexture(SVMedia.mentalo_hand)
	local tanchortxt = tanchorbg:CreateFontString(nil,"OVERLAY")
	tanchortxt:SetFont(SVFonts.super_c, 14, "OUTLINE")
	tanchortxt:SetText("Tooltip Anchor")
	tanchortxt:SetPoint("TOP",tanchorbg,0,-22)
	tanchorbg:SetAlpha(0)
	ttinfo:SetScript("OnEnter",function()
			if tmentaloframe:IsShown() then
				tanchorbg:SetBackdropColor(0.5,0.8,1,0.5)
				UIFrameFadeIn(tmentaloframe, 0.3, 0, 1)
				SVMod.MentaloPEWPEW()
			end
		end)
	ttinfo:SetScript("OnLeave",function()
			if tmentaloframe:IsShown() then
				tanchorbg:SetBackdropColor(0.5,0.8,1,0.15)
				UIFrameFadeOut(tmentaloframe, 0.3, 1, 0)
				SVMod.MentaloIDLE()
			end
		end)	
-- ROLL
local rtinfo = CreateFrame("Frame","RollPin",UIParent)
	rtinfo:SetMovable(true)
	rtinfo:SetClampedToScreen(true) 
	rtinfo:ClearAllPoints()
	rtinfo:SetPoint("CENTER",UIParent,"CENTER",SVMod.Scale(-175),SVMod.Scale(-105))
	rtinfo:SetWidth(100)
	rtinfo:SetHeight(50)
	rtinfo:SetUserPlaced(true)
-- ROLL MOVER FRAME
local ranchorbg = CreateFrame("Frame","RollPinBack",rtinfo)
	ranchorbg:SetFrameLevel(0)
	ranchorbg:SetFrameStrata("BACKGROUND")
	ranchorbg:SetAllPoints(rtinfo)
	SVMod.MentaloBG(ranchorbg)
	local rmentaloframe = CreateFrame("Frame","RollPinMentalo",rtinfo)
	rmentaloframe:SetSize(128,128)
	rmentaloframe:SetPoint("BOTTOMRIGHT",ranchorbg,"TOPRIGHT")
    rmentaloframe:SetAlpha(0)
    rmentaloframe:Hide()
	local rmentalo = rmentaloframe:CreateTexture(nil,"OVERLAY")
	rmentalo:SetAllPoints(rmentaloframe)
	rmentalo:SetTexture(SVMedia.mentalo_hand)
	local ranchortxt = ranchorbg:CreateFontString(nil,"OVERLAY")
	ranchortxt:SetFont(SVFonts.super_c, 14, "OUTLINE")
	ranchortxt:SetText("Roll Anchor")
	ranchortxt:SetPoint("TOP",ranchorbg,0,-22)
	ranchorbg:SetAlpha(0)
	rtinfo:SetScript("OnEnter",function()
			if rmentaloframe:IsShown() then
				ranchorbg:SetBackdropColor(0.5,0.8,1,0.5)
				UIFrameFadeIn(rmentaloframe, 0.3, 0, 1)
				SVMod.MentaloPEWPEW()
			end
		end)
	rtinfo:SetScript("OnLeave",function()
			if rmentaloframe:IsShown() then
				ranchorbg:SetBackdropColor(0.5,0.8,1,0.15)
				UIFrameFadeOut(rmentaloframe, 0.3, 1, 0)
				SVMod.MentaloIDLE()
			end
		end)
-- LOOT	
local ltinfo = CreateFrame("Frame","LootWin",UIParent)
	ltinfo:SetMovable(true)
	ltinfo:SetClampedToScreen(true) 
	ltinfo:ClearAllPoints()
	ltinfo:SetPoint("CENTER",UIParent,"CENTER",SVMod.Scale(-300),SVMod.Scale(-105))
	ltinfo:SetWidth(100)
	ltinfo:SetHeight(50)
	ltinfo:SetUserPlaced(true)
-- LOOT MOVER FRAME
local lanchorbg = CreateFrame("Frame","LootWinBack",ltinfo)
	lanchorbg:SetFrameLevel(0)
	lanchorbg:SetFrameStrata("BACKGROUND")
	lanchorbg:SetAllPoints(ltinfo)
	SVMod.MentaloBG(lanchorbg)
	local lmentaloframe = CreateFrame("Frame","LootWinMentalo",ltinfo)
	lmentaloframe:SetSize(128,128)
	lmentaloframe:SetPoint("BOTTOMRIGHT",lanchorbg,"TOPRIGHT")
    lmentaloframe:SetAlpha(0)
    lmentaloframe:Hide()
	local lmentalo = lmentaloframe:CreateTexture(nil,"OVERLAY")
	lmentalo:SetAllPoints(lmentaloframe)
	lmentalo:SetTexture(SVMedia.mentalo_hand)
	local lanchortxt = lanchorbg:CreateFontString(nil,"OVERLAY")
	lanchortxt:SetFont(SVFonts.super_c, 14, "OUTLINE")
	lanchortxt:SetText("Loot Anchor")
	lanchortxt:SetPoint("TOP",lanchorbg,0,-22)
	lanchorbg:SetAlpha(0)
	ltinfo:SetScript("OnEnter",function()
			if lmentaloframe:IsShown() then
				lanchorbg:SetBackdropColor(0.5,0.8,1,0.5)
				UIFrameFadeIn(lmentaloframe, 0.3, 0, 1)
				SVMod.MentaloPEWPEW()
			end
		end)
	ltinfo:SetScript("OnLeave",function()
			if lmentaloframe:IsShown() then
				lanchorbg:SetBackdropColor(0.5,0.8,1,0.15)
				UIFrameFadeOut(lmentaloframe, 0.3, 1, 0)
				SVMod.MentaloIDLE()
			end
		end)

local function ANCHORSAWAY()
	if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
	if anchor_move == false then
		anchor_move = true
		TipJarMentalo:Show()
		RollPinMentalo:Show()
		LootWinMentalo:Show()
		UIFrameFadeIn(TipJarBack, 0.5, 0, 1)
		UIFrameFadeIn(RollPinBack, 0.5, 0, 1)
		UIFrameFadeIn(LootWinBack, 0.5, 0, 1)
		print(LEVEL_UP_FEATURE)
		print(LEVEL_UP_FEATURE)
		print(LEVEL_UP_FEATURE)
		TipJar:SetFrameStrata("DIALOG")
		TipJar:EnableMouse(true);
		TipJar:RegisterForDrag("LeftButton"); 
		TipJar:SetScript("OnDragStart", TipJar.StartMoving); 
		TipJar:SetScript("OnDragStop", TipJar.StopMovingOrSizing);
		---
		RollPin:SetFrameStrata("DIALOG")
		RollPin:EnableMouse(true);
		RollPin:RegisterForDrag("LeftButton"); 
		RollPin:SetScript("OnDragStart", RollPin.StartMoving); 
		RollPin:SetScript("OnDragStop", RollPin.StopMovingOrSizing);
		---
		LootWin:SetFrameStrata("DIALOG")
		LootWin:EnableMouse(true);
		LootWin:RegisterForDrag("LeftButton"); 
		LootWin:SetScript("OnDragStart", LootWin.StartMoving); 
		LootWin:SetScript("OnDragStop", LootWin.StopMovingOrSizing);
	elseif anchor_move == true then
		TipJarMentalo:Hide()
		RollPinMentalo:Hide()
		LootWinMentalo:Hide()
		TipJar:SetFrameStrata("BACKGROUND")
		TipJar:EnableMouse(false);
		RollPin:SetFrameStrata("BACKGROUND")
		RollPin:EnableMouse(false);
		LootWin:SetFrameStrata("BACKGROUND")
		LootWin:EnableMouse(false);
		anchor_move = false
		UIFrameFadeOut(TipJarBack, 0.5, 1, 0)
		UIFrameFadeOut(RollPinBack, 0.5, 1, 0)
		UIFrameFadeOut(LootWinBack, 0.5, 1, 0)
		print(LOCKED)
	end
end

SLASH_ANCHORSAWAY1 = "/svanchor"
SlashCmdList["ANCHORSAWAY"] = ANCHORSAWAY

local function RESETSVANCHORS()
	TipJar:ClearAllPoints()
	RollPin:ClearAllPoints()
	LootWin:ClearAllPoints()
	TipJar:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMRIGHT",SVMod.Scale(-300),SVMod.Scale(250))
	RollPin:SetPoint("CENTER",UIParent,"CENTER",SVMod.Scale(-175),SVMod.Scale(-105))
	LootWin:SetPoint("CENTER",UIParent,"CENTER",SVMod.Scale(175),SVMod.Scale(-105))
end

SLASH_RESETSVANCHORS1 = "/ranchors"
SlashCmdList["RESETSVANCHORS"] = RESETSVANCHORS