if ((SVRoot.client == "zhTW") or (SVRoot.client == "zhCN") or (SVRoot.client == "koKR") or (SVRoot.client == "ruRU")) and (SuperSet.load.overridelocal ~= true) then return end
if SuperSet["load"].replacefont ~= true then return end
--------------------------------------------------------------------------------
local SetFont = function(obj, font, size, style, r, g, b, sr, sg, sb, sox, soy)
	obj:SetFont(font, size, style)
	if sr and sg and sb then obj:SetShadowColor(sr, sg, sb) end
	if sox and soy then obj:SetShadowOffset(sox, soy) end
	if r and g and b then obj:SetTextColor(r, g, b)
	elseif r then obj:SetAlpha(r) end
end

local FixTitleFont = function()
	for _,butt in pairs(PlayerTitlePickerScrollFrame.buttons) do
		butt.text:SetFontObject(GameFontHighlightSmallLeft)
	end
end

local abcchange = function(self)
	
	local NORMAL     = SVFonts.font
	local INPUT     = SVFonts.font_s
	local COMBAT     = SVFonts.damage
	local NUMBER     = SVFonts.super_c
	local BIGNUMBER  = SVFonts.numbers
	local ZONE	     = SVFonts.super
	local SUBZONE	 = SVFonts.super_c
	
	UIDROPDOWNMENU_DEFAULT_TEXT_HEIGHT = 12
	CHAT_FONT_HEIGHTS = {10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20}

	UNIT_NAME_FONT     = NORMAL
	NAMEPLATE_FONT     = NORMAL
	DAMAGE_TEXT_FONT   = COMBAT
	STANDARD_TEXT_FONT = NORMAL

	-- Base fonts
	SetFont(GameTooltipHeader,                  NORMAL, 14)
	SetFont(NumberFont_OutlineThick_Mono_Small, NUMBER, 12, "OUTLINE")
	SetFont(NumberFont_Outline_Huge,            BIGNUMBER, 14, "THICKOUTLINE", 1,1,1,0,0,0)
	SetFont(NumberFont_Outline_Large,           NUMBER, 12, "OUTLINE")
	SetFont(NumberFont_Outline_Med,             NUMBER, 12, "OUTLINE")
	SetFont(NumberFont_Shadow_Med,              INPUT, 12)
	SetFont(NumberFont_Shadow_Small,            NORMAL, 13)
	SetFont(QuestFont,                          NORMAL, 13)
	SetFont(QuestFont_Large,                    NORMAL, 14)
	SetFont(QuestFont_Shadow_Huge,				SUBZONE, 20)
	SetFont(SystemFont_Large,                   NORMAL, 14)
	SetFont(SystemFont_Med1,                    NORMAL, 13)
	SetFont(SystemFont_Med3,                    NORMAL, 13)
	SetFont(SystemFont_OutlineThick_Huge2,      NORMAL, 14, "THICKOUTLINE")
	SetFont(SystemFont_Outline_Small,           NORMAL, 13, "OUTLINE")
	SetFont(SystemFont_Shadow_Large,            NORMAL, 14)
	SetFont(SystemFont_Shadow_Med1,             NORMAL, 13)
	SetFont(SystemFont_Shadow_Med3,             NORMAL, 22)
	SetFont(SystemFont_Shadow_Outline_Huge2,    NORMAL, 16, "OUTLINE")
	SetFont(SystemFont_Shadow_Small,            INPUT, 12)
	SetFont(GameFontNormalSmall,            	NORMAL, 13, nil, 1,1,1,0,0,0)

	SetFont(SystemFont_Small,                   NORMAL, 13)
	SetFont(SystemFont_Tiny,                    NORMAL, 10)
	SetFont(FriendsFont_Normal,                 NORMAL, 13)
	SetFont(FriendsFont_Small,                  NORMAL, 13)
	SetFont(FriendsFont_Large,                  NORMAL, 14)
	SetFont(FriendsFont_UserText,               INPUT, 12)
	SetFont(Tooltip_Med,                        NORMAL, 13)
	SetFont(Tooltip_Small,                      NORMAL, 13)
	SetFont(CombatTextFont,                     COMBAT, 50, "OUTLINE") -- number here just increase the font quality.
	SetFont(SystemFont_Shadow_Huge3,            COMBAT, 50, "OUTLINE") -- number here just increase the font quality.
	SetFont(SystemFont_Shadow_Huge1,            NORMAL, 20, "THINOUTLINE")
	SetFont(ZoneTextString,                     ZONE, 32, "OUTLINE")
	SetFont(SubZoneTextString,                  SUBZONE, 20, "THINOUTLINE")
	SetFont(PVPInfoTextString,                  SUBZONE, 20, "THINOUTLINE")
	SetFont(PVPArenaTextString,                 SUBZONE, 20, "THINOUTLINE")
	
	--------------------------------------------------------------------------------------------------------------------------	
	--------------Jasje's Zone Text Script------------------------------------------------------------------------------------
	local pvpTextString = PVPInfoTextString
	
	ZoneTextFrame:ClearAllPoints();									      --Location of Zone text
	ZoneTextFrame:SetPoint("TOP", UIParent, "TOP", 0, -80);
	ZoneTextFrame:SetScale(1.1);
	 
	SubZoneTextFrame:ClearAllPoints();									  --Location of Subzone Text
	SubZoneTextFrame:SetPoint("TOP", UIParent, "TOP", 0, -100);
	SubZoneTextFrame:SetScale(1.1);
	 
	ZoneTextString:SetTextColor(1, 1, 1);								  --Color of text
	SubZoneTextString:SetTextColor(1, 1, 1);
	pvpTextString:SetTextColor(1, 1, 1);
	 
	ZoneTextString:SetAlpha(0.5);                                         --Alpha of text
	SubZoneTextString:SetAlpha(0.5);
	
	PVPInfoTextString:SetText("");

	hooksecurefunc("PlayerTitleFrame_UpdateTitles", FixTitleFont)
	FixTitleFont()
	self:UnregisterAllEvents()
	self:Hide()
	SetFont = nil
end

local abc = CreateFrame("Frame")
abc:RegisterEvent("PLAYER_ENTERING_WORLD")
abc:SetScript("OnEvent",abcchange)