----------------------------------------------------------------------------------------------------
-------------[[//||\\-------------------------LOCALS--------------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
local mk_anim
local colors = SVColors.oUF_colors
if SVRoot.myclass == "DEATHKNIGHT" or SVRoot.myclass == "WARRIOR" or SVRoot.myclass == "ROGUE" then 
	mk_anim = false
else
	mk_anim = true
end
----------------------------------------------------------------------------------------------------
-------------[[//||\\---------------------MAKIN A SHAMMY----------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
-- Player Totems
local mk_totems = function(self)
	if (SVRoot.myclass ~= "SHAMAN") then return nil end
	local lol_totem_f = CreateFrame("Frame",nil,self)
		lol_totem_f:SetPoint("BOTTOMLEFT",self,"TOPLEFT",2,2)
		lol_totem_f:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT",-2,2)
		lol_totem_f:SetHeight(10)
		lol_totem_f:SetBackdrop({bgFile = SVMedia.blank})
		lol_totem_f:SetBackdropColor(0,0,0,0.8)
		SVUnit.mkButton(lol_totem_f,-1)
	local lol_totem = CreateFrame("Frame",nil,self)
			
	for i = 1, 4 do
		local totWidth = (SVUnit.unitW-26)/4
		lol_totem[i] = CreateFrame("StatusBar", nil, lol_totem)
		lol_totem[i]:SetSize(totWidth,26)
		lol_totem[i]:SetStatusBarTexture(SVMedia.neonbar)
		lol_totem[i]:SetMinMaxValues(0, 1)
		lol_totem.Destroy = true
			
		if i == 1 then
			lol_totem[i]:SetPoint("LEFT",lol_totem,"LEFT",4,0)
		else
			lol_totem[i]:SetPoint("LEFT",lol_totem[i-1],"RIGHT",4,0)
		end
				
		lol_totem[i].bg = lol_totem[i]:CreateTexture(nil, "BORDER")
		lol_totem[i].glow = SVUnit.frame(lol_totem[i],nil,0)
		lol_totem[i].glow:SetPoint("TOPLEFT", lol_totem[i], "TOPLEFT", -4, -14)
		lol_totem[i].glow:SetPoint("BOTTOMRIGHT", lol_totem[i], "BOTTOMRIGHT", 4, 14)
	end
		lol_totem[1]:SetPoint('LEFT', lol_totem_f, 'LEFT', 2, 0)
		
	self.TotemBar = lol_totem
end
SVUnit.MakeEmTotems = mk_totems
----------------------------------------------------------------------------------------------------
-------------[[//||\\------------------MAKIN LOCKS AND PALLYS-----------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
SVUnit.UpdateShards = function(self, event, unit, powerType)
	if(self.unit ~= unit or (powerType and powerType ~= 'SOUL_SHARDS')) then return end
	local num = UnitPower(unit, SPELL_POWER_SOUL_SHARDS)
	for i = 1, SHARD_BAR_NUM_SHARDS do
		if(i <= num) then
			self.SoulShards[i]:SetAlpha(1)
		else
			self.SoulShards[i]:SetAlpha(.2)
		end
	end
end
SVUnit.UpdateHoly = function(self, event, unit, powerType)
	if(self.unit ~= unit or (powerType and powerType ~= 'HOLY_POWER')) then return end
	local num = UnitPower(unit, SPELL_POWER_HOLY_POWER)
	for i = 1, MAX_HOLY_POWER do
		if(i <= num) then
			self.HolyPower[i]:SetAlpha(1)
		else
			self.HolyPower[i]:SetAlpha(.2)
		end
	end
end
local mkshards = function(self,class)
	if SVRoot.myclass ~= class then return end
		local r,g,b
		if SVRoot.myclass == 'WARLOCK' then
			r,g,b = unpack(SVColors.shard)
		elseif SVRoot.myclass == 'PALADIN' then
			r,g,b = unpack(SVColors.solar)
		end
		local shards = CreateFrame("Frame",nil,self)
		shards:SetPoint("BOTTOMLEFT",self,"TOPLEFT",2,2)
		shards:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT",-2,2)
		shards:SetHeight(10)
		shards:SetBackdrop({bgFile = SVMedia.bar})
		shards:SetBackdropColor(0,0,0,0.8)
		SVUnit.mkButton(shards,-1)
		local shWidth = (SVUnit.unitW-18)/3
		for i=1,3 do
			local s = shards:CreateTexture(nil,"OVERLAY")
			s:SetSize(shWidth,26)
			s:SetTexture(SVMedia.neonbar)
			s:SetVertexColor(r*.8,g*.8,b*.8)
			if i == 1 then
				s:SetPoint("LEFT",4,0)
			else
				s:SetPoint("LEFT",shards[i-1],"RIGHT",4,0)
			end
			local glow = CreateFrame ("Frame",nil,shards)
			SVMod.setbackdrop(glow)
			SVUnit.mkButton(glow)
			glow:SetPoint("TOPLEFT",s,-4,-14)
			glow:SetPoint("BOTTOMRIGHT",s,4,14)
			glow:SetFrameLevel(0)	
			shards[i] = s
		end
	if class == "WARLOCK" then
		self.SoulShards = shards
	elseif class == "PALADIN" then
		self.HolyPower = shards
	end
end
SVUnit.IJustSharded = mkshards
----------------------------------------------------------------------------------------------------
-------------[[//||\\---------------------MAKIN A DROOD-----------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
SVUnit.EclipseDisplay = function(self, login)
	if SVRoot.myclass ~= "DRUID" then return end
	local eb = self.EclipseBar
	local txt = self.EclipseBar.Text
	
	if login then
		eb:SetScript("OnUpdate", nil)
	end
	
	if eb:IsShown() then
		txt:Show()
	else
		txt:Hide()
	end
end
--Eclipse 
SVUnit.EclipseDirection = function(self)
	if SVRoot.myclass ~= "DRUID" then return end
	local sundial = GetEclipseDirection()
	if ( sundial == "sun" ) then
			self.Text:SetTextColor(unpack(SVColors.solar))
			self.Icon:SetTexture(SVMedia.sunicon)
			self.Icon:SetAlpha(0.9)
	elseif ( sundial == "moon" ) then
			self.Text:SetTextColor(unpack(SVColors.lunar))
			self.Icon:SetTexture(SVMedia.moonicon)
			self.Icon:SetAlpha(0.9)
	else
			self.Text:SetTextColor(1,1,1,0.5)
			self.Icon:SetAlpha(0)
	end
end
local mkeclipse = function(self)
	if SVRoot.myclass ~= "DRUID" then return end
	local eclipseBar = CreateFrame('Frame', nil, self)
		eclipseBar:SetPoint("BOTTOMLEFT",self,"TOPLEFT",32,4)
		eclipseBar:SetSize(SVUnit.unitW-36,10)
		eclipseBar:SetFrameStrata("MEDIUM")
		eclipseBar:SetBackdropColor(0,0,0,0)
		eclipseBar:SetFrameLevel(8)
		eclipseBar:SetScript("OnShow", function() SVUnit.EclipseDisplay(self, false) end)
		eclipseBar:SetScript("OnUpdate", function() SVUnit.EclipseDisplay(self, true) end) -- just forcing 1 update on login for buffs/shadow/etc.
		eclipseBar:SetScript("OnHide", function() SVUnit.EclipseDisplay(self, false) end)
		local ebHight = ((eclipseBar:GetHeight()) + 16) 
		
		local lunarBar = CreateFrame('StatusBar', nil, eclipseBar)
		lunarBar:SetPoint('LEFT', eclipseBar, 'LEFT', 0, 0)
		lunarBar:SetSize(eclipseBar:GetWidth(), ebHight)
		lunarBar:SetStatusBarTexture(SVMedia.neonbar)
		lunarBar:SetStatusBarColor(unpack(SVColors.lunar))
		lunarBar:SetFrameLevel(eclipseBar:GetFrameLevel() - 2)
		eclipseBar.LunarBar = lunarBar

		local solarBar = CreateFrame('StatusBar', nil, eclipseBar)
		solarBar:SetPoint('LEFT', lunarBar:GetStatusBarTexture(), 'RIGHT', 0, 0)
		solarBar:SetSize(eclipseBar:GetWidth(), ebHight)
		solarBar:SetStatusBarTexture(SVMedia.neonbar)
		solarBar:SetStatusBarColor(unpack(SVColors.solar))
		solarBar:SetFrameLevel(eclipseBar:GetFrameLevel() - 2)
		eclipseBar.SolarBar = solarBar
		
		local ebDatabox = CreateFrame ("Frame",nil,eclipseBar)
		SVMod.setbackdrop(ebDatabox)
		SVUnit.mkButton(ebDatabox)
		ebDatabox:SetSize(30,18)
		ebDatabox:SetPoint("RIGHT",eclipseBar,"LEFT",-4,0)
		ebDatabox:SetFrameLevel(eclipseBar:GetFrameLevel() - 4)
		
		local sunmoon = ebDatabox:CreateTexture(nil,"OVERLAY")
		sunmoon:SetHeight(36)
		sunmoon:SetWidth(36)
		sunmoon:SetPoint("CENTER",ebDatabox,"CENTER",0,4)
		sunmoon:SetTexture(SVMedia.sunicon)
		sunmoon:SetAlpha(0)
		
		local eclipseBarText = eclipseBar:CreateFontString(nil, 'OVERLAY')
		eclipseBarText:SetPoint("BOTTOMLEFT", ebDatabox, "BOTTOMLEFT" ,0 ,4)
		eclipseBarText:SetFont(SVFonts.super_c, 12, "THICKOUTLINE")
		eclipseBarText:SetTextColor(1,1,1,0.5)
		self:Tag(eclipseBarText, '[pereclipse]%')
		
		local bg = CreateFrame ("Frame",nil,eclipseBar)
		SVMod.setbackdrop(bg)
		SVUnit.mkButton(bg)
		bg:SetPoint("TOPLEFT",-4,4)
		bg:SetPoint("BOTTOMRIGHT",4,-4)
		bg:SetFrameLevel(eclipseBar:GetFrameLevel() - 6)	

		eclipseBar.PostUpdatePower = SVUnit.EclipseDirection
		
	self.EclipseBar = eclipseBar 
	self.EclipseBar.Text = eclipseBarText
	self.EclipseBar.Icon = sunmoon
end
SVUnit.UpdateDruidMana = function(self)
	if SVRoot.myclass ~= "DRUID" then return end
	if self.unit ~= "player" then return end
	local num, str = UnitPowerType("player")
	local fl = self.Power.flashlow
	if num ~= 0 then
		local min = UnitPower("player", 0)
		local max = UnitPowerMax("player", 0)
		local percMana = min / max * 100
		mk_anim = false
		if percMana <= SVConfig.workings.druidmana then
			if not(fl.anim:IsPlaying()) then
				fl.anim:Finish()
				fl:SetAlpha(1)
			end
		else
			if fl.anim:IsPlaying() then
				fl.anim:Finish()
				fl:SetAlpha(0)
			end
		end
		if min ~= max then
			if self.Power.value:GetText() then
				self.DruidMana:SetPoint("RIGHT", self.Power.value, "LEFT", -6, 0)
				self.DruidMana:SetFormattedText("%d%%|r", floor(min / max * 100))
			else
				self.DruidMana:SetPoint("RIGHT", self.Health.value, "LEFT", -6, 0)
				self.DruidMana:SetFormattedText("%d%%", floor(min / max * 100))
			end
		else
			self.DruidMana:SetText()
		end
		self.DruidMana:SetAlpha(1)
	else
		self.DruidMana:SetAlpha(0)
		mk_anim = true
	end
end
-- DruidMana
local mk_druid = function(self)
	if SVRoot.myclass ~= "DRUID" then return end
	CreateFrame("Frame"):SetScript("OnUpdate", function() SVUnit.UpdateDruidMana(self) end)
	local DruidMana = SVUnit.SuperText(self.data, SVFonts.numbers, 12, "THINOUTLINE")
	DruidMana:SetTextColor(0.1,0.5,0.8)
	self.DruidMana = DruidMana
	mkeclipse(self)
end
SVUnit.OhGodCyclone = mk_druid
----------------------------------------------------------------------------------------------------
-------------[[//||\\---------------------MAKIN A LOLKNIGHT-------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
local mk_runes = function(self) 
	if SVRoot.myclass ~= "DEATHKNIGHT" then return nil end	
	local runes = CreateFrame("Frame",nil,self)
	runes:SetPoint("BOTTOMLEFT",self,"TOPLEFT",1,2)
	runes:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT",-1,2)
	runes:SetHeight(10)
	runes:SetBackdrop({bgFile = SVMedia.bar})
	runes:SetBackdropColor(0,0,0)
	SVUnit.mkButton(runes,-1)	
	for i = 1, 6 do
		local rWidth = (SVUnit.unitW-30)/6
		runes[i] = CreateFrame('StatusBar', nil, runes)
		runes[i]:SetStatusBarTexture(SVMedia.neonbar)
		runes[i]:SetSize(rWidth,26)
		if i == 1 then 
			runes[i]:SetPoint("LEFT",4,0)
		else	
			runes[i]:SetPoint('LEFT', runes[i-1], 'RIGHT', 4, 0)
		end
		runes[i].glow = CreateFrame ("Frame",nil,runes[i])
		SVMod.setbackdrop(runes[i].glow)
		SVUnit.mkButton(runes[i].glow)
		runes[i].glow:SetPoint("TOPLEFT",-4,-14)
		runes[i].glow:SetPoint("BOTTOMRIGHT",4,14)
		runes[i].glow:SetFrameLevel(0)	
	end
	self.Runes = runes
end
SVUnit.LOLFiftyFive = mk_runes
----------------------------------------------------------------------------------------------------
-------------[[//||\\---------------------MAKIN A NINJA-----------------------//||\\]]--------------
----------------------------------------------------------------------------------------------------
SVUnit.UpdateCPoints = function(self, event, unit)
	if not(SVRoot.myclass=="ROGUE" or SVRoot.myclass=="DRUID") then return end
	if unit == PlayerFrame.unit and unit ~= self.CPoints.unit then
		self.CPoints.unit = unit
	end
end
local mk_cc_points = function(self,unit)
	if not(SVRoot.myclass=="ROGUE" or SVRoot.myclass=="DRUID") then return end
	if SuperSet.unitops.fancycp ~= true then
		local cpoints = self.data:CreateFontString(nil, "OVERLAY")
		cpoints:SetFont(SVFonts.super, 22, "THICKOUTLINE")
		cpoints:SetTextColor(1,1,0.2)
		cpoints:SetShadowOffset(1, -1)
		cpoints:SetPoint("RIGHT",self.Health,"RIGHT",SVMod.Scale(-12),0)
		self:Tag(cpoints, '[cpoints]')
	else
		-- The Fancy Combo Points
		local CPoints = {}
		CPoints.unit = PlayerFrame.unit
		for i = 1, 5 do
			local scaling = ((10*i)+20)-(2*i)
			CPoints[i] = self.data:CreateTexture(nil, "OVERLAY")
			CPoints[i]:SetHeight(SVMod.Scale(scaling))
			CPoints[i]:SetWidth(SVMod.Scale(scaling))
			--CPoints[i]:SetTexture(SVMedia.cpicon)
			local j = i+1
			SVMod.MapDraw(CPoints[i],"ACTIONS",j)
			if i == 1 then
				CPoints[i]:SetPoint("CENTER",UIParent,"CENTER",0,SVMod.Scale(-120))
				CPoints[i]:SetVertexColor(1,0.2,0.1,0.7)
			else
				CPoints[i]:SetPoint("BOTTOMLEFT", CPoints[i-1], "TOPRIGHT", SVMod.Scale(i*-3), SVMod.Scale(i*-10))
			end
		end
		CPoints[2]:SetVertexColor(1,0.2,0.1,0.7)
		CPoints[3]:SetVertexColor(1,0.6,0.3,0.7)
		CPoints[4]:SetVertexColor(1,1,0.2,0.7)
		CPoints[5]:SetVertexColor(0.1,1,0.2,0.7)
		self.CPoints = CPoints
		self:RegisterEvent("UNIT_COMBO_POINTS", SVUnit.UpdateCPoints)
	end
end
SVUnit.ComboBreaker = mk_cc_points