
--[[--------------------------------------------------------------------
        .     ..    ,~,..   .I7.  .  IO:                    
 . .          ?O=   +M8?,.  ID87.. :$OD+..   ,==     .      
  .   ~?,     788$ .7$,$8: +N,,DZ ~8I.78=.  $NNI            
      +NM$=,. $Z ZO=O?. ?DIM= .:NO8+  =D7~7N$?8:,.          
      ,$I=?$ZI8$  +8D,.  :$+....=Z~ . .ZD$+,.8Z?+           
      .I$, .,+O~ . ,:.......,.......   ...  IDI?.,=+~       
~Z7?+=~+O=      .....,,,,,,,,,,........  . .D8OOZZND=       
.+ND??$OD+.   .....:::::::::::,.           .,,..,O8?+~.     
  .IDI.   ..    ...:~::::::::~,.          .  ..~D8II=.      
    .$N$: . .  ....,~~~~~~~~~~,.            ..~DM8OI:.      
.,+OND$:..       . .:~~~~~~~~~,.            .....:IZDNM8I.  
$M8=,   .. .. . .. ..~~~~~~=~=,.            .    .,:+$DOI,. 
.~$8+  .         ....,=~==~===:.           ..  :$88Z$$7I=,. 
   ~D8:.          ....~=======:.            .?MM87II?+:     
   .?DI. . .    . . ..,=======:.         ....+II$ZO$+:.     
  ~D$,..   ..     .. ..:===+=+:.            .,,,,,~+7DN8$~. 
,ZM$=+????,         . .,======,. .   .      8MMNDNNDDDD888~ 
,+==I$ZNNI,  .  ..   ......,,,.. .    .,.   .~ZN?:~~~~~~::,.
   ,~7N7.....      . . .:=++??+=. . ..,8M8ZI=,,+N$,.        
  :7Z7++IZ$,.   ..  . .~?++++++?, .. . ?D$I$O88ZOMM7,       
.7MMND8O8N=  ~O, ..  ..~+????+=,....   .$O:...,~+I77~.      
.$?=:~=$8=,+OMN,  ..... .,:,,.  . ,Z8?, :D7..     .,:,  .   
    .,IO?$8O$D?  7O~ . ,I~.  ,?,..=8ZZ8$.+N= .              
    .?M8D7II$D:=MND+..?NMI.  ~NM7,?D$= 7N?8D,               
   ,ZMZ+=?+:ODZO$787I887ZO:  =N$ZZ88I~  ,IOMO. .            
   ,+:.~=,.,MI,II~ZMI77?=8~  +D7=.:+I,    .~I+              
   .  .. .    ,=  ..,?~. $7. ID7~   ..       .,             
              .   . ..   +D,.$8I:        .                  
   . .                   .8+.OOI.   ..                      
                          $8,8ZI             .              
                          ~N=DZ?             .              
           .          .    DZN$+   ..                       
                           ?MN7=                            
                         ...MO?~                            
                            $$~:                            
                            ..,.                            
                               .     
                            _____       _                  _____ 
  /\/\  _   _ _ __   __ _  /__   \_   _| | __ ____  /\ /\  \_   \
 /    \| | | | '_ \ / _` |   / /\/ | | | |/ /|_  / / / \ \  / /\/
/ /\/\ \ |_| | | | | (_| |  / /  | |_| |   <  / /  \ \_/ /\/ /_  
\/    \/\__,_|_| |_|\__, |  \/    \__,_|_|\_\/___|  \___/\____/  
                    |___/                                        
----------------------------------------------------------------------]]
--MICROMENU -----------------------------------------------------
--LOCAL SHIZZ
local mmX,mmY
local menuH = SVMod.Scale(300)*SuperSet.scaleops.mmscale
local menuW = SVMod.Scale(28)*SuperSet.scaleops.mmscale
local MMSP = 2
local MMBS = (menuH-(MMSP*10))/10
local cColor
local r, g, b, r2, g2, b2
local dCDB = SVColors["classy"]
local dColor = dCDB[SVRoot.myclass]
local blank = SVMedia.blank
local glowTex = SVMedia.glow
if (SuperSet.colortheme == 3) then
	cColor = SVColors.oUF_colors.class[SVRoot.myclass]
	r, g, b = dColor[1],dColor[2],dColor[3]
	r2, g2, b2 = cColor[1],cColor[2],cColor[3]
else
	cColor = SVColors.oUF_colors.class[SVRoot.myclass]
	r, g, b = cColor[1],cColor[2],cColor[3]
	r2, g2, b2 = (r*0.6), (g*0.6), (b*0.6)
end
------------------------------------------------------------------
local slider = function (self,k,x,y)
	self.slide = self:CreateAnimationGroup("Move_In")
	self.slide.in_a = self.slide:CreateAnimation("Translation")
	self.slide.in_a:SetDuration(0)
	self.slide.in_a:SetOrder(1)
	self.slide.in_b = self.slide:CreateAnimation("Translation")
	self.slide.in_b:SetDuration(.3)
	self.slide.in_b:SetOrder(2)
	self.slide.in_b:SetSmoothing("OUT")
	self.slide_out = self:CreateAnimationGroup("Move_Out")
	self.slide_out.b = self.slide_out:CreateAnimation("Translation")
	self.slide_out.b:SetDuration(.3)
	self.slide_out.b:SetOrder(1)
	self.slide_out.b:SetSmoothing("IN")
	self.slide_out.b:SetStartDelay(5)
	self.slide.in_a:SetOffset(x,y)
	self.slide.in_b:SetOffset(-x,-y)
	self.slide_out.b:SetOffset(x,y)	
	if k then self.slide_out:SetScript("OnFinished",function() self:Hide() end) end
end
-----------------------------------------------let's create the panels first--
-- main menu bar
local minfoa = CreateFrame ("Frame","SVMenuBarAnchor",UIParent)
	minfoa:SetPoint("TOPLEFT",UIParent,"TOPLEFT",5,SVMod.Scale(-40))
	minfoa:SetMovable(true)
	minfoa:SetClampedToScreen(true)
	minfoa:SetWidth(menuW)
	minfoa:SetHeight(menuH)
	minfoa:SetFrameStrata("BACKGROUND")
	minfoa:SetFrameLevel(2)
	minfoa:SetUserPlaced(true)

local anchorbg = CreateFrame("Frame","SVMenuBarAnchorBack",minfoa)
	anchorbg:SetFrameLevel(0)
	anchorbg:SetFrameStrata("BACKGROUND")
	anchorbg:SetAllPoints(minfoa)
	SVMod.MentaloBG(anchorbg)
	local mentaloframe = CreateFrame("Frame","SVMenuBarAnchorMentalo",minfoa)
	mentaloframe:SetSize(128,128)
	mentaloframe:SetPoint("LEFT",minfoa,"LEFT")
    mentaloframe:SetAlpha(0)
    mentaloframe:Hide()
	local mentalo = mentaloframe:CreateTexture(nil,"OVERLAY")
	mentalo:SetAllPoints(mentaloframe)
	mentalo:SetTexture(SVMedia.mentalo_hand)
	local anchortxt = anchorbg:CreateFontString(nil,"OVERLAY")
	anchortxt:SetFont(SVFonts.super_c, 14, "OUTLINE")
	anchortxt:SetText("Menubar Anchor")
	anchortxt:SetPoint("TOP",anchorbg,0,-22)
	anchorbg:SetAlpha(0)
			
local minfo = CreateFrame ("Frame","SVMenuBar",SVMenuBarAnchor)
	minfo:SetPoint("TOP",SVMenuBarAnchor,"TOP")
	minfo:SetWidth(menuW)
	minfo:SetHeight(menuH)
	minfo:SetFrameStrata("HIGH")
	minfo:SetFrameLevel(0)
	mmX = (SVMenuBarAnchor:GetRight() + (menuW*2))
	mmY = (SVMenuBarAnchor:GetBottom() + (menuH*2))
	slider(SVMenuBar,true,mmX,-mmY)
	SVMenuBar:Hide()
	
SVMenuBarAnchor:SetScript("OnEnter",function()
	if SVLock.menubar==true then
		if not SVMenuBar:IsShown() then
			SVMenuBar.slide_out:Stop()
			SVMenuBar:Show()
			SVMenuBar.slide:Play()
		end
	else
		if SVMenuBarAnchorMentalo:IsShown() then
			SVMenuBarAnchorBack:SetBackdropColor(0.5,0.8,1,0.5)
			UIFrameFadeIn(SVMenuBarAnchorMentalo, 0.3, 0, 1)
			SVMod.MentaloPEWPEW()
		end
	end
end)

SVMenuBarAnchor:SetScript("OnLeave",function()
	if SVLock.menubar==true then
		if SVMenuBar:IsShown() then
			SVMenuBar.slide:Stop()
			SVMenuBar.slide_out:Play()
		end
	else
		if SVMenuBarAnchorMentalo:IsShown() then
			SVMenuBarAnchorBack:SetBackdropColor(0.5,0.8,1,0.15)
			UIFrameFadeOut(SVMenuBarAnchorMentalo, 0.3, 1, 0)
			SVMod.MentaloIDLE()
		end
	end
end)

SVMenuBar.slide:SetScript("OnFinished",function() go = true end)
SVMenuBar.slide_out:SetScript("OnPlay",function() go = false end)

--MM BUTTONS------------------------------------------------------------------
for i = 1, 10 do
	local mmBf = CreateFrame("Frame", "MMbuttonFrame"..i, SVMenuBar)
	local mmBf2 = _G["MMbuttonFrame"..i-1]
	mmBf:SetWidth(MMBS)
	mmBf:SetHeight(MMBS)
	SVMod.SimpleSkin(mmBf,3)
	if i==1 then
		mmBf:SetPoint("TOPLEFT", SVMenuBar, "TOPLEFT")
	else
		mmBf:SetPoint("TOP", mmBf2, "BOTTOM", 0, MMSP)
	end
	local mB = CreateFrame("Frame", "MButton"..i, mmBf)
	mB:SetPoint("TOPLEFT")
	mB:SetPoint("BOTTOMRIGHT")
	scRn = mmBf:CreateTexture("Screen"..i, "ARTWORK")
	scRn:SetPoint("TOPLEFT",mmBf,"TOPLEFT", SVMod.Scale(2), SVMod.Scale(-2))
	scRn:SetPoint("BOTTOMRIGHT",mmBf,"BOTTOMRIGHT", SVMod.Scale(-2), SVMod.Scale(2))
	scRn:SetParent(mmBf)
	scRn2 = mB:CreateTexture("ScreenAlt"..i, "OVERLAY")
	scRn2:SetPoint("TOPLEFT",mB,"TOPLEFT", SVMod.Scale(2), SVMod.Scale(-2))
	scRn2:SetPoint("BOTTOMRIGHT",mB,"BOTTOMRIGHT", SVMod.Scale(-2), SVMod.Scale(2))
	scRn2:SetVertexColor(1,1,1)
	mB:EnableMouse(true)
	SVAnimate.SetPulse(mB, 0, 1.5)
end

--Now we skin 'em and add toggle functions ----------------------------------
--2----------------------------------------------------------Character Screen 
SVMod.MapDraw(Screen1,"VILLAINS",2)
SVMod.MapDraw(ScreenAlt1,"VILLAINS2",2)
Screen1:SetVertexColor(r2, g2, b2)
ScreenAlt1:SetAlpha(0)
MButton1:HookScript("OnEnter", function(self) Screen1:SetVertexColor(r, g, b)
	ScreenAlt1:SetAlpha(0.8)
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(BINDING_NAME_TOGGLECHARACTER0) 
end)
MButton1:HookScript("OnLeave", function(self) Screen1:SetVertexColor(r2, g2, b2); ScreenAlt1:SetAlpha(0); GameTooltip:Hide() end)
MButton1:SetScript("OnMouseUp", function() MButton1.pulse:Play(); ToggleCharacter("PaperDollFrame") end)
--8--------------------------------------------------------------Talent Screen
SVMod.MapDraw(Screen2,"VILLAINS",8)
SVMod.MapDraw(ScreenAlt2,"VILLAINS2",8)
Screen2:SetVertexColor(r2, g2, b2)
ScreenAlt2:SetAlpha(0)
MButton2:HookScript("OnEnter", function(self) Screen2:SetVertexColor(r, g, b) 
	ScreenAlt2:SetAlpha(0.8)
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(BINDING_NAME_TOGGLETALENTS) 
end)
MButton2:HookScript("OnLeave", function(self) Screen2:SetVertexColor(r2, g2, b2); ScreenAlt2:SetAlpha(0); GameTooltip:Hide() end)
MButton2:SetScript("OnMouseUp", function() MButton2.pulse:Play(); if not PlayerTalentFrame then LoadAddOn("Blizzard_TalentUI") end; if not GlyphFrame then LoadAddOn("Blizzard_GlyphUI") end; PlayerTalentFrame_Toggle() end)
--9-----------------------------------------------------------------Spell Book
SVMod.MapDraw(Screen3,"VILLAINS",9)
SVMod.MapDraw(ScreenAlt3,"VILLAINS2",9)
Screen3:SetVertexColor(r2, g2, b2)
ScreenAlt3:SetAlpha(0)
MButton3:HookScript("OnEnter", function(self) Screen3:SetVertexColor(r, g, b)
	ScreenAlt3:SetAlpha(0.8)
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(BINDING_NAME_TOGGLESPELLBOOK) 
end)
MButton3:HookScript("OnLeave", function(self) Screen3:SetVertexColor(r2, g2, b2); ScreenAlt3:SetAlpha(0); GameTooltip:Hide() end)
MButton3:SetScript("OnMouseUp", function() MButton3.pulse:Play(); ToggleSpellBook("spell") end)
--1---------------------------------------------------------------Achievements
SVMod.MapDraw(Screen4,"VILLAINS",1)
SVMod.MapDraw(ScreenAlt4,"VILLAINS2",1)
Screen4:SetVertexColor(r2, g2, b2)
ScreenAlt4:SetAlpha(0)
MButton4:HookScript("OnEnter", function(self) Screen4:SetVertexColor(r, g, b)
	ScreenAlt4:SetAlpha(0.8)
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(BINDING_NAME_TOGGLEACHIEVEMENT) 
end)
MButton4:HookScript("OnLeave", function(self) Screen4:SetVertexColor(r2, g2, b2); ScreenAlt4:SetAlpha(0); GameTooltip:Hide() end)
MButton4:SetScript("OnMouseUp", function() MButton4.pulse:Play(); ToggleAchievementFrame() end)
--7------------------------------------------------------------------Quest Log
SVMod.MapDraw(Screen5,"VILLAINS",7)
SVMod.MapDraw(ScreenAlt5,"VILLAINS2",7)
Screen5:SetVertexColor(r2, g2, b2)
ScreenAlt5:SetAlpha(0)
MButton5:HookScript("OnEnter", function(self) Screen5:SetVertexColor(r, g, b)
	ScreenAlt5:SetAlpha(0.8)
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(BINDING_NAME_TOGGLEQUESTLOG) 
end)
MButton5:HookScript("OnLeave", function(self) Screen5:SetVertexColor(r2, g2, b2); ScreenAlt5:SetAlpha(0); GameTooltip:Hide() end)
MButton5:SetScript("OnMouseUp", function() MButton5.pulse:Play(); ToggleFrame(QuestLogFrame) end)
--5--------------------------------------------------------------Social Screen
SVMod.MapDraw(Screen6,"VILLAINS",5)
SVMod.MapDraw(ScreenAlt6,"VILLAINS2",5)
Screen6:SetVertexColor(r2, g2, b2)
ScreenAlt6:SetAlpha(0)
MButton6:HookScript("OnEnter", function(self) Screen6:SetVertexColor(r, g, b)
	ScreenAlt6:SetAlpha(0.8)
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(BINDING_NAME_TOGGLEFRIENDSTAB) 
end)
MButton6:HookScript("OnLeave", function(self) Screen6:SetVertexColor(r2, g2, b2); ScreenAlt6:SetAlpha(0); GameTooltip:Hide() end)
MButton6:SetScript("OnMouseUp", function() MButton6.pulse:Play(); ToggleFriendsFrame(1) end)
--10------------------------------------------------------------PVP  ??????????
SVMod.MapDraw(Screen7,"VILLAINS",10)
SVMod.MapDraw(ScreenAlt7,"VILLAINS2",10)
Screen7:SetVertexColor(r2, g2, b2)
ScreenAlt7:SetAlpha(0)
MButton7:HookScript("OnEnter", function(self) Screen7:SetVertexColor(r, g, b)
	ScreenAlt7:SetAlpha(0.8)
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(BINDING_NAME_TOGGLEPVP) 
end)
MButton7:HookScript("OnLeave", function(self) Screen7:SetVertexColor(r2, g2, b2); ScreenAlt7:SetAlpha(0); GameTooltip:Hide() end)
MButton7:SetScript("OnMouseUp", function() MButton7.pulse:Play(); TogglePVPFrame() end)
--15------------------------------------------------------------------------LFD
SVMod.MapDraw(Screen8,"VILLAINS",15)
SVMod.MapDraw(ScreenAlt8,"VILLAINS2",15)
Screen8:SetVertexColor(r2, g2, b2)
ScreenAlt8:SetAlpha(0)
MButton8:HookScript("OnEnter", function(self) Screen8:SetVertexColor(r, g, b)
	ScreenAlt8:SetAlpha(0.8)
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(BINDING_NAME_TOGGLELFGPARENT) 
end)
MButton8:HookScript("OnLeave", function(self) Screen8:SetVertexColor(r2, g2, b2); ScreenAlt8:SetAlpha(0); GameTooltip:Hide() end)
MButton8:SetScript("OnMouseUp", function() MButton8.pulse:Play(); ToggleFrame(LFDParentFrame) end)
--14-----------------------------------------------------------------------LFR
SVMod.MapDraw(Screen9,"VILLAINS",14)
SVMod.MapDraw(ScreenAlt9,"VILLAINS2",14)
Screen9:SetVertexColor(r2, g2, b2)
ScreenAlt9:SetAlpha(0)
MButton9:HookScript("OnEnter", function(self) Screen9:SetVertexColor(r, g, b)
	ScreenAlt9:SetAlpha(0.8)
	GameTooltip:SetOwner( UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(BINDING_NAME_TOGGLELFRPARENT) 
end)
MButton9:HookScript("OnLeave", function(self) Screen9:SetVertexColor(r2, g2, b2); ScreenAlt9:SetAlpha(0); GameTooltip:Hide() end)
MButton9:SetScript("OnMouseUp", function() MButton9.pulse:Play(); ToggleFrame(LFRParentFrame) end)
--4----------------------------------------------------------------------HELP
SVMod.MapDraw(Screen10,"VILLAINS",4)
SVMod.MapDraw(ScreenAlt10,"VILLAINS2",4)
Screen10:SetVertexColor(r2, g2, b2)
ScreenAlt10:SetAlpha(0)
MButton10:HookScript("OnEnter", function(self) Screen10:SetVertexColor(r, g, b)
	ScreenAlt10:SetAlpha(0.8)
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:ClearLines()
	GameTooltip:SetText(HELP_BUTTON) 
end)
MButton10:HookScript("OnLeave", function(self) Screen10:SetVertexColor(r2, g2, b2); ScreenAlt10:SetAlpha(0); GameTooltip:Hide() end)
MButton10:SetScript("OnMouseUp", function() MButton10.pulse:Play(); ToggleHelpFrame() end)
---------------------------------------------------------------------------------------------------------TAA DAA *FLEX*---------------
		
local function MOVESVMM()
	if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
	if SVLock.menubar == true then
		SVLock.menubar = false
		SVMenuBarAnchorMentalo:Show()
		UIFrameFadeIn(SVMenuBarAnchorBack, 0.5, 0, 1)
		print(LEVEL_UP_FEATURE)
		SVMenuBarAnchor:SetFrameStrata("DIALOG")
		SVMenuBarAnchor:EnableMouse(true);
		SVMenuBarAnchor:RegisterForDrag("LeftButton"); 
		SVMenuBarAnchor:SetScript("OnDragStart", SVMenuBarAnchor.StartMoving); 
		SVMenuBarAnchor:SetScript("OnDragStop", SVMenuBarAnchor.StopMovingOrSizing);
	elseif SVLock.menubar == false then
		SVMenuBarAnchor:SetFrameStrata("BACKGROUND")
		SVMenuBarAnchor:EnableMouse(false);
		SVLock.menubar = true
		SVMenuBarAnchorMentalo:Hide()
		UIFrameFadeOut(SVMenuBarAnchorBack, 0.5, 1, 0)
		SVMenuBar:ClearAllPoints()
		SVMenuBar:SetPoint("TOP",SVMenuBarAnchor,"TOP")
		mmX = (SVMenuBarAnchor:GetRight() + (menuW*2))
		mmY = (SVMenuBarAnchor:GetBottom() + (menuH*2))
		slider(SVMenuBar,true,mmX,-mmY)
		SVMenuBarAnchor:SetScript("OnEnter",function()
			if SVLock.menubar==true then
				if not SVMenuBar:IsShown() then
					SVMenuBar.slide_out:Stop()
					SVMenuBar:Show()
					SVMenuBar.slide:Play()
				end
			else
				if SVMenuBarAnchorMentalo:IsShown() then
					UIFrameFadeIn(SVMenuBarAnchorMentalo, 0.3, 0, 1)
				end
			end
		end)
		
		SVMenuBarAnchor:SetScript("OnLeave",function()
			if SVLock.menubar==true then
				if SVMenuBar:IsShown() then
					SVMenuBar.slide:Stop()
					SVMenuBar.slide_out:Play()
				end
			else
				if SVMenuBarAnchorMentalo:IsShown() then
					UIFrameFadeOut(SVMenuBarAnchorMentalo, 0.3, 1, 0)
				end
			end
		end)
		print(LOCKED)
	end
end

SLASH_MOVESVMM1 = "/svmovemm"
SlashCmdList["MOVESVMM"] = MOVESVMM

local function RESETSVMM()
	if SVLock.menubar==true and (not SVMenuBar:IsShown()) then
		SVMenuBarAnchor:ClearAllPoints()
		SVMenuBarAnchor:SetPoint("TOPLEFT",UIParent,"TOPLEFT",5,SVMod.Scale(-40))
		SVMenuBar:ClearAllPoints()
		SVMenuBar:SetPoint("TOP",SVMenuBarAnchor,"TOP")
		mmX = (SVMenuBarAnchor:GetRight() + (menuW*2))
		mmY = (SVMenuBarAnchor:GetBottom() + (menuH*2))
		slider(SVMenuBar,true,mmX,-mmY)
		SVMenuBarAnchor:SetScript("OnEnter",function()
			if SVLock.menubar==true then
				if not SVMenuBar:IsShown() then
					SVMenuBar.slide_out:Stop()
					SVMenuBar:Show()
					SVMenuBar.slide:Play()
				end
			end
		end)
	else
		print("MenuBar can't be reset while it is unlocked for moving.")
	end
end

SLASH_RESETSVMM1 = "/rmm"
SlashCmdList["RESETSVMM"] = RESETSVMM