local cColor = SVColors.oUF_colors.class[SVRoot.myclass]
local cr,cg,cb = cColor[1], cColor[2], cColor[3]
local ir,ig,ib
if (SuperSet.colortheme == 3) then
	ir,ig,ib = 1,0.4,0.4
else
	ir,ig,ib = (1-(cr*0.8)),(1-(cg*0.8)),(1-(cb*0.8))
end
local bagskin = [[Interface\Icons\Achievement_BG_most_damage_killingblow_dieleast]]
SVMod.StatBox("SVStatPower",bagskin)

local dd = SVStatPower.bar:CreateFontString (nil,"OVERLAY")
dd:SetFont(SVFonts.super,14,"OUTLINE")
dd:SetJustifyH("LEFT")
dd:SetPoint("LEFT",4,0)
if (SuperSet.colortheme == 3) then
	dd:SetTextColor(1,1,1)
else
	dd:SetTextColor(cr+0.3,cg+0.3,cb+0.3)
end
dd:SetShadowOffset(2,3)
dd:SetShadowColor(0,0,0,0.8)
dd:SetText("0")
PowText = dd
--| Main Idea taken from Tukui\\\\

local int = 1
local spellhaste,rangedhaste,attackhaste,haste
local meleecrit,spellcrit,rangedcrit,CritChance
local hit,mastery
local function Update(self, t)
	if not SVStatPower:IsShown() then return end;
	int = int - t
	---FIND POWER
	local base, posBuff, negBuff = UnitAttackPower("player");
	local effective = base + posBuff + negBuff;
	local Rbase, RposBuff, RnegBuff = UnitRangedAttackPower("player");
	local Reffective = Rbase + RposBuff + RnegBuff;
	
	healpwr = GetSpellBonusHealing()

	Rattackpwr = Reffective
	spellpwr2 = GetSpellBonusDamage(7)
	attackpwr = effective

	if healpwr > spellpwr2 then
		spellpwr = healpwr
	else
		spellpwr = spellpwr2
	end

	if attackpwr > spellpwr and select(2, UnitClass("Player")) ~= "HUNTER" then
		pwr = attackpwr
	elseif select(2, UnitClass("Player")) == "HUNTER" then
		pwr = Reffective
	else
		pwr = spellpwr
	end
	if int < 0 then
		PowText:SetText(pwr)      
		int = 1
	end
	--FIND HASTE
	
	spellhaste = format("%0.2f%%", GetCombatRatingBonus(CR_HASTE_SPELL))
	rangedhaste = format("%0.2f%%", GetCombatRatingBonus(CR_HASTE_RANGED))
	attackhaste = format("%0.2f%%", GetCombatRatingBonus(CR_HASTE_MELEE))
	if attackhaste > spellhaste and select(2, UnitClass("Player")) ~= "HUNTER" then
		haste = format("%d / %.2f%%", GetCombatRating(CR_HASTE_MELEE),GetCombatRatingBonus(CR_HASTE_MELEE));
		CritChance = format("%d / %.2f%%", GetCombatRating(CR_CRIT_MELEE),GetCritChance());
		hit = format("%d / %.2f%%", GetCombatRating(CR_HIT_MELEE),GetCombatRatingBonus(CR_HIT_MELEE));
	elseif select(2, UnitClass("Player")) == "HUNTER" then
		haste = format("%d / %.2f%%", GetCombatRating(CR_HASTE_RANGED),GetCombatRatingBonus(CR_HASTE_RANGED));
		CritChance = format("%d / %.2f%%", GetCombatRating(CR_CRIT_RANGED),GetRangedCritChance());
		hit = format("%d / %.2f%%", GetCombatRating(CR_HIT_RANGED),GetCombatRatingBonus(CR_HIT_RANGED));
	else
		haste = format("%d / %.2f%%", GetCombatRating(CR_HASTE_SPELL),GetCombatRatingBonus(CR_HASTE_SPELL));
		CritChance = format("%d / %.2f%%", GetCombatRating(CR_CRIT_SPELL),GetSpellCritChance(1));
		hit = format("%d / %.2f%%", GetCombatRating(CR_HIT_SPELL),GetCombatRatingBonus(CR_HIT_SPELL));
	end

	mastery = format("%0.2f", GetMastery())
end
SVStatPower:SetScript("OnEnter", function(self)
	if not InCombatLockdown() then
		self.hovered = true 
		GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, SVMod.Scale(6));
		GameTooltip:ClearAllPoints()
		GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, SVMod.mult)
		GameTooltip:ClearLines()
		GameTooltip:AddLine(SVLocal.datatext_stats)
		GameTooltip:AddDoubleLine(ITEM_MOD_MASTERY_RATING_SHORT..": ", mastery, 0.2, 0.8, 1, 0.5, 1, 0.5)
		GameTooltip:AddDoubleLine(SPELL_HASTE.." / "..SPELL_HASTE_ABBR..": ", haste, 0.2, 0.8, 1, 0.5, 1, 0.5)
		GameTooltip:AddDoubleLine(COMBAT_RATING_NAME10.." / "..CRIT_ABBR..": ", CritChance, 0.2, 0.8, 1, 0.5, 1, 0.5)
		GameTooltip:AddDoubleLine(COMBAT_RATING_NAME6.." / "..STAT_HIT_CHANCE..": ", hit, 0.2, 0.8, 1, 0.5, 1, 0.5)
		GameTooltip:Show()
	end
end)
SVStatPower:SetScript("OnLeave", function() GameTooltip:Hide() end)	
SVStatPower:SetScript("OnUpdate", Update)
Update(SVStatPower, 10)
SVStatPower:Hide()
SVStat.make("SVStatPower",POWER_ABBR,9)