﻿if not(IsAddOnLoaded("Omen")) then return end
local Omen = LibStub("AceAddon-3.0"):GetAddon("Omen")
if not Omen then return end

--Skin Title/Bars backgrounds
Omen.UpdateBackdrop_ = Omen.UpdateBackdrop
Omen.UpdateBackdrop = function(self)
    self:UpdateBackdrop_()
	local ombg = CreateFrame("Frame",nil,self.BarList)
	ombg:SetPoint("TOPLEFT",self.Title,-8,8)
	ombg:SetPoint("BOTTOMRIGHT",self.BarList,8,-8)
	ombg:SetFrameStrata("BACKGROUND")
	SAIAurora.SuperSkin(ombg)
end
-- Skin Bar Texture
Omen.UpdateBarTextureSettings_ = Omen.UpdateBarTextureSettings
Omen.UpdateBarTextureSettings = function(self)
    for i, v in ipairs(self.Bars) do
        v.texture:SetTexture(SAIAurora.bar)
    end
end
-- Skin Bar fonts
--[[
Omen.UpdateBarLabelSettings_ = Omen.UpdateBarLabelSettings
Omen.UpdateBarLabelSettings = function(self)
    self:UpdateBarLabelSettings_()
    for i, v in ipairs(self.Bars) do
        v.Text1:SetFont(SVFonts.font,self.db.profile.Bar.FontSize)
        v.Text2:SetFont(SVFonts.font,self.db.profile.Bar.FontSize)
        v.Text3:SetFont(SVFonts.font,self.db.profile.Bar.FontSize)
    end
end
]]--
-- Hook bar creation to apply settings
local meta = getmetatable(Omen.Bars)
local oldidx = meta.__index
meta.__index = function(self, barID)
    local bar = oldidx(self, barID)
    Omen:UpdateBarTextureSettings()
    Omen:UpdateBarLabelSettings()
	return bar
end
-- Option Overrides
--Omen.db.profile.Scale = 1
Omen.db.profile.Background.EdgeSize = 1
Omen.db.profile.Background.BarInset = 2
Omen.db.profile.Background.Color.a = 0
Omen.db.profile.TitleBar.FontSize = 16
Omen.db.profile.TitleBar.Height = 20
Omen.db.profile.Bar.Spacing = 1
Omen.db.profile.TitleBar.UseSameBG = true
-- Force updates
Omen:UpdateBarTextureSettings()
Omen:UpdateBarLabelSettings()
Omen:UpdateTitleBar()
Omen:UpdateBackdrop()
Omen:ReAnchorBars()
Omen:ResizeBars()