﻿local MungComicsFrame = CreateFrame("Frame")
MungComicsFrame:RegisterEvent("PLAYER_LOGIN")
----locals----
local premium1 = {}
local premium2 = {}
local delux = {}
local basix = {}
local CanPlayAnimation=true;

function AllAnimationEnd(self, requested)
	CanPlayAnimation=true;
end

local function basic_Panels()
	local basicPanel = CreateFrame("Frame","SVBasicComic",UIParent)
	SVComics.CreatePanel(basicPanel, 100, 100, "CENTER", UIParent, "CENTER", 0, -150)
	basicTex = basicPanel:CreateTexture(nil, "ARTWORK")
	basicTex:SetAllPoints(basicPanel)
	SVComics.SetTrans(SVBasicComic, 1, 1, 0.1)
	basicPanel:SetAlpha(0)
	SVBasicComic.trans[3]:SetScript("OnFinished",AllAnimationEnd)
end

local function deluxe_Panels()
	local deluxePanel = CreateFrame("Frame","SVDeluxeComic",UIParent)
	SVComics.CreatePanel(deluxePanel, 100, 100, "CENTER", UIParent, "CENTER", 0, -150)
	deluxeTex = deluxePanel:CreateTexture(nil, "ARTWORK")
	deluxeTex:SetAllPoints(deluxePanel)
	SVComics.SetTrans(SVDeluxeComic, 1, 1, 0.1)
	deluxePanel:SetAlpha(0)
	SVDeluxeComic.trans[3]:SetScript("OnFinished",AllAnimationEnd)
end

local function premium_Panels()
	local premiumPanel = CreateFrame("Frame","SVPremiumComic",UIParent)
	SVComics.CreatePanel(premiumPanel, 100, 100, "CENTER", UIParent, "CENTER", 0, -150)
	premiumTex = premiumPanel:CreateTexture(nil, "ARTWORK")
	premiumTex:SetAllPoints(premiumPanel)
	SVComics.SetTrans(SVPremiumComic, 1, 1, 0.1, 1)
	premiumPanel:SetAlpha(0)
	local premiumPanelBG = CreateFrame("Frame","SVPremiumComicBG",UIParent)
	SVComics.CreatePanel(premiumPanelBG, 128, 128, "CENTER", UIParent, "CENTER", 0, -150)
	premiumPanelBGTex = premiumPanelBG:CreateTexture(nil, "ARTWORK")
	premiumPanelBGTex:SetAllPoints(premiumPanelBG)
	SVComics.SetTrans(SVPremiumComicBG, 1, 0, 0.1, 1)
	premiumPanelBG:SetAlpha(0)
	SVPremiumComic.trans[3]:SetScript("OnFinished",AllAnimationEnd)
end

local function basic_Skinner()
	if (MungComix.Basic["TEX"]) then
		for key, value in pairs(MungComix.Basic["TEX"]) do
			tinsert(basix, value)
		end
	end
	basic_Panels()
end

local function deluxe_Skinner()
	if (MungComix.Deluxe["TEX"]) then
		for key, value in pairs(MungComix.Deluxe["TEX"]) do
			tinsert(delux, value)
		end
	end
	deluxe_Panels()
end

local function premium_Skinner()
	if (MungComix.Premium["TEX"]) then
		for key, value in pairs(MungComix.Premium["TEX"]) do
			tinsert(premium1, value)
		end
	end
	if (MungComix.Premium["BOX"]) then
		for key, value in pairs(MungComix.Premium["BOX"]) do
			tinsert(premium2, value)
		end
	end
	premium_Panels()
end

function MungComics_Slide(frame1, frame2)
    frame1.trans:Play()
	if (frame2) then
		frame2.trans:Play()
	end
end

function MungComics_Fling(group)
	local show, show2, bank, bank2, skin, skin2, x1, x2, y1, y2, x1b, x2b, y1b, y2b
	if (group == "PREMIUM") then
		show = random(1,15)
		bank, bank2 = premium1[show], premium2[show]
		skin, skin2 = bank[1], bank2[1]
		x1, x2, y1, y2, x1b, x2b, y1b, y2b = bank[2], bank[4], bank[3], bank[5], bank2[2], bank2[4], bank2[3], bank2[5]
		premiumTex:SetTexture(skin)
		premiumPanelBGTex:SetTexture(skin2)
		SVPremiumComic.trans[1]:SetOffset(x1,y1)
		SVPremiumComic.trans[2]:SetOffset(x2,y2)
		SVPremiumComic.trans[3]:SetOffset(0,0)
		SVPremiumComicBG.trans[1]:SetOffset(x1b,y1b)
		SVPremiumComicBG.trans[2]:SetOffset(x2b,y2b)
		SVPremiumComicBG.trans[3]:SetOffset(0,0)
		MungComics_Slide(SVPremiumComic, SVPremiumComicBG)
	elseif (group == "DELUXE") then
		show = random(1,10)
		bank = delux[show]
		skin = bank[1]
		x1 = random(-280,bank[2])
		if (x1 > -30) and (x1 < 30) then
			x1 = 150
		end
		x2 = x1*0.1
		y1 = random(10,bank[3])
		y2 = y1*0.1
		deluxeTex:SetTexture(skin)
		SVDeluxeComic.trans[1]:SetOffset(x1,y1)
		SVDeluxeComic.trans[2]:SetOffset(x2,y2)
		SVDeluxeComic.trans[3]:SetOffset(0,0)
		MungComics_Slide(SVDeluxeComic)
	else
		show = random(1,28)
		bank = basix[show]
		skin = bank[1]
		x1 = random(-200,bank[2])
		if (x1 > -30) and (x1 < 30) then
			x1 = 150
		end
		x2 = x1*0.1
		y1 = random(100,200)
		y2 = y1*0.1
		basicTex:SetTexture(skin)
		SVBasicComic.trans[1]:SetOffset(x1,y1)
		SVBasicComic.trans[2]:SetOffset(x2,y2)
		SVBasicComic.trans[3]:SetOffset(0,0)
		MungComics_Slide(SVBasicComic)
	end
end

------------------------------
local function SetUpTracker()
	tracker = CreateFrame("Frame")
	tracker:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	tracker:SetScript("OnEvent", function(_, _, _, event, guid)
			if event == "PARTY_KILL" and guid==playerid then
				CanPlayAnimation=false
				local picker = random(1,3)
				if (picker == 1) then
					MungComics_Fling("BASIC")
				elseif (picker == 2) then
					MungComics_Fling("DELUXE")
				else
					MungComics_Fling("PREMIUM")
				end
			end
	end)
end

MungComicsFrame:SetScript("OnEvent", function(self, event, ...)
		if event == "PLAYER_LOGIN" then
				playerid = UnitGUID("player")
				basic_Skinner()
				deluxe_Skinner()
				premium_Skinner()
				CanPlayAnimation=true
				SetUpTracker()
		end
end)

local function SVCOMIC()
	MungComics_Fling("PREMIUM")
end
SLASH_SVCOMIC1 = "/svcomic"
SlashCmdList["SVCOMIC"] = SVCOMIC