﻿SVComics.CreatePanel = function(f, w, h, a1, p, a2, x, y)
	f:SetHeight(h)
	f:SetWidth(w)
	f:SetFrameStrata("BACKGROUND")
	f:SetPoint(a1, p, a2, x, y)
end

SVComics.SetTrans = function(f, tranScale, layer, durone, durtwo)
	local layer = layer or 1
	local tranScale = tranScale or 1
	local durone = durone or 0.2
	local durtwo = durtwo or 1
	if layer == 1 then
		f:SetFrameLevel(30)
	else
		f:SetFrameLevel(20)
	end
	f:SetPoint("CENTER",UIParent,0,-150)
	f.trans = f:CreateAnimationGroup()
	f.trans[1] = f.trans:CreateAnimation("Translation")
	f.trans[1]:SetOrder(1)
	f.trans[1]:SetDuration(durone)
	f.trans[1]:SetScript("OnUpdate", function(self)
		f:SetScale(1 + (tranScale * f.trans[1]:GetProgress()))
	end)
	
	f.trans[2] = f.trans:CreateAnimation("Translation")
	f.trans[2]:SetOrder(2)
	f.trans[2]:SetDuration(durtwo)
	
	f.trans[3] = f.trans:CreateAnimation("Translation")
	f.trans[3]:SetOrder(3)
	f.trans[3]:SetDuration(0.3)
	
	f.trans[1]:SetScript("OnPlay", function()
		f:SetScale(0.01)
		f:SetAlpha(1)
	end)
	f.trans[3]:SetScript("OnPlay", function()
		UIFrameFadeOut(f, 0.3, 1, 0)
	end)
	f.trans[3]:SetScript("OnStop", function()
		f:SetAlpha(0)
	end)
	f.trans:SetScript("OnFinished", f.trans[3]:GetScript("OnStop"))
end